<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 1.3
 * @author davidhs
 * @copyright 2014-2015 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Adds things on load theme.
function cffp_load_theme()
{
	global $context, $settings, $db_prefix, $sourcedir;

	require_once ($sourcedir . '/Subs-CustomFieldFilterPost.php');
	require_once ($sourcedir . '/Subs-Db-CustomFieldFilterPost-mysql.php');

	// Columns of tables.
	$context['cffp']['list_columns'] = array(
		'settings_groups' => cffp_db_list_columns('cffp_settings_groups'),
		'settings_fields' => cffp_db_list_columns('cffp_settings_fields'),
		'count_groups' => cffp_db_list_columns('cffp_count_groups'),
		'fields' => cffp_db_list_columns('cffp_fields'),
		'stats' => cffp_db_list_columns('cffp_stats'),
	);

	// Settings of active groups and fields.
	$context['cffp']['settings_groups'] = array();

	$request = db_query("
		SELECT " . implode(', ', $context['cffp']['list_columns']['settings_groups']) . "
		FROM {$db_prefix}cffp_settings_groups
		WHERE active = 1
		ORDER BY group_order ASC", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		$context['cffp']['settings_groups'][$row['ID_GROUP']] = $row;
		$context['cffp']['settings_groups'][$row['ID_GROUP']]['settings_fields'] = array();
	}
	mysql_free_result($request);

	$context['cffp']['settings_vars'] = array();
	if (!empty($context['cffp']['settings_groups']))
	{
		$request = db_query("
			SELECT " . implode(', ', $context['cffp']['list_columns']['settings_fields']) . "
			FROM {$db_prefix}cffp_settings_fields
			WHERE ID_GROUP IN (" . implode(', ', array_keys($context['cffp']['settings_groups'])) . ")
				AND active = 1
			ORDER BY field_order ASC", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			$context['cffp']['settings_vars']['{FIELD_' . $row['ID_FIELD'] . '_DATABASE}'] = 'column_' . $row['id_column'];
			$context['cffp']['settings_groups'][$row['ID_GROUP']]['settings_fields'][$row['ID_FIELD']] = $row;
		}
		mysql_free_result($request);
	}

	// Cache of values in options of combobox buttons or values used of select or combobox buttons.
	$context['cffp']['options_combobox'] = array();
	$context['cffp']['options_used'] = array();

	// Cache of values of fields.
	$context['cffp']['fields_value'] = array();

	// Cache of data of message and topic.
	$context['cffp']['data_msg_topic'] = array(
		'topic_new' => array(
			'sticky' => null,
			'locked' => null,
			'id_msg' => 0,
			'first_msg' => 1,
			'subject' => '',
		),
	);

	// Search pages.
	cffpGetSearchPages();

	// Lists of moderation.
	$context['cffp']['moderation_list'] = array();
	foreach ($context['cffp']['settings_groups'] as $id_group => $settings_group)
	{
		if (!$settings_group['moderation_list_show'])
			continue;

		$context['cffp']['moderation_list'][$id_group] = cffpIsNotEmptyString($settings_group['moderation_list_name']) ? $settings_group['moderation_list_name'] : $settings_group['name'];
	}

	// HTML headers.
	$context['html_headers'] .= '
	<script language="JavaScript" type="text/javascript" src="' . $settings['default_theme_url'] . '/CustomFieldFilterPost.js?fin11"></script>';
}

?>