<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 1.3
 * @author davidhs
 * @copyright 2014-2015 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Adds things on load theme.
function cffp_load_theme()
{
	global $context, $settings, $smcFunc;

	db_extend('packages');

	// Columns of tables.
	$context['cffp']['list_columns'] = array(
		'settings_groups' => $smcFunc['db_list_columns']('{db_prefix}cffp_settings_groups'),
		'settings_fields' => $smcFunc['db_list_columns']('{db_prefix}cffp_settings_fields'),
		'count_groups' => $smcFunc['db_list_columns']('{db_prefix}cffp_count_groups'),
		'fields' => $smcFunc['db_list_columns']('{db_prefix}cffp_fields'),
		'stats' => $smcFunc['db_list_columns']('{db_prefix}cffp_stats'),
	);

	// Settings of active groups and fields.
	$context['cffp']['settings_groups'] = array();

	$request = $smcFunc['db_query']('', '
		SELECT ' . implode(', ', $context['cffp']['list_columns']['settings_groups']) . '
		FROM {db_prefix}cffp_settings_groups
		WHERE active = {int:active}
		ORDER BY group_order ASC',
		array(
			'active' => 1,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['cffp']['settings_groups'][$row['id_group']] = $row;
		$context['cffp']['settings_groups'][$row['id_group']]['settings_fields'] = array();
	}
	$smcFunc['db_free_result']($request);

	$context['cffp']['settings_vars'] = array();
	if (!empty($context['cffp']['settings_groups']))
	{
		$request = $smcFunc['db_query']('', '
			SELECT ' . implode(', ', $context['cffp']['list_columns']['settings_fields']) . '
			FROM {db_prefix}cffp_settings_fields
			WHERE id_group IN ({array_int:id_group})
				AND active = {int:active}
			ORDER BY field_order ASC',
			array(
				'id_group' => array_keys($context['cffp']['settings_groups']),
				'active' => 1,
			)
		);
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$context['cffp']['settings_vars']['{FIELD_' . $row['id_field'] . '_DATABASE}'] = 'column_' . $row['id_column'];
			$context['cffp']['settings_groups'][$row['id_group']]['settings_fields'][$row['id_field']] = $row;
		}
		$smcFunc['db_free_result']($request);
	}

	// Cache of values in options of combobox buttons or values used of select or combobox buttons.
	$context['cffp']['options_combobox'] = array();
	$context['cffp']['options_used'] = array();

	// Cache of values of fields.
	$context['cffp']['fields_value'] = array();

	// Cache of data of message and topic.
	$context['cffp']['data_msg_topic'] = array(
		'topic_new' => array(
			'sticky' => null,
			'locked' => null,
			'id_msg' => 0,
			'first_msg' => 1,
			'subject' => '',
		),
	);

	// Search pages.
	cffpGetSearchPages();

	// Lists of Moderation Center.
	$context['cffp']['moderation_list'] = array();
	foreach ($context['cffp']['settings_groups'] as $id_group => $settings_group)
	{
		if (!$settings_group['moderation_list_show'])
			continue;

		$context['cffp']['moderation_list'][$id_group] = array(
			'name' => cffpIsNotEmptyString($settings_group['moderation_list_name']) ? $settings_group['moderation_list_name'] : $settings_group['name'],
			'menu' => $settings_group['moderation_list_menu'],
		);
	}

	// HTML headers.
	$context['html_headers'] .= '
	<script type="text/javascript" src="' . $settings['default_theme_url'] . '/scripts/CustomFieldFilterPost.js?fin20"></script>';
}

?>