<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 1.5
 * @author davidhs
 * @copyright 2014-2017 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

// Template for edit custom post fields of a group.
function template_cffp_edit_group()
{
	global $context, $txt, $modSettings, $scripturl, $settings;

	$js = $context['params']['group']['javascript'];
	echo '
	<form action="', $scripturl, '?action=cffpeditgroup;start=', $context['start'], ';id_cffp=', $context['id_cffp'], ';id_msg=', $context['id_msg'], ';id_group=', $context['id_group'], ';board=', $context['board'], ';', $context['session_var'], '=', $context['session_id'], '" id="cffp_edit_group" method="post" accept-charset="', $context['character_set'], '">
		<div class="cat_bar">
			<h3 class="catbg">
				<span class="ie6_header floatleft">', !empty($settings['use_buttons']) ? '<img src="' . $settings['images_url'] . '/buttons/modify.gif" alt="" class="icon" />' : ' ', $context['page_title'], '</span>
			</h3>
		</div>
		<span class="upperframe"><span></span></span>
		<div class="roundframe"><br class="clear" />
			<div class="cffp_member">';

	if (!empty($context['params']['group']['text_input']))
		echo '
				', $context['params']['group']['text_input'];

	echo '
				<input type="hidden" name="cffp[', $context['id_group'], '][id_cffp]" value="', $context['id_cffp'], '" />
				<input type="hidden" name="cffp[', $context['id_group'], '][name]" value="', $context['params']['group']['name'], '" />
				<input type="hidden" name="cffp[', $context['id_group'], '][set]" value="1" />';

	$subset = '';
	$begin_set = true;
	if ($context['params']['group']['show_fields_name'])
	{
		foreach ($context['params']['group']['settings_fields'] as $id_field => $settings_field)
		{
			template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $context['params']['group']['show_fields_name']);

			$field = $context['params']['field_array'][$id_field];
			echo '
					<dt id="', $field['html']['id2'], '_dt">
						', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
						$field['name'], ':',
						(empty($field['html']['id']) ? '' : '</label>'),
						(!cffpIsNotEmptyString($field['field_desc']) ? '' : '<br />
						<span class="smalltext">' . $field['field_desc'] . '</span>'), '
						<input type="hidden" name="cffp[', $context['id_group'], '][name_fields][', $id_field, ']" value="', $field['name'], '" />
					</dt>
					<dd id="', $field['html']['id2'], '_dd">', (!cffpIsNotEmptyString($field['field_long_desc']) ? '' : '
						' . $field['field_long_desc'] . '<br />'), '
						', $field['html']['html'], '
					</dd>';
			if (!empty($field['html']['js']))
				$js .= '
' . $field['html']['js'];
		}
	}
	else
	{
		foreach ($context['params']['group']['settings_fields'] as $id_field => $settings_field)
		{
			template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $context['params']['group']['show_fields_name']);

			$field = $context['params']['field_array'][$id_field];
			echo '
					<span id="', $field['html']['id2'], '_span">
						<input type="hidden" name="cffp[', $context['id_group'], '][name_fields][', $id_field, ']" value="', $field['name'], '" />
						', $field['html']['html'], '<br />
					</span>';
			if (!empty($field['html']['js']))
				$js .= '
' . $field['html']['js'];
		}
	}
	template_cffp_show_subset_end($subset, $context['params']['group']['show_fields_name']);

	echo '
			</div>
			<div class="righttext">
				<input type="submit" name="save" value="', $txt['save'], '" accesskey="s" class="button_submit" />
			</div>
		<br class="clear" /></div>
		<span class="lowerframe"><span></span></span>
	</form>';

	if (!empty($js))
	{
		echo '
	<script type="text/javascript"><!-- // --><![CDATA[', $js, '
	// ]]></script>';
	}
}

// Template for edit custom post fields of groups type no member.
function template_cffp_edit_groups_post()
{
	global $context, $txt, $modSettings;

	if (!$context['cffp']['post'])
		return;

	$error = array();
	if (isset($context['cffp']['validate']))
	{
		foreach ($context['cffp']['validate'] as $error_code => $v)
		{
			$error_code2 = explode(',', $error_code);
			if (2 == count($error_code2))
				$error[$error_code2[1]]['_name' == substr($error_code2[0], -5) ? 'name' : 'email'] = true;
			else // 3 == count($error_code2).
				$error[$error_code2[2]][$error_code2[1]] = true;
		}
	}

	$js = '';
	foreach ($context['cffp']['post']['group_array'] as $id_group => $group)
	{
		$checkbox_name = 'cffp[' . $id_group . '][set]';

		if (!empty($group['javascript']))
			$js .= '
' . $group['javascript'];

		echo '
					<div class="cffp_post">
						<input type="hidden" name="cffp[', $id_group, '][id_cffp]" value="', $group['id_cffp'], '" />
						<input type="hidden" name="cffp[', $id_group, '][name]" value="', $group['name'], '" />
						<input type="hidden" name="cffp[', $id_group, '][type]" value="', $group['type'], '" />
						<input type="hidden" name="cffp[', $id_group, '][no_show_with_subject_prefix]" value="', $group['no_show_with_subject_prefix'], '" />';

		if ('fields' == $group['type'])
		{
			echo '
						<input type="hidden" name="', $checkbox_name, '" value="1" />';
			if ($group['show_fields_set'])
			{
				echo '
						<fieldset>
							<legend>', $group['name'], '</legend>';
			}
		}
		else // record.
		{
			$checkbox_id = 'cffp_' . $id_group . '_set';
			$div_id = 'cffp_' . $id_group . '_div';
			$readonly = (!$group['id_cffp'] && !$group['can_add']) || ($group['id_cffp'] && !$group['can_remove']);

			if (!empty($group['text_input_before']))
				echo '
						', $group['text_input_before'];

			echo '
						<fieldset>
							<legend>
								<label>
									<input type="checkbox" name="', $checkbox_name, '" id="', $checkbox_id, '" value="1"', $group['set'] ? ' checked="checked"' : '', ' class="input_check" />
									', $group['name'], '
								</label>
							</legend>
							<div id="', $div_id, '">';

			if ($readonly)
			{
				$js .= '
						document.getElementById("' . $checkbox_id . '").onclick = function (event)
						{
							return false;
						}';
			}
			else
			{
				$js .= '
						document.getElementById("' . $checkbox_id . '").onclick = function (event)
						{
							cffpExpandCollapseWithCheckbox(this, "' . $div_id . '");';
				if ('record' == $group['type'])
				{
					$js .= '
							var empty_message = oEditorHandle_' . $context['post_box_name'] . '.bRichTextEnabled ? "<br>" : "";
							if (this.checked && empty_message == oEditorHandle_' . $context['post_box_name'] . '.getText(false))
							{
								oEditorHandle_' . $context['post_box_name'] . '.insertText(".", false, true);
								this.focus();
							}';
				}
				$js .= '
						}
						cffpExpandCollapseWithCheckbox(document.getElementById("' . $checkbox_id . '"), "' . $div_id . '");';
			}
		}

		if (!empty($group['text_input']))
			echo '
								', $group['text_input'];

		if ($group['can_modify_fields'])
		{
			if (!empty($group['no_show_with_subject_prefix']))
			{
				$prefix = '"' . strtr($group['no_show_with_subject_prefix'], array(',' => '", "')) . '"';
				echo '
								<p>', sprintf($txt['cffp_warning_group_subject'], $prefix), '</p>';
			}

			// Guests have to put in their name and email...
			$put_guest_data = !empty($context['cffp']['post']['id_msg']) && !$group['id_cffp'] && $context['user']['is_guest'];
			if ($put_guest_data)
			{
				echo '
								<dl class="cffp_data">
									<dt>
										<label for="cffp_', $id_group, '_guest_name">',
											(!isset($error[$id_group]['name']) ? '' : '<span class="error">'),
											$txt['name'], ':',
											(!isset($error[$id_group]['name']) ? '' : '</span>'),
										'</label>
									</dt>
									<dd>
										<input type="text" name="cffp[', $id_group, '][guest_name]" id="cffp_', $id_group, '_guest_name" size="25" value="', $group['guest_name'], '" class="input_text" />
									</dd>';

				if (empty($modSettings['guest_post_no_email']))
				{
					echo '
									<dt>
										<label for="cffp_', $id_group, '_guest_email">',
											(!isset($error[$id_group]['email']) ? '' : '<span class="error">'),
											$txt['email'], ':',
											(!isset($error[$id_group]['email']) ? '' : '</span>'),
										'</label>
									</dt>
									<dd>
										<input type="text" name="cffp[', $id_group, '][guest_email]" id="cffp_', $id_group, '_guest_email" size="25" value="', $group['guest_email'], '" class="input_text" />
									</dd>';
				}
			}

			$subset = '';
			if ($group['show_fields_name'])
			{
				$begin_set = !$put_guest_data;
				foreach ($group['settings_fields'] as $id_field => $settings_field)
				{
					template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

					$field = $context['cffp']['post']['field_array'][$id_group][$id_field];
					echo '
									<dt id="', $field['html']['id2'], '_dt">
										', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
										(!isset($error[$id_group][$id_field]) ? '' : '<span class="error">'),
										$field['name'], ':',
										(!isset($error[$id_group][$id_field]) ? '' : '</span>'),
										(empty($field['html']['id']) ? '' : '</label>'),
										(!cffpIsNotEmptyString($field['field_desc']) ? '' : '<br />
										<span class="smalltext">' . $field['field_desc'] . '</span>'), '
										<input type="hidden" name="cffp[', $id_group, '][name_fields][', $id_field, ']" value="', $field['name'], '" />
									</dt>
									<dd id="', $field['html']['id2'], '_dd">', (!cffpIsNotEmptyString($field['field_long_desc']) ? '' : '
										' . $field['field_long_desc'] . '<br />'), '
										', $field['html']['html'], '
									</dd>';
					if (!empty($field['html']['js']))
						$js .= '
' . $field['html']['js'];
				}
			}
			else
			{
				if ($put_guest_data)
					echo '
								</dl>';

				$begin_set = true;
				foreach ($group['settings_fields'] as $id_field => $settings_field)
				{
					template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

					$field = $context['cffp']['post']['field_array'][$id_group][$id_field];
					echo '
									<span id="', $field['html']['id2'], '_span">', (!isset($error[$id_group][$id_field]) ? '' : '
										<span class="error">*</span>'), '
										<input type="hidden" name="cffp[', $id_group, '][name_fields][', $id_field, ']" value="', $field['name'], '" />
										', $field['html']['html'], '<br />
									</span>';
					if (!empty($field['html']['js']))
						$js .= '
' . $field['html']['js'];
				}
			}
			template_cffp_show_subset_end($subset, $group['show_fields_name']);

			if ('record' == $group['type'] && (!$group['id_cffp'] || $group['template_quick_input_show_modify']) && !empty($group['template_quick_input_regex']))
			{
				echo '
								<label for="cffp_', $id_group, '_quick_input_field">', $txt['cffp_quick_input_field'], '</label><br />';

				if (!empty($group['template_quick_input_help']))
					echo '
								', $group['template_quick_input_help'];

				echo '<br />
								<textarea name="cffp_', $id_group, '_quick_input_field" id="cffp_', $id_group, '_quick_input_field" rows="10" cols="100" style="width: 100%; max-width: 100%; min-width: 100%;"></textarea>
								<div class="righttext">
									[ <a href="#" onclick="cffpApplyQuickInputFieldGroup', $id_group, '(); return false;">', $txt['cffp_quick_input_apply'], '</a> ]
								</div>';

				$params = explode("\n", $group['template_quick_input_params']);
				foreach ($params as $k => $param)
				{
					if (is_numeric($param))
						$params[$k] = isset($group['settings_fields'][$param]) ? $param : 0;
					else
						$params[$k] = '"' . addslashes($param) . '"';
				}
				$js .= '
						var cffp_field_obj = new Array();
						cffp_field_obj[0] = null;';
				foreach ($group['settings_fields'] as $id_field => $settings_field)
				{
					if (in_array($settings_field['type'], array('radio', 'check', 'boolean')))
						$js .= '
						cffp_field_obj[' . $id_field . '] = document.getElementsByName("cffp[' . $id_group . '][column_' . $settings_field['id_column'] . ']");';
					else
						$js .= '
						cffp_field_obj[' . $id_field . '] = document.getElementById("cffp_' . $id_group . '_column_' . $settings_field['id_column'] . '");';
				}
				$js .= '
						function cffpApplyQuickInputFieldGroup' . $id_group . '()
						{
							var regex = ' . $group['template_quick_input_regex'] . ';
							var params_array = [' . implode(', ', $params) . '];

							if (cffpApplyQuickInputField(' . $id_group . ', regex, cffp_field_obj, params_array))
								alert("' . addslashes($txt['cffp_quick_input_match']) . '");
							else
								alert("' . addslashes($txt['cffp_quick_input_no_match']) . '");
						}';
			}
		}
		elseif ($group['can_view_fields'])
		{
			if ($group['show_fields_name'])
			{
				echo '
								<dl class="cffp_data">';
				foreach ($group['settings_fields'] as $id_field => $f)
				{
					$field = $context['cffp']['post']['field_array'][$id_group][$id_field];
					echo '
									<dt>
										', $field['name'], ':
									</dt>
									<dd>
										', $field['html'], '
									</dd>';
				}
				echo '
								</dl>';
			}
			else
			{
				echo '
								<div class="cffp_data">';
				foreach ($group['settings_fields'] as $id_field => $f)
				{
					$field = $context['cffp']['post']['field_array'][$id_group][$id_field];
					echo '
									', $field['html'], '<br />';
				}
				echo '
								</div>';
			}
			echo '
								<input type="hidden" name="cffp[', $id_group, '][without_fields]" value="1" />';
		}
		else
		{
			echo '
								<p>', $txt['cffp_warning_cannot_see_group_fields'], '</p>
								<input type="hidden" name="cffp[', $id_group, '][without_fields]" value="1" />';
		}

		if ('fields' == $group['type'])
		{
			if ($group['show_fields_set'])
				echo '
						</fieldset>';
		}
		else // record.
		{
			echo '
							</div>
						</fieldset>';
		}

		echo '
					</div>';
	}

	if (!empty($js))
	{
		echo '
					<script type="text/javascript"><!-- // --><![CDATA[', $js, '
					// ]]></script>';
	}
}

// Template for move a group of custom post fields.
function template_cffp_move_group()
{
	global $context, $txt, $scripturl, $settings;

	echo '
	<form action="', $scripturl, '?action=cffpeditgroup;move_to_post=1;start=', $context['start'], ';id_cffp=', $context['id_cffp'], ';id_msg=', $context['id_msg'], ';id_group=', $context['id_group'], ';board=', $context['board'], ';', $context['session_var'], '=', $context['session_id'], '" id="cffp_edit_group" method="post" accept-charset="', $context['character_set'], '">
		<div class="cat_bar">
			<h3 class="catbg">
				<span class="ie6_header floatleft">', !empty($settings['use_buttons']) ? '<img src="' . $settings['images_url'] . '/icons/quick_move.gif" alt="" class="icon" />' : ' ', $context['page_title'], '</span>
			</h3>
		</div>
		<span class="upperframe"><span></span></span>
		<div class="roundframe"><br class="clear" />
			<dl class="settings">
				<dt>
					<label for="msg_to">', 'no' == $context['params']['group']['show_in_topic'] ? $txt['cffp_move_to_post'] : $txt['cffp_move_to_topic'], ':</label><br />
					<span class="smalltext">', 'no' == $context['params']['group']['show_in_topic'] ? $txt['cffp_move_to_post_desc'] : $txt['cffp_move_to_topic_desc'], '</span>
				</dt>
				<dd>
					<input type="text" name="msg_to" id="msg_to" value="" size="10" class="input_text" />
					<input type="submit" name="move" value="', $txt['cffp_move'], '" accesskey="m" class="button_submit" />
				</dd>
			</dl>
		<br class="clear" /></div>
		<span class="lowerframe"><span></span></span>
	</form>';
}

// Template for search posts.
function template_cffp_search_posts()
{
	global $context, $txt, $settings, $scripturl;

	$no_column = empty($context['cffp']['search']['columns_id_group'][1]);
	$div_id = 'cffp_search_div';
	$img_id = 'cffp_search_img';
	$js = '';

	echo '
	<form action="', $scripturl, '?action=cffpsearch;sa=search_posts;search_page=', $context['search_page_compress'], ';', $context['session_var'], '=', $context['session_id'], '" id="cffp_search" method="post" accept-charset="', $context['character_set'], '">
		<div class="cat_bar">
			<h3 class="catbg">
				<span class="ie6_header floatleft">', !empty($settings['use_buttons']) ? '<img src="' . $settings['images_url'] . '/buttons/search.gif" alt="" class="icon" />' : ' ', $context['page_title'], '</span>
			</h3>
		</div>
		<p class="description">', $context['page_desc'], '</p>
		<span class="upperframe"><span></span></span>
		<div class="roundframe', $no_column ? ' cffp_roundframe' : '', '"><br class="clear" />
			<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
				<img src="', $settings['images_url'], '/', $context['cffp_search']['expanded'] ? 'collapse' : 'expand', '.gif" alt="+" id="', $img_id,'" class="icon" />
			</a>
			<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
				', $txt['cffp_show_fields'], '
			</a>
			<div id="', $div_id,'"', $context['cffp_search']['expanded'] ? '' : ' style="display: none;"', '>';

	foreach ($context['cffp']['search']['columns_id_group'] as $column => $column_id_group)
	{
		if (!$no_column)
			echo '
				<div class="cffp_column', !$column ? ' floatleft' : ' floatright', '">';
		foreach ($column_id_group as $id_group)
		{
			$group = $context['cffp']['search']['group_array'][$id_group];

			echo '
					<div class="cffp_search">';

			if ($group['show_group_name_search'])
			{
				echo '
						<fieldset>
							<legend>
								<label>
									', $group['name'], '
								</label>
							</legend>';
			}

			$subset = '';
			$begin_set = true;
			foreach ($group['settings_fields'] as $id_field => $settings_field)
			{
				template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set);

				$field = $context['cffp']['search']['field_array'][$id_group][$id_field];

				echo '
									<dt>
										', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
										$field['name'], ':',
										(empty($field['html']['id']) ? '' : '</label>'),
										(!cffpIsNotEmptyString($field['field_desc']) ? '' : '<br />
										<span class="smalltext">' . $field['field_desc'] . '</span>'), '
									</dt>
									<dd>', (!cffpIsNotEmptyString($field['field_long_desc']) ? '' : '
										' . $field['field_long_desc'] . '<br />'), '
										', $field['html_operator'], $field['html']['html'], '
									</dd>';
				if (!empty($field['html']['js']))
					$js .= '
' . $field['html']['js'];
			}
			template_cffp_show_subset_end($subset);

			if ($group['show_group_name_search'])
				echo '
						</fieldset>';

			echo '
					</div>';
		}
		if (!$no_column)
			echo '
				</div>';
	}

	echo '
				<div class="righttext clear">
					<label><input type="checkbox" name="no_expanded" value="1"', !$context['cffp_search']['expanded'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_hide_fields'], '</label>
					<input type="submit" name="search" value="', $txt['search'], '" accesskey="s" class="button_submit" />
				</div>
			</div>
		<br class="clear" /></div>
		<span class="lowerframe"><span></span></span>
	</form>';

	if (!empty($js))
	{
		echo '
	<script type="text/javascript"><!-- // --><![CDATA[', $js, '
	// ]]></script>';
	}

	template_show_list('cffp_search_result');
}

// Template for search records.
function template_cffp_search_records()
{
	global $context, $txt, $settings, $scripturl;

	$group = $context['cffp']['search']['group_array'][$context['id_group']];

	$div_id = 'cffp_search_div';
	$img_id = 'cffp_search_img';
	$js = '';

	echo '
	<form action="', $scripturl, '?action=cffpsearch;sa=search_records;id_group=', $context['id_group'], ';', $context['session_var'], '=', $context['session_id'], '" id="cffp_search" method="post" accept-charset="', $context['character_set'], '">
		<div class="cat_bar">
			<h3 class="catbg">
				<span class="ie6_header floatleft">', !empty($settings['use_buttons']) ? '<img src="' . $settings['images_url'] . '/buttons/search.gif" alt="" class="icon" />' : ' ', $context['page_title'], '</span>
			</h3>
		</div>
		<p class="description">', $context['page_desc'], '</p>
		<span class="upperframe"><span></span></span>
		<div class="roundframe cffp_roundframe"><br class="clear" />
			<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
				<img src="', $settings['images_url'], '/', $context['cffp_search']['expanded'] ? 'collapse' : 'expand', '.gif" alt="+" id="', $img_id,'" class="icon" />
			</a>
			<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
				', $txt['cffp_show_fields'], '
			</a>
			<div id="', $div_id,'"', $context['cffp_search']['expanded'] ? '' : ' style="display: none;"', '>
				<div class="cffp_search">';

	if ($group['show_group_name_search'])
	{
		echo '
					<fieldset>
						<legend>
							', $group['name'], '
						</legend>';
	}

	$subset = '';
	$begin_set = true;
	foreach ($group['settings_fields'] as $id_field => $settings_field)
	{
		template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set);

		$field = $context['cffp']['search']['field_array'][$context['id_group']][$id_field];

		echo '
							<dt>
								', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
								$field['name'], ':',
								(empty($field['html']['id']) ? '' : '</label>'),
								(!cffpIsNotEmptyString($field['field_desc']) ? '' : '<br />
								<span class="smalltext">' . $field['field_desc'] . '</span>'), '
							</dt>
							<dd>', (!cffpIsNotEmptyString($field['field_long_desc']) ? '' : '
								' . $field['field_long_desc'] . '<br />'), '
								', $field['html_operator'], $field['html']['html'], '
							</dd>';
		if (!empty($field['html']['js']))
			$js .= '
' . $field['html']['js'];
	}
	template_cffp_show_subset_end($subset);

	if ($group['show_group_name_search'])
		echo '
					</fieldset>';

	echo '
				</div>
				<div class="righttext clear">
					<label><input type="checkbox" name="no_expanded" value="1"', !$context['cffp_search']['expanded'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_hide_fields'], '</label>
					<input type="submit" name="search" value="', $txt['search'], '" accesskey="s" class="button_submit" />
				</div>
			</div>
		<br class="clear" /></div>
		<span class="lowerframe"><span></span></span>
	</form>';

	if (!empty($js))
	{
		echo '
	<script type="text/javascript"><!-- // --><![CDATA[', $js, '
	// ]]></script>';
	}

	template_show_list('cffp_search_result');
}

// Template for admin area settings (edit field).
function template_cffp_settings_edit_field()
{
	global $txt, $scripturl, $context, $settings, $smcFunc;

	echo '
	<div id="admincenter">
		<form action="', $scripturl, '?action=admin;area=modsettings;sa=cffpeditfield;fid=', $context['fid'], ';gid=', $context['gid'], $context['params_url'], ';', $context['session_var'], '=', $context['session_id'], '" method="post" accept-charset="', $context['character_set'], '">
			<div class="cat_bar">
				<h3 class="catbg">
					', $context['settings_title'], '
				</h3>
			</div>
			<div class="windowbg">
				<span class="topslice"><span></span></span>
				<div class="content">
					<fieldset>
						<legend>', $txt['cffp_group'], '</legend>
						<dl class="settings">
							<dt>
								', $txt['cffp_id'], ':
							</dt>
							<dd>
								', $context['gid'], '
							</dd>
							<dt>
								', $txt['cffp_name'], ':
							</dt>
							<dd>
								', $context['params']['group']['name'], '
							</dd>
							<dt>
								', $txt['cffp_type'], ':
							</dt>
							<dd>
								', $context['params']['group']['type_txt'], '
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_settings_display'], '</legend>
						<dl class="settings">';

	if (!empty($context['fid']))
	{
		echo '
							<dt>
								', $txt['cffp_id'], ':
							</dt>
							<dd>
								', $context['fid'], '
							</dd>';
	}

	echo '
							<dt>
								<label for="name">', $txt['cffp_name'], '</label>
							</dt>
							<dd>
								<input type="text" name="name" id="name" value="', $context['params']['name'], '" size="30" maxlength="40" class="input_text" />
							</dd>
							<dt>
								<label for="field_desc">', $txt['cffp_field_description'], '</label><br />
								<span class="smalltext">', $txt['cffp_field_description_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="field_desc" id="field_desc" value="', $context['params']['field_desc'], '" size="30" maxlength="255" class="input_text" />
							</dd>
							<dt>
								<label for="field_long_desc">', $txt['cffp_field_long_description'], '</label><br />
								<span class="smalltext">', $txt['cffp_field_long_description_desc'], '</span>
							</dt>
							<dd>
								<textarea name="field_long_desc" id="field_long_desc" rows="4" cols="30" style="min-width: 90%;">', $context['params']['field_long_desc'], '</textarea>
							</dd>
							<dt>
								<label for="description">', $txt['cffp_description'], '</label>
							</dt>
							<dd>
								<textarea name="description" id="description" rows="2" cols="30">', $context['params']['description'], '</textarea>
							</dd>
							<dt>
								<label for="field_order">', $txt['cffp_order'], '</label><br />
								<span class="smalltext">', $txt['cffp_order_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="field_order" id="field_order" value="', $context['params']['field_order'], '" size="5" maxlength="3" class="input_text" />
							</dd>
							<dt>
								<label for="text_previous">', $txt['cffp_text_previous'], '</label><br />
								<span class="smalltext">', $txt['cffp_text_previous_desc'], '</span>
							</dt>
							<dd>
								<textarea name="text_previous" id="text_previous" rows="4" cols="30" style="min-width: 90%;">', $context['params']['text_previous'], '</textarea>
							</dd>
							<dt>
								<label for="text_next">', $txt['cffp_text_next'], '</label><br />
								<span class="smalltext">', $txt['cffp_text_next_desc'], '</span>
							</dt>
							<dd>
								<textarea name="text_next" id="text_next" rows="4" cols="30" style="min-width: 90%;">', $context['params']['text_next'], '</textarea>
							</dd>
							<dt>
								<a id="cffp_enclose" href="', $scripturl, '?action=helpadmin;help=cffp_enclose" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="enclose_text">', $txt['cffp_enclose'], '</label><br />
								<span class="smalltext">', $txt['cffp_enclose_desc'], '</span>
							</dt>
							<dd>
								<label for="enclose_type">', $txt['cffp_type'], '</label>
								<select name="enclose_type" id="enclose_type">';

	foreach ($context['params']['enclose_type_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['enclose_type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select><br />
								<textarea name="enclose_text" id="enclose_text" rows="4" cols="30" style="min-width: 90%;">', $context['params']['enclose_text'], '</textarea>
							</dd>
							<dt>
								<label for="show_message_index">', $txt['cffp_show_message_index'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_message_index_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="show_message_index" id="show_message_index" value="1"', $context['params']['show_message_index'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>';

	switch ($context['params']['group']['type'])
	{
		case 'record':
		{
			echo '
					<fieldset>
						<legend>', sprintf($txt['cffp_settings_grouptype'], $txt['cffp_grouptype_record']), '</legend>
						<dl class="settings">
							<dt>
								<label for="show_record_list_type">', $txt['cffp_show_record_list_type'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_record_list_type_desc'], '</span>
							</dt>
							<dd>
								<select name="show_record_list_type" id="show_record_list_type">';

			foreach ($context['params']['show_record_list_type_array'] as $k => $v)
				echo '
									<option value="', $k, '"', $context['params']['show_record_list_type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

			echo '
								</select>
							</dd>
							<dt id="show_record_list_column_dt">
								<label for="show_record_list_column">', $txt['cffp_show_list_column'], '</label>
							</dt>
							<dd id="show_record_list_column_dd">
								<select name="show_record_list_column" id="show_record_list_column">';

			foreach ($context['params']['show_record_list_column_array'] as $row)
			{
				$k = (empty($row['show_record_list_width']) ? 'auto' : $row['show_record_list_width']) . ',' . $row['show_record_list_name'];
				$v = $row['show_record_list_name'];
				if (!empty($row['show_record_list_width']))
					$v .= ' (' . $row['show_record_list_width'] . ')';
				echo '
									<option value="', $k, '"', $context['params']['show_record_list_column'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';
			}

			echo '
									<option value=""', empty($context['params']['show_record_list_column']) ? ' selected="selected"' : '', '>', $txt['cffp_show_list_column_other'], '</option>
								</select>
							</dd>
							<dt id="show_record_list_name_dt">
								<label for="show_record_list_name">', $txt['cffp_show_list_name'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_list_name_desc'], '</span>
							</dt>
							<dd id="show_record_list_name_dd">
								<input type="text" name="show_record_list_name" id="show_record_list_name" value="', $context['params']['show_record_list_name'], '" size="30" class="input_text" />
							</dd>
							<dt id="show_record_list_width_dt">
								<label for="show_record_list_width_unit">', $txt['cffp_show_list_width'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_list_width_desc'], '</span>
							</dt>
							<dd id="show_record_list_width_dd">
								<select name="show_record_list_width_unit" id="show_record_list_width_unit">';

			foreach ($context['params']['show_record_list_width_unit_array'] as $k => $v)
				echo '
									<option value="', $k, '"', $context['params']['show_record_list_width_unit'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

			echo '
								</select>
								<span id="show_record_list_width_value">
									<input type="text" name="show_record_list_width_value" value="', $context['params']['show_record_list_width_value'], '" size="5" maxlength="5" class="input_text" />
									<span id="show_record_list_width_unit2"></span>
								</span>
							</dd>
						</dl>
					</fieldset>';
			break;
		}
		case 'member':
		{
			echo '
					<fieldset>
						<legend>', sprintf($txt['cffp_settings_grouptype'], $txt['cffp_grouptype_member']), '</legend>
						<dl class="settings">
							<dt>
								<label for="show_moderation_list_type">', $txt['cffp_show_moderation_list_type'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_moderation_list_type_desc'], '</span>
							</dt>
							<dd>
								<select name="show_moderation_list_type" id="show_moderation_list_type">';

			foreach ($context['params']['show_moderation_list_type_array'] as $k => $v)
				echo '
									<option value="', $k, '"', $context['params']['show_moderation_list_type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

			echo '
								</select>
							</dd>
							<dt id="show_moderation_list_column_dt">
								<label for="show_moderation_list_column">', $txt['cffp_show_list_column'], '</label>
							</dt>
							<dd id="show_moderation_list_column_dd">
								<select name="show_moderation_list_column" id="show_moderation_list_column">';

			foreach ($context['params']['show_moderation_list_column_array'] as $row)
			{
				$k = (empty($row['show_moderation_list_width']) ? 'auto' : $row['show_moderation_list_width']) . ',' . $row['show_moderation_list_name'];
				$v = $row['show_moderation_list_name'];
				if (!empty($row['show_moderation_list_width']))
					$v .= ' (' . $row['show_moderation_list_width'] . ')';
				echo '
									<option value="', $k, '"', $context['params']['show_moderation_list_column'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';
			}

			echo '
									<option value=""', empty($context['params']['show_moderation_list_column']) ? ' selected="selected"' : '', '>', $txt['cffp_show_list_column_other'], '</option>
								</select>
							</dd>
							<dt id="show_moderation_list_name_dt">
								<label for="show_moderation_list_name">', $txt['cffp_show_list_name'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_list_name_desc'], '</span>
							</dt>
							<dd id="show_moderation_list_name_dd">
								<input type="text" name="show_moderation_list_name" id="show_moderation_list_name" value="', $context['params']['show_moderation_list_name'], '" size="30" class="input_text" />
							</dd>
							<dt id="show_moderation_list_width_dt">
								<label for="show_moderation_list_width_unit">', $txt['cffp_show_list_width'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_list_width_desc'], '</span>
							</dt>
							<dd id="show_moderation_list_width_dd">
								<select name="show_moderation_list_width_unit" id="show_moderation_list_width_unit">';

			foreach ($context['params']['show_moderation_list_width_unit_array'] as $k => $v)
				echo '
									<option value="', $k, '"', $context['params']['show_moderation_list_width_unit'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

			echo '
								</select>
								<span id="show_moderation_list_width_value">
									<input type="text" name="show_moderation_list_width_value" value="', $context['params']['show_moderation_list_width_value'], '" size="5" maxlength="5" class="input_text" />
									<span id="show_moderation_list_width_unit2"></span>
								</span>
							</dd>
						</dl>
					</fieldset>';
			break;
		}
	}

	echo '
					<fieldset>
						<legend>', $txt['cffp_settings_input'], '</legend>
						<dl class="settings">
							<dt>
								<a id="cffp_fieldtype" href="', $scripturl, '?action=helpadmin;help=cffp_fieldtype" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="type">', $txt['cffp_type'], '</label>
							</dt>
							<dd>
								<select name="type" id="type">';

	foreach ($context['params']['type_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt id="length_dt">
								<label for="length">', $txt['cffp_length'], '</label><br />
								<span class="smalltext">', $txt['cffp_length_desc'], '<span id="length_text_desc"> ', $txt['cffp_length_text_desc'], '</span></span>
							</dt>
							<dd id="length_dd">
								<input type="text" name="length" id="length" value="', $context['params']['length'], '" size="7" maxlength="6" class="input_text" />
							</dd>
							<dt id="dimension_dt">
								', $txt['cffp_dimension'], '<br />
								<span class="smalltext">', $txt['cffp_dimension_col_desc'], '</span>
							</dt>
							<dd id="dimension_dd">
								<label for="rows">', $txt['cffp_dimension_row'], '</label> <input type="text" name="rows" id="rows" value="', $context['params']['rows'], '" size="5" maxlength="3" class="input_text" />
								<label for="cols">', $txt['cffp_dimension_col'], '</label> <input type="text" name="cols" id="cols" value="', $context['params']['cols'], '" size="5" maxlength="3" class="input_text" />
							</dd>
							<dt id="mask_dt">
								<a id="cffp_mask" href="', $scripturl, '?action=helpadmin;help=cffp_mask" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="mask">', $txt['cffp_mask'], '</label><br />
								<span class="smalltext">', $txt['cffp_mask_desc'], '</span>
							</dt>
							<dd id="mask_dd">
								<select name="mask" id="mask">';

	foreach ($context['params']['mask_array'] as $k => $v)
	{
		$mask = 'regex' == $k ? $smcFunc['substr']($context['params']['mask'], 0, 5) : $context['params']['mask'];
		echo '
									<option value="', $k, '"', $mask == $k ? ' selected="selected"' : '', '>', $v, '</option>';
	}

	echo '
								</select>
								<br />
								<span id="regex_div">
									<input type="text" name="regex" value="', $context['params']['regex'], '" size="30" class="input_text" />
								</span>
							</dd>
							<dt id="bbc_dt">
								<label for="bbc">', $txt['cffp_allow_bbc'], '</label>
							</dt>
							<dd id="bbc_dd">
								<input type="checkbox" name="bbc" id="bbc" value="1"', $context['params']['bbc'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="select_multiple_dt">
								<label for="select_multiple">', $txt['cffp_select_multiple'], '</label>
							</dt>
							<dd id="select_multiple_dd">
								<input type="checkbox" name="select_multiple" id="select_multiple" value="1"', $context['params']['select_multiple'] ? ' checked="checked"' : '', ' class="input_check" onchange="updateInputBoxes();" />
							</dd>
							<dt id="select_size_dt">
								<label for="select_size">', $txt['cffp_select_size'], '</label>
							</dt>
							<dd id="select_size_dd">
								<input type="text" name="select_size" id="select_size" value="', $context['params']['select_size'], '" size="5" maxlength="3" class="input_text" />
							</dd>
							<dt id="options_dt">
								<a href="', $scripturl, '?action=helpadmin;help=cffp_options" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" /></a>
								<label for="select_option">', $txt['cffp_options'], '</label><br />
								<span class="smalltext">', $txt['cffp_options_desc'], '</span>
							</dt>
							<dd id="options_dd">
								<div>';

	foreach ($context['params']['options'] as $k => $option)
	{
		echo '
									', $k == 0 ? '' : '<br />',
									'<input type="radio" name="default_value_options" id="default_value_options_', $k, '" value="', $k, '"', cffpIsNotEmptyString($context['params']['default_value_options']) && $context['params']['default_value_options'] == $option ? ' checked="checked"' : '', ' class="input_radio" />',
									'<input type="checkbox" name="default_value_options_multiple[', $k, ']" id="default_value_options_multiple_', $k, '" value="', $k, '"', !empty($context['params']['default_value_options_multiple']) && in_array($option, $context['params']['default_value_options_multiple']) ? ' checked="checked"' : '', ' class="input_check" />',
									'<input type="text" name="select_option[', $k, ']"', $k == 0 ? ' id="select_option"' : '', ' value="', $option, '" class="input_text" />',
									'<span id="select_option_text_', $k, '"> <label>', $txt['cffp_text'], ' <input type="text" name="select_option_text[', $k, ']" value="', isset($context['params']['options_text'][$k]) ? $context['params']['options_text'][$k] : '', '" class="input_text" /></label></span>';
	}

	echo '
									<span id="addopt"></span>
									[<a href="#" onclick="addOption(\'\', \'\'); return false;">', $txt['cffp_options_more'], '</a>]<br />
									<label for="options_add_multi">', $txt['cffp_options_add_multi'], '</label><br />
									<span class="smalltext"><span id="options_add_multi_desc">', $txt['cffp_options_add_multi_desc'], '</span><span id="options_add_multi_combo_desc">', $txt['cffp_options_add_multi_combo_desc'], '</span></span><br />
									<textarea name="options_add_multi" id="options_add_multi" rows="4" cols="60"></textarea>
									[<a href="#" onclick="addOptionMulti(); return false;">', $txt['cffp_add'], '</a>]
								</div>
							</dd>
							<dt id="default_value_text_dt">
								<label for="default_value_text">', $txt['cffp_default_value'], '</label>
							</dt>
							<dd id="default_value_text_dd">
								<input type="text" name="default_value_text" id="default_value_text" value="', $context['params']['default_value_text'], '" size="30" class="input_text" />
							</dd>
							<dt id="default_value_textarea_dt">
								<label for="default_value_textarea">', $txt['cffp_default_value'], '</label>
							</dt>
							<dd id="default_value_textarea_dd">
								<textarea name="default_value_textarea" id="default_value_textarea" rows="4" cols="30" style="min-width: 90%;">', $context['params']['default_value_textarea'], '</textarea>
							</dd>
							<dt id="default_value_boolean_dt">
								<label for="default_value_boolean">', $txt['cffp_default_value'], '</label>
							</dt>
							<dd id="default_value_boolean_dd">
								<input type="checkbox" name="default_value_boolean" id="default_value_boolean" value="1"', $context['params']['default_value_boolean'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_settings_search'], '</legend>
						<dl class="settings">
							<dt>
								<label for="field_search_desc">', $txt['cffp_field_search_description'], '</label><br />
								<span class="smalltext">', $txt['cffp_field_search_description_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="field_search_desc" id="field_search_desc" value="', $context['params']['field_search_desc'], '" size="30" maxlength="255" class="input_text" />
							</dd>
							<dt>
								<label for="field_search_long_desc">', $txt['cffp_field_search_long_description'], '</label><br />
								<span class="smalltext">', $txt['cffp_field_search_long_description_desc'], '</span>
							</dt>
							<dd>
								<textarea name="field_search_long_desc" id="field_search_long_desc" rows="4" cols="30" style="min-width: 90%;">', $context['params']['field_search_long_desc'], '</textarea>
							</dd>';

	foreach ($context['params']['type_filter_array'] as $gr_filter => $data_filter)
	{
		echo '
							<dt id="type_filter_', $gr_filter, '_dt">
								<a id="cffp_type_filter_', $gr_filter, '_a" href="', $scripturl, '?action=helpadmin;help=cffp_type_filter" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="type_filter_', $gr_filter, '">', $txt['cffp_type_filter'], '</label><br />
								<span class="smalltext">', $txt['cffp_type_filter_desc'], '</span>
							</dt>
							<dd id="type_filter_', $gr_filter, '_dd">
								<select name="type_filter_', $gr_filter, '" id="type_filter_', $gr_filter, '">';

		foreach ($data_filter[1] as $k)
			echo '
									<option value="', $k, '"', $context['params']['type_filter_' . $gr_filter] == $k ? ' selected="selected"' : '', '>', isset($context['params']['filtertype_array'][$k]) ? $context['params']['filtertype_array'][$k] : $context['params']['type_array'][$k], '</option>';

		echo '
								</select>
							</dd>';
	}

	echo '
							<dt id="show_filter_operator_dt">
								<label for="show_filter_operator">', $txt['cffp_show_filter_operator'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_filter_operator_desc'], '</span>
							</dt>
							<dd id="show_filter_operator_dd">
								<input type="checkbox" name="show_filter_operator" id="show_filter_operator" value="1"', $context['params']['show_filter_operator'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<label for="hide_filter">', $txt['cffp_hide_filter'], '</label><br />
								<span class="smalltext">', $txt['cffp_hide_filter_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="hide_filter" id="hide_filter" value="', $context['params']['hide_filter'], '" size="30" maxlength="40" style="width: 200px; max-width: 100%;" class="input_text" /><br />
								<select name="hide_filter_select" id="hide_filter_select" style="width: 200px; max-width: 100%;">
									<option value=""', !cffpIsNotEmptyString($context['params']['hide_filter']) ? ' selected="selected"' : '', '></option>';

	foreach ($context['params']['hide_filter_array'] as $v)
		echo '
									<option value="', $v, '"', $context['params']['hide_filter'] == $v ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt id="show_filter_used_options_dt">
								<label for="show_filter_used_options">', $txt['cffp_show_filter_used_options'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_filter_used_options_desc'], '</span>
							</dt>
							<dd id="show_filter_used_options_dd">
								<input type="checkbox" name="show_filter_used_options" id="show_filter_used_options" value="1"', $context['params']['show_filter_used_options'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_settings_advanced'], '</legend>
						<dl class="settings">
							<dt id="not_empty_value_dt">
								<label for="not_empty_value">', $txt['cffp_not_empty_value'], '</label><br />
								<span class="smalltext">', $txt['cffp_not_empty_value_desc'], '</span>
							</dt>
							<dd id="not_empty_value_dd">
								<input type="checkbox" name="not_empty_value" id="not_empty_value" value="1"', $context['params']['not_empty_value'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="unique_value_dt">
								<label for="unique_value">', $txt['cffp_unique_value'], '</label><br />
								<span class="smalltext">', $txt['cffp_unique_value_desc'], '</span>
							</dt>
							<dd id="unique_value_dd">
								<input type="checkbox" name="unique_value" id="unique_value" value="1"', $context['params']['unique_value'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<label for="subset">', $txt['cffp_subset'], '</label><br />
								<span class="smalltext">', $txt['cffp_subset_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="subset" id="subset" value="', $context['params']['subset'], '" size="30" maxlength="40" style="width: 200px; max-width: 100%;" class="input_text" /><br />
								<select name="subset_select" id="subset_select" style="width: 200px; max-width: 100%;">
									<option value=""', !cffpIsNotEmptyString($context['params']['subset']) ? ' selected="selected"' : '', '></option>';

	foreach ($context['params']['subset_array'] as $v)
		echo '
									<option value="', $v, '"', $context['params']['subset'] == $v ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt>
								', $txt['cffp_permissions'], '<br />
								<span class="smalltext">', $txt['cffp_permissions_field_desc'], '</span>
							</dt>
							<dd>
								<table>
									<tr>
										<td>&nbsp;</td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
										<td align="center">', $txt_pa, '</td>';
	echo '
										<td align="center"><em>', $txt['check_all'], '</em></td>
									</tr>';
	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
									<tr>
										<td align="left">', $txt_pu, '</td>';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm = $pu . ':' . $pa;
			$perm_id = $pu . '_' . $pa;
			echo '
										<td align="center">', 'owner:search' == $perm ? '&nbsp;' : '<input type="checkbox" name="permissions[]" id="permissions_' . $perm_id . '" value="' . $perm . '"' . (in_array($perm, $context['params']['permissions']) ? ' checked="checked"' : '') . ' class="input_check" />', '</td>';
		}
		echo '
										<td align="center"><input type="checkbox" name="check_all_permissions_', $pu, '" id="check_all_permissions_', $pu, '" value="" class="input_check" /></td>
									</tr>';
	}
	echo '
									<tr>
										<td align="left"><em>', $txt['check_all'], '</em></td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
										<td align="center"><input type="checkbox" name="check_all_permissions_', $pa, '" id="check_all_permissions_', $pa, '" value="" class="input_check" /></td>';
	echo '
										<td align="center"><input type="checkbox" name="check_all_permissions" id="check_all_permissions" value="" class="input_check" /></td>
									</tr>
								</table>
							</dd>
							<dt>
								<label for="active">', $txt['cffp_active'], '</label><br />
								<span class="smalltext">', $txt['cffp_active_field_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="active" id="active" value="1"', $context['params']['active'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>
					<div class="righttext">
						<input type="submit" name="save" value="', $txt['save'], '" accesskey="s" class="button_submit" />
					</div>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
	</div>
	<br class="clear" />
	<script type="text/javascript"><!-- // --><![CDATA[
		var countOpt = ', count($context['params']['options']), ';

		function updateInputBoxes()
		{
			var type = document.getElementById("type").value;
			var text = "text" == type || "textarea" == type;
			var select_multiple = (("select" == type || "combobox" == type) && document.getElementById("select_multiple").checked) || "check" == type;';

	if ('record' == $context['params']['group']['type'])
	{
		echo '
			var show_record_list_type = document.getElementById("show_record_list_type").value;
			var other_record_column = "multi" == show_record_list_type && "" == document.getElementById("show_record_list_column").value;
			var show_record_list_width_unit = document.getElementById("show_record_list_width_unit").value;';
	}

	if ('member' == $context['params']['group']['type'])
	{
		echo '
			var show_moderation_list_type = document.getElementById("show_moderation_list_type").value;
			var other_moderation_column = "multi" == show_moderation_list_type && "" == document.getElementById("show_moderation_list_column").value;
			var show_moderation_list_width_unit = document.getElementById("show_moderation_list_width_unit").value;';
	}

	echo '
';

	echo '
			document.getElementById("length_dt").style.display = text || "combobox" == type ? "" : "none";
			document.getElementById("length_dd").style.display = text || "combobox" == type ? "" : "none";
			document.getElementById("length_text_desc").style.display = "text" == type || "combobox" == type ? "" : "none";
			document.getElementById("dimension_dt").style.display = "textarea" == type ? "" : "none";
			document.getElementById("dimension_dd").style.display = "textarea" == type ? "" : "none";
			document.getElementById("mask_dt").style.display = "text" == type ? "" : "none";
			document.getElementById("mask_dd").style.display = "text" == type ? "" : "none";
			document.getElementById("regex_div").style.display = "text" == type && "regex" == document.getElementById("mask").value ? "" : "none";
			document.getElementById("bbc_dt").style.display = text ? "" : "none";
			document.getElementById("bbc_dd").style.display = text ? "" : "none";
			document.getElementById("select_multiple_dt").style.display = "select" == type || "combobox" == type ? "" : "none";
			document.getElementById("select_multiple_dd").style.display = "select" == type || "combobox" == type ? "" : "none";
			document.getElementById("select_size_dt").style.display = "select" == type || "combobox" == type ? "" : "none";
			document.getElementById("select_size_dd").style.display = "select" == type || "combobox" == type ? "" : "none";
			document.getElementById("options_dt").style.display = "select" == type || "combobox" == type || "radio" == type || "check" == type ? "" : "none";
			document.getElementById("options_dd").style.display = "select" == type || "combobox" == type || "radio" == type || "check" == type ? "" : "none";
			document.getElementById("options_add_multi_desc").style.display = "combobox" != type ? "" : "none";
			document.getElementById("options_add_multi_combo_desc").style.display = "combobox" == type ? "" : "none";
			for (k = 0; k < countOpt; k++)
			{
				document.getElementById("default_value_options_" + k).style.display = !select_multiple ? "" : "none";
				document.getElementById("default_value_options_multiple_" + k).style.display = select_multiple ? "" : "none";
				document.getElementById("select_option_text_" + k).style.display = "combobox" != type ? "" : "none";
			}
			document.getElementById("default_value_text_dt").style.display = "text" == type ? "" : "none";
			document.getElementById("default_value_text_dd").style.display = "text" == type ? "" : "none";
			document.getElementById("default_value_textarea_dt").style.display = "textarea" == type ? "" : "none";
			document.getElementById("default_value_textarea_dd").style.display = "textarea" == type ? "" : "none";
			document.getElementById("default_value_boolean_dt").style.display = "boolean" == type ? "" : "none";
			document.getElementById("default_value_boolean_dd").style.display = "boolean" == type ? "" : "none";';

	switch ($context['params']['group']['type'])
	{
		case 'record':
		{
			echo '
			document.getElementById("show_record_list_column_dt").style.display = "multi" == show_record_list_type ? "" : "none";
			document.getElementById("show_record_list_column_dd").style.display = "multi" == show_record_list_type ? "" : "none";
			document.getElementById("show_record_list_name_dt").style.display = other_record_column ? "" : "none";
			document.getElementById("show_record_list_name_dd").style.display = other_record_column ? "" : "none";
			document.getElementById("show_record_list_width_dt").style.display = "one" == show_record_list_type || other_record_column ? "" : "none";
			document.getElementById("show_record_list_width_dd").style.display = "one" == show_record_list_type || other_record_column ? "" : "none";
			if ("%" == show_record_list_width_unit || "px" == show_record_list_width_unit)
			{
				document.getElementById("show_record_list_width_value").style.display = "";
				setInnerHTML(document.getElementById("show_record_list_width_unit2"), show_record_list_width_unit);
			}
			else
				document.getElementById("show_record_list_width_value").style.display = "none";';
			break;
		}
		case 'member':
		{
			echo '
			document.getElementById("show_moderation_list_column_dt").style.display = "multi" == show_moderation_list_type ? "" : "none";
			document.getElementById("show_moderation_list_column_dd").style.display = "multi" == show_moderation_list_type ? "" : "none";
			document.getElementById("show_moderation_list_name_dt").style.display = other_moderation_column ? "" : "none";
			document.getElementById("show_moderation_list_name_dd").style.display = other_moderation_column ? "" : "none";
			document.getElementById("show_moderation_list_width_dt").style.display = "one" == show_moderation_list_type || other_moderation_column ? "" : "none";
			document.getElementById("show_moderation_list_width_dd").style.display = "one" == show_moderation_list_type || other_moderation_column ? "" : "none";
			if ("%" == show_moderation_list_width_unit || "px" == show_moderation_list_width_unit)
			{
				document.getElementById("show_moderation_list_width_value").style.display = "";
				setInnerHTML(document.getElementById("show_moderation_list_width_unit2"), show_moderation_list_width_unit);
			}
			else
				document.getElementById("show_moderation_list_width_value").style.display = "none";';
			break;
		}
	}

	foreach ($context['params']['type_filter_array'] as $gr_filter => $data_filter)
	{
		$cond_array = array();
		foreach ($data_filter[0] as $type)
			$cond_array[] = '"' . $type . '" == type';
		echo '
			document.getElementById("type_filter_', $gr_filter, '_dt").style.display = ', implode(' || ', $cond_array), ' ? "" : "none";
			document.getElementById("type_filter_', $gr_filter, '_dd").style.display = ', implode(' || ', $cond_array), ' ? "" : "none";
			if ("" == document.getElementById("type_filter_', $gr_filter, '_dt").style.display)
			{
				document.getElementById("show_filter_operator_dt").style.display = "boolean" != type && "empty_non_empty" != document.getElementById("type_filter_', $gr_filter, '").value ? "" : "none";
				document.getElementById("show_filter_operator_dd").style.display = "boolean" != type && "empty_non_empty" != document.getElementById("type_filter_', $gr_filter, '").value ? "" : "none";
				document.getElementById("show_filter_used_options_dt").style.display = "select" == document.getElementById("type_filter_', $gr_filter, '").value || "combobox" == document.getElementById("type_filter_', $gr_filter, '").value ? "" : "none";
				document.getElementById("show_filter_used_options_dd").style.display = "select" == document.getElementById("type_filter_', $gr_filter, '").value || "combobox" == document.getElementById("type_filter_', $gr_filter, '").value ? "" : "none";
			}';
	}

	echo '
			document.getElementById("not_empty_value_dt").style.display = "boolean" != type ? "" : "none";
			document.getElementById("not_empty_value_dd").style.display = "boolean" != type ? "" : "none";
			document.getElementById("unique_value_dt").style.display = "boolean" != type ? "" : "none";
			document.getElementById("unique_value_dd").style.display = "boolean" != type ? "" : "none";
		}

		function addOption(option, text)
		{
			setOuterHTML(document.getElementById("addopt"),
				\'<br />\' +
				\'<input type="radio" name="default_value_options" id="default_value_options_\' + countOpt + \'" value="\' + countOpt + \'" class="input_radio" />\' +
				\'<input type="checkbox" name="default_value_options_multiple[\' + countOpt + \']" id="default_value_options_multiple_\' + countOpt + \'" value="\' + countOpt + \'" class="input_check" />\' +
				\'<input type="text" name="select_option[\' + countOpt + \']" value="\' + option + \'" class="input_text" />\' +
				\'<span id="select_option_text_\' + countOpt + \'"> <label>', addslashes($txt['cffp_text']), ' <input type="text" name="select_option_text[\' + countOpt + \']" value="\' + text + \'" class="input_text" /><\' + \'/label><\' + \'/span>\' +
				\'<span id="addopt"><\' + \'/span>\');
			countOpt++;
			updateInputBoxes();
		}

		function addOptionMulti()
		{
			var value = document.getElementById("options_add_multi").value;
			var value_array, line_array;
			var i, dim_i;
			var line, option, text;

			value = value.replace(/\s*(\r\n|\n|\r)\s*/g, "\n");
			value_array = value.split(/\s*\n\s*/);
			dim_i = value_array.length;

			for (i = 0; i < dim_i; i++)
			{
				line = value_array[i];
				line_array = line.split(/\s*,\s*/);
				if ("" != line_array[0])
				{
					option = line_array[0];
					text = 2 == line_array.length ? line_array[1] : "";
					addOption(option, text);
				}
			}

			document.getElementById("options_add_multi").value = "";
		}

		document.getElementById("type").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("mask").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("hide_filter_select").onchange = function (event)
		{
			cffpOnchangeCombobox(document.getElementById("hide_filter"), this);
		}

		document.getElementById("subset_select").onchange = function (event)
		{
			cffpOnchangeCombobox(document.getElementById("subset"), this);
		}';

	foreach ($context['params']['type_filter_array'] as $gr_filter => $data_filter)
	{
		echo '
			document.getElementById("type_filter_', $gr_filter, '").onchange = function (event)
			{
				updateInputBoxes();
			}';
	}

	switch ($context['params']['group']['type'])
	{
		case 'record':
		{
			echo '

		document.getElementById("show_record_list_type").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_record_list_column").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_record_list_width_unit").onchange = function (event)
		{
			updateInputBoxes();
		}';
			break;
		}
		case 'member':
		{
			echo '

		document.getElementById("show_moderation_list_type").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_moderation_list_column").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_moderation_list_width_unit").onchange = function (event)
		{
			updateInputBoxes();
		}';
			break;
		}
	}

	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
	{
		echo '

		document.getElementById("check_all_permissions_', $pa, '").onclick = function (event)
		{';
		foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
		{
			$perm_id = $pu . '_' . $pa;
			echo '
			if (document.getElementById("permissions_', $perm_id, '"))
				document.getElementById("permissions_', $perm_id, '").checked = this.checked;';
		}
		echo '
		}';
	}

	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '

		document.getElementById("check_all_permissions_', $pu, '").onclick = function (event)
		{';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm_id = $pu . '_' . $pa;
			echo '
			if (document.getElementById("permissions_', $perm_id, '"))
				document.getElementById("permissions_', $perm_id, '").checked = this.checked;';
		}
		echo '
		}';
	}

	echo '

		document.getElementById("check_all_permissions").onclick = function (event)
		{';

	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
			document.getElementById("check_all_permissions_', $pu, '").checked = this.checked;
			document.getElementById("check_all_permissions_', $pu, '").click(); // Click without change status.
			document.getElementById("check_all_permissions_', $pu, '").click();';
	}

	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
			document.getElementById("check_all_permissions_', $pa, '").checked = this.checked;';

	echo '
		}

		updateInputBoxes();
	// ]]></script>';
}

// Template for admin area settings (edit group).
function template_cffp_settings_edit_group()
{
	global $txt, $scripturl, $context, $settings, $modSettings;

	echo '
	<div id="admincenter">
		<form action="', $scripturl, '?action=admin;area=modsettings;sa=cffpeditgroup;gid=', $context['gid'], $context['params_url'], ';', $context['session_var'], '=', $context['session_id'], '" method="post" accept-charset="', $context['character_set'], '">
			<div class="cat_bar">
				<h3 class="catbg">
					', $context['settings_title'], '
				</h3>
			</div>
			<div class="windowbg">
				<span class="topslice"><span></span></span>
				<div class="content">
					<fieldset>
						<legend>', $txt['cffp_settings_display'], '</legend>
						<dl class="settings">';

	if (!empty($context['gid']))
	{
		echo '
							<dt>
								', $txt['cffp_id'], ':
							</dt>
							<dd>
								', $context['gid'], '
							</dd>';
	}

	echo '
							<dt>
								<label for="name">', $txt['cffp_name'], '</label>
							</dt>
							<dd>
								<input type="text" name="name" id="name" value="', $context['params']['name'], '" size="30" maxlength="40" class="input_text" />
							</dd>
							<dt>
								<label for="description">', $txt['cffp_description'], '</label>
							</dt>
							<dd>
								<textarea name="description" id="description" rows="2" cols="30">', $context['params']['description'], '</textarea>
							</dd>
							<dt>
								<label for="group_order">', $txt['cffp_order'], '</label><br />
								<span class="smalltext">', $txt['cffp_order_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="group_order" id="group_order" value="', $context['params']['group_order'], '" size="5" maxlength="3" class="input_text" />
							</dd>
							<dt id="text_input_dt">
								<label for="text_input">', $txt['cffp_text_input'], '</label><br />
								<span class="smalltext">', $txt['cffp_text_input_desc'], '</span>
							</dt>
							<dd id="text_input_dd">
								<textarea name="text_input" id="text_input" rows="4" cols="30" style="min-width: 90%;">', $context['params']['text_input'], '</textarea>
							</dd>
							<dt id="text_output_dt">
								<label for="text_output">', $txt['cffp_text_output'], '</label><br />
								<span class="smalltext">', $txt['cffp_text_output_desc'], '</span>
							</dt>
							<dd id="text_output_dd">
								<textarea name="text_output" id="text_output" rows="4" cols="30" style="min-width: 90%;">', $context['params']['text_output'], '</textarea>
							</dd>
							<dt>
								<a id="cffp_grouptype" href="', $scripturl, '?action=helpadmin;help=cffp_grouptype" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="type">', $txt['cffp_type'], '</label>
							</dt>
							<dd>
								<select name="type" id="type">';

	foreach ($context['params']['type_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt id="show_group_name_message_index_dt">
								<label for="show_group_name_message_index">', $txt['cffp_show_group_name_message_index'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_group_name_message_index_desc'], '</span>
							</dt>
							<dd id="show_group_name_message_index_dd">
								<input type="checkbox" name="show_group_name_message_index" id="show_group_name_message_index" value="1"', $context['params']['show_group_name_message_index'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_fields_name_dt">
								<label for="show_fields_name">', $txt['cffp_show_fields_name'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_fields_name_desc'], '</span>
							</dt>
							<dd id="show_fields_name_dd">
								<input type="checkbox" name="show_fields_name" id="show_fields_name" value="1"', $context['params']['show_fields_name'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_empty_fields_post_dt">
								<label for="show_empty_fields_post">', $txt['cffp_show_empty_fields_post'], '</label>
							</dt>
							<dd id="show_empty_fields_post_dd">
								<input type="checkbox" name="show_empty_fields_post" id="show_empty_fields_post" value="1"', $context['params']['show_empty_fields_post'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_empty_fields_message_index_dt">
								<label for="show_empty_fields_message_index">', $txt['cffp_show_empty_fields_message_index'], '</label>
							</dt>
							<dd id="show_empty_fields_message_index_dd">
								<input type="checkbox" name="show_empty_fields_message_index" id="show_empty_fields_message_index" value="1"', $context['params']['show_empty_fields_message_index'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_actions_as_dt">
								<label for="show_actions_as">', $txt['cffp_show_actions_as'], '</label>
							</dt>
							<dd id="show_actions_as_dd">
								<select name="show_actions_as" id="show_actions_as">';

	foreach ($context['params']['show_actions_as_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['show_actions_as'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
						</dl>
					</fieldset>
					<fieldset id="settings_fields">
						<legend>', sprintf($txt['cffp_settings_grouptype'], $txt['cffp_grouptype_fields']), '</legend>
						<dl class="settings">
							<dt>
								<label for="show_fields_set">', $txt['cffp_show_fields_set'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_fields_set_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="show_fields_set" id="show_fields_set" value="1"', $context['params']['show_fields_set'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>
					<fieldset id="settings_record">
						<legend>', sprintf($txt['cffp_settings_grouptype'], $txt['cffp_grouptype_record']), '</legend>
						<dl class="settings">
							<dt>
								<label for="text_input_before">', $txt['cffp_text_input_before'], '</label><br />
								<span class="smalltext">', $txt['cffp_text_input_before_desc'], '</span>
							</dt>
							<dd>
								<textarea name="text_input_before" id="text_input_before" rows="4" cols="30" style="min-width: 90%;">', $context['params']['text_input_before'], '</textarea>
							</dd>
							<dt>
								<label for="show_poster_data">', $txt['cffp_show_poster_data'], '</label>
							</dt>
							<dd>
								<input type="checkbox" name="show_poster_data" id="show_poster_data" value="1"', $context['params']['show_poster_data'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_modified_data_dt">
								<label for="show_modified_data">', $txt['cffp_show_modified_data'], '</label>
							</dt>
							<dd id="show_modified_data_dd">
								<input type="checkbox" name="show_modified_data" id="show_modified_data" value="1"', $context['params']['show_modified_data'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<a id="cffp_counter" href="', $scripturl, '?action=helpadmin;help=cffp_counter" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								', $txt['cffp_counter'], '<br />
								<span id="counter_desc" class="smalltext">', $txt['cffp_counter_desc'], '</span>
							</dt>
							<dd>
								<label><input type="checkbox" name="counter_show" id="counter_show" value="1"', $context['params']['counter_show'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_counter_show'], '</label>
								<span id="counter_show_span">
									<br />
									<label>
										', $txt['cffp_counter_name'], '
										<input type="text" name="counter_name" value="', $context['params']['counter_name'], '" size="30" class="input_text" />
									</label>
								</span>
							</dd>
							<dt>
								<a id="cffp_top_poster" href="', $scripturl, '?action=helpadmin;help=cffp_top_poster" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								', $txt['cffp_top_poster'], '<br />
								<span id="top_poster_desc" class="smalltext">', $txt['cffp_top_poster_desc'], '</span>
							</dt>
							<dd>
								<label><input type="checkbox" name="top_poster_show" id="top_poster_show" value="1"', $context['params']['top_poster_show'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_top_poster_show'], '</label>
								<span id="top_poster_show_span">
									<br />
									<label>
										', $txt['cffp_top_poster_name'], '
										<input type="text" name="top_poster_name" value="', $context['params']['top_poster_name'], '" size="30" class="input_text" />
									</label>
								</span>
							</dd>
							<dt>
								<a id="cffp_profile_list" href="', $scripturl, '?action=helpadmin;help=cffp_profile_list" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								', $txt['cffp_profile_list'], '<br />
								<span id="profile_list_desc" class="smalltext">', $txt['cffp_profile_list_desc'], '</span>
							</dt>
							<dd>
								<label><input type="checkbox" name="profile_list_show" id="profile_list_show" value="1"', $context['params']['profile_list_show'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_profile_list_show'], '</label>
								<span id="profile_list_show_span">
									<br />
									<label>
										', $txt['cffp_profile_list_name'], '
										<input type="text" name="profile_list_name" value="', $context['params']['profile_list_name'], '" size="30" class="input_text" />
									</label>
								</span>
							</dd>
						</dl>
					</fieldset>
					<fieldset id="settings_member">
						<legend>', sprintf($txt['cffp_settings_grouptype'], $txt['cffp_grouptype_member']), '</legend>
						<dl class="settings">
							<dt>
								<label for="show_member_expanded">', $txt['cffp_show_member_expanded'], '</label>
							</dt>
							<dd>
								<select name="show_member_expanded" id="show_member_expanded">
									<option value="0"', 0 == $context['params']['show_member_expanded'] ? ' selected="selected"' : '', '>', $txt['no'], '</option>
									<option value="1"', 1 == $context['params']['show_member_expanded'] ? ' selected="selected"' : '', '>', $txt['yes'], '</option>
									<option value="2"', 2 == $context['params']['show_member_expanded'] ? ' selected="selected"' : '', '>', $txt['forever'], '</option>
								</select>
							</dd>
							<dt>
								<label for="show_member_expanded_data">', $txt['cffp_show_member_expanded_data'], '</label>
							</dt>
							<dd>
								<select name="show_member_expanded_data" id="show_member_expanded_data">
									<option value="0"', 0 == $context['params']['show_member_expanded_data'] ? ' selected="selected"' : '', '>', $txt['no'], '</option>
									<option value="1"', 1 == $context['params']['show_member_expanded_data'] ? ' selected="selected"' : '', '>', $txt['yes'], '</option>
									<option value="2"', 2 == $context['params']['show_member_expanded_data'] ? ' selected="selected"' : '', '>', $txt['forever'], '</option>
								</select>
							</dd>
							<dt>
								<label for="show_member_expanded_data_recent">', $txt['cffp_show_member_expanded_data_recent'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_member_expanded_data_recent_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="show_member_expanded_data_recent" id="show_member_expanded_data_recent" value="', $context['params']['show_member_expanded_data_recent'], '" size="5" maxlength="3" class="input_text" />
							</dd>
							<dt>
								<label for="show_member_expanded_new">', $txt['cffp_show_member_expanded_new'], '</label>
							</dt>
							<dd>
								<select name="show_member_expanded_new" id="show_member_expanded_new">
									<option value="0"', 0 == $context['params']['show_member_expanded_new'] ? ' selected="selected"' : '', '>', $txt['no'], '</option>
									<option value="1"', 1 == $context['params']['show_member_expanded_new'] ? ' selected="selected"' : '', '>', $txt['yes'], '</option>
									<option value="2"', 2 == $context['params']['show_member_expanded_new'] ? ' selected="selected"' : '', '>', $txt['forever'], '</option>
								</select>
							</dd>
							<dt>
								<label for="show_member_recent_at_top">', $txt['cffp_show_member_recent_at_top'], '</label>
							</dt>
							<dd>
								<input type="checkbox" name="show_member_recent_at_top" id="show_member_recent_at_top" value="1"', $context['params']['show_member_recent_at_top'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<label for="member_max_height">', $txt['cffp_member_max_height'], '</label><br />
								<span class="smalltext">', $txt['cffp_member_max_height_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="member_max_height" id="member_max_height" value="', $context['params']['member_max_height'], '" size="5" maxlength="5" class="input_text" />
								', $txt['cffp_member_max_height_px'], '
							</dd>
							<dt>
								<label for="member_one_value">', $txt['cffp_member_one_value'], '</label><br />
								<span class="smalltext">', $txt['cffp_member_one_value_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="member_one_value" id="member_one_value" value="1"', $context['params']['member_one_value'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<a id="cffp_stats" href="', $scripturl, '?action=helpadmin;help=cffp_stats" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="show_stats">', $txt['cffp_show_stats'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_stats_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="show_stats" id="show_stats" value="1"', $context['params']['show_stats'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>';

	foreach ($context['params']['stats_position'] as $pos)
	{
		echo '
							<dt id="show_stats_', $pos, '_dt">
								', $txt['cffp_show_stats_' . $pos], '
							</dt>
							<dd id="show_stats_', $pos, '_dd">
								<label>
									', $txt['cffp_show_stats_text'], ' <span class="smalltext">(', $txt['cffp_show_stats_text_desc'], ')</span><br />
									<textarea name="show_stats_', $pos, '_text" rows="4" cols="30" style="min-width: 90%;">', $context['params']['show_stats_' . $pos . '_text'], '</textarea>
								</label><br />
								<table>
									<tr>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_average[]" id="show_stats_', $pos, '_chart_average" value="show"', in_array('show', $context['params']['show_stats_' . $pos . '_chart_average']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td colspan="2"><label for="show_stats_', $pos, '_chart_average">', $txt['cffp_show_stats_chart_average'], '</label> <span class="smalltext">(', $txt['cffp_show_stats_only_numeric'], ')</span></td>
									</tr>
									<tr id="show_stats_', $pos, '_chart_average_tr1">
										<td width="4">&nbsp;</td>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_average[]" id="show_stats_', $pos, '_chart_average_average" value="average"', in_array('average', $context['params']['show_stats_' . $pos . '_chart_average']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="show_stats_', $pos, '_chart_average_average">', $txt['cffp_show_stats_average'], '</label></td>
									</tr>
									<tr id="show_stats_', $pos, '_chart_average_tr2">
										<td width="4">&nbsp;</td>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_average[]" id="show_stats_', $pos, '_chart_average_minmax" value="minmax"', in_array('minmax', $context['params']['show_stats_' . $pos . '_chart_average']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="show_stats_', $pos, '_chart_average_minmax">', $txt['cffp_show_stats_minmax'], '</label></td>
									</tr>
									<tr id="show_stats_', $pos, '_chart_average_tr3">
										<td width="4">&nbsp;</td>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_average[]" id="show_stats_', $pos, '_chart_average_options_text" value="options_text"', in_array('options_text', $context['params']['show_stats_' . $pos . '_chart_average']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="show_stats_', $pos, '_chart_average_options_text">', $txt['cffp_show_stats_options_text'], '</label></td>
									</tr>
									<tr>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_hbars[]" id="show_stats_', $pos, '_chart_hbars" value="show"', in_array('show', $context['params']['show_stats_' . $pos . '_chart_hbars']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td colspan="2"><label for="show_stats_', $pos, '_chart_hbars">', $txt['cffp_show_stats_chart_hbars'], '</label></td>
									</tr>
									<tr>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_vbars[]" id="show_stats_', $pos, '_chart_vbars" value="show"', in_array('show', $context['params']['show_stats_' . $pos . '_chart_vbars']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td colspan="2"><label for="show_stats_', $pos, '_chart_vbars">', $txt['cffp_show_stats_chart_vbars'], '</label></td>
									</tr>
									<tr id="show_stats_', $pos, '_chart_vbars_tr">
										<td width="4">&nbsp;</td>
										<td width="4"><input type="checkbox" name="show_stats_', $pos, '_chart_vbars[]" id="show_stats_', $pos, '_chart_vbars_options_text" value="options_text"', in_array('options_text', $context['params']['show_stats_' . $pos . '_chart_vbars']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="show_stats_', $pos, '_chart_vbars_options_text">', $txt['cffp_show_stats_options_text'], '</label></td>
									</tr>
									<tr>
										<td colspan="3">', $txt['cffp_show_stats_summary'], ':</td>
									</tr>';

		foreach ($context['params']['show_stats_summary_array'] as $k => $v)
		{
			$id = 'show_stats_' . $pos . '_summary_' . $k;
			echo '
									<tr>
										<td width="4">&nbsp;</td>
										<td width="4"><input type="checkbox" name="show_stats_' . $pos . '_summary[]" id="', $id, '" value="', $k, '"', in_array($k, $context['params']['show_stats_' . $pos . '_summary']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="', $id, '">', $v[0], '</label>', $v[1] ? (' <span class="smalltext">(' . $txt['cffp_show_stats_only_numeric'] . ')</span>') : '', '</td>
									</tr>';
		}

		echo '
								</table>
							</dd>';
	}

	echo '
							<dt id="show_stats_order_by_dt">
								', $txt['cffp_show_stats_order_by'], '
							</dt>
							<dd id="show_stats_order_by_dd">
								<table>';

	foreach ($context['params']['show_stats_summary2_array'] as $k => $v)
	{
		$id = 'show_stats_order_by_' . $k;
		echo '
									<tr>
										<td><input type="checkbox" name="show_stats_order_by[]" id="', $id, '" value="', $k, '"', in_array($k, $context['params']['show_stats_order_by']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td><label for="', $id, '">', $v[0], '</label>', $v[1] ? (' <span class="smalltext">(' . $txt['cffp_show_stats_only_numeric'] . ')</span>') : '', '</td>
									</tr>';
	}

	echo '
								</table>
							</dd>
							<dt id="show_in_topic_dt">
								<label for="show_in_topic">', $txt['cffp_show_in_topic'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_in_topic_desc'], '</span>
							</dt>
							<dd id="show_in_topic_dd">
								<select name="show_in_topic" id="show_in_topic">';

	foreach ($context['params']['show_in_topic_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['show_in_topic'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt>
								<a id="cffp_moderation_list" href="', $scripturl, '?action=helpadmin;help=cffp_moderation_list" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								', $txt['cffp_moderation_list'], '<br />
								<span id="moderation_list_desc" class="smalltext">', $txt['cffp_moderation_list_desc'], '</span>
							</dt>
							<dd>
								<label><input type="checkbox" name="moderation_list_show" id="moderation_list_show" value="1"', $context['params']['moderation_list_show'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_moderation_list_show'], '</label>
								<span id="moderation_list_show_span">
									<br />
									<label><input type="checkbox" name="moderation_list_menu" value="1"', $context['params']['moderation_list_menu'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_moderation_list_menu'], '</label><br />
									<label>
										', $txt['cffp_moderation_list_name'], '
										<input type="text" name="moderation_list_name" value="', $context['params']['moderation_list_name'], '" size="30" class="input_text" />
									</label><br />
									<label>
										', $txt['cffp_moderation_list_order_by'], '
										<select name="moderation_list_order_by">';

	foreach ($context['params']['moderation_list_order_by_array'] as $k => $v)
		echo '
											<option value="', $k, '"', $context['params']['moderation_list_order_by'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
										</select>
									</label>
								</span>
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_settings_search'], '</legend>
						<dl class="settings">
							<dt>
								<label for="show_group_name_filter">', $txt['cffp_show_group_name_filter'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_group_name_filter_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="show_group_name_filter" id="show_group_name_filter" value="1"', $context['params']['show_group_name_filter'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt>
								<label for="show_group_name_search">', $txt['cffp_show_group_name_search'], '</label><br />
								<span class="smalltext">', $txt['cffp_show_group_name_search_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="show_group_name_search" id="show_group_name_search" value="1"', $context['params']['show_group_name_search'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_filters_dt">
								', $txt['cffp_show_filters'], '<br />
								<span class="smalltext">', $txt['cffp_show_filters_desc'], '</span>
							</dt>
							<dd id="show_filters_dd">
								<table>
									<tr>
										<td>&nbsp;</td>
										<td>', $txt['message_index'], '</td>
										<td>', $txt['cffp_search_posts'], '</td>
										<td>', $txt['cffp_show_filters_operator'], '<td>
									</tr>';

	foreach ($context['params']['show_filters_array'] as $k => $v)
	{
		echo '
									<tr>
										<td><input type="checkbox" name="show_filters[]" id="show_filters_', $k, '" value="', $k, '"', in_array($k, $context['params']['show_filters']) ? ' checked="checked"' : '', ' class="input_check" /></td>
										<td>', !empty($v['name'][0]) ? '<label for="show_filters_' . $k . '">' . $v['name'][0] . '</label>': '&nbsp;', '</td>
										<td>', empty($v['name'][0]) ? '<label for="show_filters_' . $k . '">' . $v['name'][1] . '</label>': $v['name'][1], 'sticky' == $k && !$modSettings['enableStickyTopics'] ? ' <span class="smalltext">(*)</span>' : '', '</td>
										<td>', $v['show_filter_operator'] ? '<input type="checkbox" name="show_filters_operator[]" id="show_filters_operator_' . $k . '" value="' . $k . '"' . (in_array($k, $context['params']['show_filters_operator']) ? ' checked="checked"' : '') . ' class="input_check" />' : '', '</td>
									</tr>';
	}

	echo '
								</table>';

	if (!$modSettings['enableStickyTopics'])
		echo '
								<span class="smalltext">(*) ', $txt['cffp_show_filters_sticky_disabled'], '</span>';

	echo '
							</dd>
							<dt id="search_page_post_dt">
								<a id="cffp_search_page_post" href="', $scripturl, '?action=helpadmin;help=cffp_search_page" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								', $txt['cffp_search_page'], '<br />
								<span id="search_page_post_desc" class="smalltext">', $txt['cffp_search_page_post_desc'], '</span>
							</dt>
							<dd id="search_page_post_dd">
								<label><input type="checkbox" name="search_page_post_default" id="search_page_post_default" value="1"', $context['params']['search_page_post_default'] ? ' checked="checked"' : '', ' class="input_check" /> ', $txt['cffp_search_page_post_default'], '</label><br />
								<span id="search_page_post_default_data">
									', $txt['cffp_name'], ': ', $txt['cffp_search_posts'], '<br />
									', $txt['cffp_search_page_order_by2'], ': ', $txt['cffp_poster_time'], ' (', $txt['cffp_order_by_desc'], ')
								</span>
								<span id="search_page_post_no_default_data">';

	foreach ($context['params']['search_page_name_post'] as $k => $search_page_name_post)
	{
		echo '
									', $k == 0 ? '' : '<br />
									', '<input type="text" name="search_page_name_post[', $k, ']" value="', $search_page_name_post, '" size="30" class="input_text" />
									<label>',
										$txt['cffp_search_page_order_by2'], ' ',
										'<select name="search_page_order_by_post[', $k, ']">';

		foreach ($context['params']['search_page_order_by_post_array'] as $kk => $v)
			echo '
											<option value="', $kk, '"', $context['params']['search_page_order_by_post'][$k] == $kk ? ' selected="selected"' : '', '>', $v, '</option>';

		echo '
										</select>',
									'</label>';
	}

	echo '
									<span id="addpage"></span>
									[<a href="#" onclick="addPage(\'\', \'m.poster_time desc\'); return false;">', $txt['cffp_search_page_post_more'], '</a>]<br />
									<label>
									', $txt['cffp_search_page_post_add'], ':
										<select name="search_page_post_more" id="search_page_post_more">
											<option value="" selected="selected"></option>';

	foreach ($context['params']['search_page_post_more_array'] as $v)
	{
		list ($name, $order) = explode(',', $v);
		echo '
											<option value="', $v, '">', $name, ' (', $txt['cffp_search_page_order_by2'], ': ', $context['params']['search_page_order_by_post_array'][$order], ')</option>';
	}

	echo '
										</select>
									</label>
								</span>
							</dd>
							<dt id="search_page_name_record_dt">
								<a id="cffp_search_page_record" href="', $scripturl, '?action=helpadmin;help=cffp_search_page" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="search_page_name_record">', $txt['cffp_search_page'], '</label><br />
								<span class="smalltext">', $txt['cffp_search_page_record_desc'], '</span>
							</dt>
							<dd id="search_page_name_record_dd">
								<input type="text" name="search_page_name_record" id="search_page_name_record" value="', $context['params']['search_page_name_record'], '" size="30" class="input_text" />
							</dd>
							<dt id="search_page_order_by_record_dt">
								<label for="search_page_order_by_record">', $txt['cffp_search_page_order_by'], '</label><br />
								<span class="smalltext">', $txt['cffp_search_page_order_by_desc'], '</span>
							</dt>
							<dd id="search_page_order_by_record_dd">
								<select name="search_page_order_by_record" id="search_page_order_by_record">';

	foreach ($context['params']['search_page_order_by_record_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['search_page_order_by_record'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_settings_advanced'], '</legend>
						<dl class="settings">
							<dt>
								<label for="boards">', $txt['cffp_boards'], '</label>
							</dt>
							<dd>
								<select name="boards[]" id="boards" size="10" multiple="multiple">
									<option value="all"', in_array('all', $context['params']['boards']) ? ' selected="selected"' : '', '>', $txt['all'], '</option>';

	foreach ($context['params']['all_boards'] as $category)
	{
		echo '
									<optgroup label="', $category['name'], '">';
		foreach ($category['boards'] as $board)
			echo '
										<option value="', $board['id'], '"', in_array($board['id'], $context['params']['boards']) ? ' selected="selected"' : '', '>', $board['child_level'] > 0 ? str_repeat('==', $board['child_level'] - 1) . '=&gt;' : '', ' ', $board['name'], '</option>';
		echo '
									</optgroup>';
	}

	echo '
								</select>
							</dd>
							<dt>
								<label for="child_boards">', $txt['cffp_child_boards'], '</label>
							</dt>
							<dd>
								<select name="child_boards" id="child_boards">
									<option value=""', !is_numeric($context['params']['child_boards']) ? ' selected="selected"' : '', '>', $txt['all'], '</option>
									<option value="0"', is_numeric($context['params']['child_boards']) && empty($context['params']['child_boards']) ? ' selected="selected"' : '', '>', $txt['no'], '</option>';

	for ($k = 1; $k < 256; $k++)
		echo '
									<option value="', $k, '"', $k == $context['params']['child_boards'] ? ' selected="selected"' : '', '>', sprintf($txt['cffp_child_boards_until'], $k), '</option>';

	echo '
								</select>
							</dd>
							<dt id="show_sticky_dt">
								<label for="show_sticky">', $txt['cffp_show_sticky'], '</label>
							</dt>
							<dd id="show_sticky_dd">
								<select name="show_sticky" id="show_sticky">
									<option value=""', !is_numeric($context['params']['show_sticky']) ? ' selected="selected"' : '', '>', $txt['all'], '</option>
									<option value="1"', is_numeric($context['params']['show_sticky']) && $context['params']['show_sticky'] ? ' selected="selected"' : '', '>', $txt['yes'], '</option>
									<option value="0"', is_numeric($context['params']['show_sticky']) && !$context['params']['show_sticky'] ? ' selected="selected"' : '', '>', $txt['no'], '</option>
								</select>
							</dd>
							<dt id="show_locked_dt">
								<label for="show_locked">', $txt['cffp_show_locked'], '</label>
							</dt>
							<dd id="show_locked_dd">
								<select name="show_locked" id="show_locked">
									<option value=""', !is_numeric($context['params']['show_locked']) ? ' selected="selected"' : '', '>', $txt['all'], '</option>
									<option value="1"', is_numeric($context['params']['show_locked']) && $context['params']['show_locked'] ? ' selected="selected"' : '', '>', $txt['yes'], '</option>
									<option value="0"', is_numeric($context['params']['show_locked']) && !$context['params']['show_locked'] ? ' selected="selected"' : '', '>', $txt['no'], '</option>
								</select>
							</dd>
							<dt id="show_first_post_topic_dt">
								<label for="show_first_post_topic">', $txt['cffp_show_first_post_topic'], '</label>
							</dt>
							<dd id="show_first_post_topic_dd">
								<input type="checkbox" name="show_first_post_topic" id="show_first_post_topic" value="1"', $context['params']['show_first_post_topic'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="show_replies_topic_dt">
								<label for="show_replies_topic">', $txt['cffp_show_replies_topic'], '</label>
							</dt>
							<dd id="show_replies_topic_dd">
								<input type="checkbox" name="show_replies_topic" id="show_replies_topic" value="1"', $context['params']['show_replies_topic'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
							<dt id="no_show_with_subject_prefix_dt">
								<label for="no_show_with_subject_prefix">', $txt['cffp_no_show_with_subject_prefix'], '</label><br />
								<span class="smalltext">', $txt['cffp_no_show_with_subject_prefix_desc'], '</span>
							</dt>
							<dd id="no_show_with_subject_prefix_dd">
								<input type="text" name="no_show_with_subject_prefix" id="no_show_with_subject_prefix" value="', $context['params']['no_show_with_subject_prefix'], '" size="30" class="input_text" />
							</dd>
							<dt id="javascript_dt">
								<a id="cffp_javascript" href="', $scripturl, '?action=helpadmin;help=cffp_javascript" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="javascript">', $txt['cffp_javascript'], '</label><br />
								<span class="smalltext">', $txt['cffp_javascript_desc'], '</span>
							</dt>
							<dd id="javascript_dd">
								<textarea name="javascript" id="javascript" rows="4" cols="30" style="min-width: 90%;">', $context['params']['javascript'], '</textarea>
							</dd>
							<dt>
								', $txt['cffp_permissions'], '<br />
								<span class="smalltext">', $txt['cffp_permissions_group_desc'], '</span>
							</dt>
							<dd>
								<table>
									<tr>
										<td>&nbsp;</td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
										<td align="center" id="permissions_', $pa, '_td">', (is_array($txt_pa) ? '<span id="permissions_' . $pa . '_0">' . $txt_pa[0] . '</span><span id="permissions_' . $pa . '_1">' . $txt_pa[1] . '</span>' : $txt_pa), '</td>';
	echo '
										<td align="center"><em>', $txt['check_all'], '</em></td>
									</tr>';
	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
									<tr id="permissions_', $pu, '_tr">
										<td align="left">', (is_array($txt_pu) ? '<span id="permissions_' . $pu . '_0">' . $txt_pu[0] . '</span><span id="permissions_' . $pu . '_1">' . $txt_pu[1] . '</span>' : $txt_pu), '</td>';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm = $pu . ':' . $pa;
			$perm_id = $pu . '_' . $pa;
			echo '
										<td align="center" id="permissions_', $perm_id, '_td">', in_array($perm, array('owner:stats', 'owner:search')) ? '&nbsp;' : '<input type="checkbox" name="permissions[]" id="permissions_' . $perm_id . '" value="' . $perm . '"' . (in_array($perm, $context['params']['permissions']) ? ' checked="checked"' : '') . ' class="input_check" />', '</td>';
		}
		echo '
										<td align="center" id="check_all_permissions_', $pu, '_td"><input type="checkbox" name="check_all_permissions_', $pu, '" id="check_all_permissions_', $pu, '" value="" class="input_check" /></td>
									</tr>';
	}
	echo '
									<tr>
										<td align="left"><em>', $txt['check_all'], '</em></td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
										<td align="center" id="check_all_permissions_', $pa, '_td"><input type="checkbox" name="check_all_permissions_', $pa, '" id="check_all_permissions_', $pa, '" value="" class="input_check" /></td>';
	echo '
										<td align="center"><input type="checkbox" name="check_all_permissions" id="check_all_permissions" value="" class="input_check" /></td>
									</tr>
								</table>
							</dd>
							<dt>
								<label for="active">', $txt['cffp_active'], '</label><br />
								<span class="smalltext">', $txt['cffp_active_group_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="active" id="active" value="1"', $context['params']['active'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>
					<div class="righttext">
						<input type="submit" name="save" value="', $txt['save'], '" accesskey="s" class="button_submit" />
					</div>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
	</div>
	<br class="clear" />
	<script type="text/javascript"><!-- // --><![CDATA[
		var countPage = ', count($context['params']['search_page_order_by_post_array']), ';

		function updateInputBoxes()
		{
			var fields = "fields" == document.getElementById("type").value;
			var record = "record" == document.getElementById("type").value;
			var member = "member" == document.getElementById("type").value;
			var filters = "filters" == document.getElementById("type").value;

			document.getElementById("text_input_dt").style.display = !filters ? "" : "none";
			document.getElementById("text_input_dd").style.display = !filters ? "" : "none";
			document.getElementById("text_output_dt").style.display = !filters ? "" : "none";
			document.getElementById("text_output_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_group_name_message_index_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_group_name_message_index_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_fields_name_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_fields_name_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_empty_fields_post_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_empty_fields_post_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_empty_fields_message_index_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_empty_fields_message_index_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_actions_as_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_actions_as_dd").style.display = !filters ? "" : "none";
			document.getElementById("settings_fields").style.display = fields ? "" : "none";
			document.getElementById("settings_record").style.display = record ? "" : "none";
			document.getElementById("show_modified_data_dt").style.display = document.getElementById("show_poster_data").checked ? "" : "none";
			document.getElementById("show_modified_data_dd").style.display = document.getElementById("show_poster_data").checked ? "" : "none";
			document.getElementById("counter_desc").style.display = document.getElementById("counter_show").checked ? "" : "none";
			document.getElementById("counter_show_span").style.display = document.getElementById("counter_show").checked ? "" : "none";
			document.getElementById("top_poster_desc").style.display = document.getElementById("top_poster_show").checked ? "" : "none";
			document.getElementById("top_poster_show_span").style.display = document.getElementById("top_poster_show").checked ? "" : "none";
			document.getElementById("profile_list_desc").style.display = document.getElementById("profile_list_show").checked ? "" : "none";
			document.getElementById("profile_list_show_span").style.display = document.getElementById("profile_list_show").checked ? "" : "none";
			document.getElementById("settings_member").style.display = member ? "" : "none";';
	foreach ($context['params']['stats_position'] as $pos)
	{
		echo '
			document.getElementById("show_stats_', $pos, '_dt").style.display = document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("show_stats_', $pos, '_dd").style.display = document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("show_stats_', $pos, '_chart_average_tr1").style.display = document.getElementById("show_stats_', $pos, '_chart_average").checked ? "" : "none";
			document.getElementById("show_stats_', $pos, '_chart_average_tr2").style.display = document.getElementById("show_stats_', $pos, '_chart_average").checked ? "" : "none";
			document.getElementById("show_stats_', $pos, '_chart_average_tr3").style.display = document.getElementById("show_stats_', $pos, '_chart_average").checked ? "" : "none";
			document.getElementById("show_stats_', $pos, '_chart_vbars_tr").style.display = document.getElementById("show_stats_', $pos, '_chart_vbars").checked ? "" : "none";';
	}
	echo '
			document.getElementById("show_stats_order_by_dt").style.display = document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("show_stats_order_by_dd").style.display = document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("show_in_topic_dt").style.display = document.getElementById("show_first_post_topic").checked && !document.getElementById("show_replies_topic").checked ? "" : "none";
			document.getElementById("show_in_topic_dd").style.display = document.getElementById("show_first_post_topic").checked && !document.getElementById("show_replies_topic").checked ? "" : "none";
			document.getElementById("moderation_list_desc").style.display = document.getElementById("moderation_list_show").checked ? "" : "none";
			document.getElementById("moderation_list_show_span").style.display = document.getElementById("moderation_list_show").checked ? "" : "none";
			document.getElementById("show_filters_dt").style.display = filters ? "" : "none";
			document.getElementById("show_filters_dd").style.display = filters ? "" : "none";
			document.getElementById("search_page_post_dt").style.display = !record ? "" : "none";
			document.getElementById("search_page_post_dd").style.display = !record ? "" : "none";
			document.getElementById("search_page_post_default_data").style.display = document.getElementById("search_page_post_default").checked ? "" : "none";
			document.getElementById("search_page_post_no_default_data").style.display = !document.getElementById("search_page_post_default").checked ? "" : "none";
			document.getElementById("search_page_post_desc").style.display = !document.getElementById("search_page_post_default").checked ? "" : "none";
			document.getElementById("search_page_name_record_dt").style.display = record ? "" : "none";
			document.getElementById("search_page_name_record_dd").style.display = record ? "" : "none";
			document.getElementById("search_page_order_by_record_dt").style.display = record ? "" : "none";
			document.getElementById("search_page_order_by_record_dd").style.display = record ? "" : "none";
			document.getElementById("show_sticky_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_sticky_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_locked_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_locked_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_first_post_topic_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_first_post_topic_dd").style.display = !filters ? "" : "none";
			document.getElementById("show_replies_topic_dt").style.display = !filters ? "" : "none";
			document.getElementById("show_replies_topic_dd").style.display = !filters ? "" : "none";
			document.getElementById("no_show_with_subject_prefix_dt").style.display = !filters ? "" : "none";
			document.getElementById("no_show_with_subject_prefix_dd").style.display = !filters ? "" : "none";
			document.getElementById("javascript_dt").style.display = !filters ? "" : "none";
			document.getElementById("javascript_dd").style.display = !filters ? "" : "none";
			document.getElementById("permissions_view_0").style.display = !filters ? "" : "none";
			document.getElementById("permissions_view_1").style.display = filters ? "" : "none";
			document.getElementById("permissions_stats_td").style.display = member && document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("permissions_add_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("permissions_modify_td").style.display = !filters ? "" : "none";
			document.getElementById("permissions_remove_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("permissions_move_td").style.display = !filters ? "" : "none";
			document.getElementById("check_all_permissions_stats_td").style.display = member && document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("check_all_permissions_add_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("check_all_permissions_modify_td").style.display = !filters ? "" : "none";
			document.getElementById("check_all_permissions_remove_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("check_all_permissions_move_td").style.display = !filters ? "" : "none";';
	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
			document.getElementById("permissions_', $pu, '_stats_td").style.display = member && document.getElementById("show_stats").checked ? "" : "none";
			document.getElementById("permissions_', $pu, '_add_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("permissions_', $pu, '_modify_td").style.display = !filters ? "" : "none";
			document.getElementById("permissions_', $pu, '_remove_td").style.display = !fields && !filters ? "" : "none";
			document.getElementById("permissions_', $pu, '_move_td").style.display = !filters ? "" : "none";';
	}
	echo '
			document.getElementById("permissions_owner_tr").style.display = !filters ? "" : "none";
			document.getElementById("permissions_owner_0").style.display = !member ? "" : "none";
			document.getElementById("permissions_owner_1").style.display = member ? "" : "none";
			document.getElementById("permissions_owner_add").style.display = !member ? "" : "none";
		}

		function addPage(name, order)
		{
			setOuterHTML(document.getElementById("addpage"),
				\'<br />\' +
				\'<input type="text" name="search_page_name_post[\' + countPage + \']" value="\' + name + \'" size="30" class="input_text" /> \' +
				\'<label>\' +
					\'', addslashes($txt['cffp_search_page_order_by2']), ' \' +
					\'<select name="search_page_order_by_post[\' + countPage + \']">\' +';

	foreach ($context['params']['search_page_order_by_post_array'] as $kk => $v)
		echo '
						\'<option value="', $kk, '"\' + (order == \'', $kk, '\' ? \' selected="selected"\' : \'\') + \'>', addslashes($v), '<\' + \'/option>\' +';

	echo '
					\'</select>\' +
				\'</label>\' +
				\'<span id="addpage"></span>\');
			countPage++;
		}

		document.getElementById("type").onchange = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_poster_data").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_modified_data").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_stats").onclick = function (event)
		{
			updateInputBoxes();
		}';

	foreach ($context['params']['stats_position'] as $pos)
	{
		echo '

		document.getElementById("show_stats_', $pos, '_chart_average").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_stats_', $pos, '_chart_vbars").onclick = function (event)
		{
			updateInputBoxes();
		}';
	}

	echo '

		document.getElementById("show_first_post_topic").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("show_replies_topic").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("search_page_post_default").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("search_page_post_more").onchange = function (event)
		{
			var value;

			if ("" != this.value)
			{
				value = this.value.split(",");
				addPage(value[0], value[1]);
			}
			this.value = "";
		}

		document.getElementById("counter_show").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("top_poster_show").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("profile_list_show").onclick = function (event)
		{
			updateInputBoxes();
		}

		document.getElementById("moderation_list_show").onclick = function (event)
		{
			updateInputBoxes();
		}';

	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
	{
		echo '

		document.getElementById("check_all_permissions_', $pa, '").onclick = function (event)
		{';
		foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
		{
			$perm_id = $pu . '_' . $pa;
			echo '
			if (document.getElementById("permissions_', $perm_id, '"))
				document.getElementById("permissions_', $perm_id, '").checked = this.checked;';
		}
		echo '
		}';
	}

	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '

		document.getElementById("check_all_permissions_', $pu, '").onclick = function (event)
		{';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm_id = $pu . '_' . $pa;
			echo '
			if (document.getElementById("permissions_', $perm_id, '"))
				document.getElementById("permissions_', $perm_id, '").checked = this.checked;';
		}
		echo '
		}';
	}

	echo '

		document.getElementById("check_all_permissions").onclick = function (event)
		{';

	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
			document.getElementById("check_all_permissions_', $pu, '").checked = this.checked;
			document.getElementById("check_all_permissions_', $pu, '").click(); // Click without change status.
			document.getElementById("check_all_permissions_', $pu, '").click();';
	}

	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
			document.getElementById("check_all_permissions_', $pa, '").checked = this.checked;';

	echo '
		}

		updateInputBoxes();
	// ]]></script>';
}

// Template for admin area settings (edit template of group).
function template_cffp_settings_edit_template()
{
	global $txt, $scripturl, $context, $settings;

	echo '
	<div id="admincenter">
		<form action="', $scripturl, '?action=admin;area=modsettings;sa=cffpedittemplate;gid=', $context['gid'], $context['params_url'], ';', $context['session_var'], '=', $context['session_id'], '" method="post" accept-charset="', $context['character_set'], '">
			<div class="cat_bar">
				<h3 class="catbg">
					', $context['settings_title'], '
				</h3>
			</div>
			<div class="windowbg">
				<span class="topslice"><span></span></span>
				<div class="content">
					<fieldset>
						<legend>', $txt['cffp_group'], '</legend>
						<dl class="settings">
							<dt>
								', $txt['cffp_id'], ':
							</dt>
							<dd>
								', $context['gid'], '
							</dd>
							<dt>
								', $txt['cffp_name'], ':
							</dt>
							<dd>
								', $context['params']['group']['name'], '
							</dd>
							<dt>
								', $txt['cffp_type'], ':
							</dt>
							<dd>
								', $context['params']['group']['type_txt'], '
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_fields'], '</legend>
						', $context['params']['fields'], '
						<span class="smalltext">(*) ', $txt['cffp_show_message_index'], '</span>
					</fieldset>';

	if ('record' == $context['params']['group']['type'])
	{
		echo '
					<fieldset>
						<legend>', $txt['cffp_template_quick_input'], '</legend>
						<dl class="settings">
							<dt>
								<a id="cffp_template_quick_input" href="', $scripturl, '?action=helpadmin;help=cffp_template_quick_input" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="template_quick_input_regex">', $txt['cffp_template_quick_input_regex'], '</label><br />
								<span class="smalltext">', $txt['cffp_template_quick_input_regex_desc'], '</span>
							</dt>
							<dd>
								<input type="text" name="template_quick_input_regex" id="template_quick_input_regex" value="', $context['params']['template_quick_input_regex'], '" size="30" class="input_text" />
							</dd>
							<dt>
								<label for="template_quick_input_params">', $txt['cffp_template_quick_input_params'], '</label><br />
								<span class="smalltext">', $txt['cffp_template_quick_input_params_desc'], '</span>
							</dt>
							<dd>
								<textarea name="template_quick_input_params" id="template_quick_input_params" rows="4" cols="30" style="min-width: 90%;">', $context['params']['template_quick_input_params'], '</textarea>
							</dd>
							<dt>
								<label for="template_quick_input_help">', $txt['cffp_template_quick_input_help'], '</label><br />
								<span class="smalltext">', $txt['cffp_template_quick_input_help_desc'], '</span>
							</dt>
							<dd>
								<textarea name="template_quick_input_help" id="template_quick_input_help" rows="4" cols="30" style="min-width: 90%;">', $context['params']['template_quick_input_help'], '</textarea>
							</dd>
							<dt>
								<label for="template_quick_input_show_modify">', $txt['cffp_template_quick_input_show_modify'], '</label><br />
								<span class="smalltext">', $txt['cffp_template_quick_input_show_modify_desc'], '</span>
							</dt>
							<dd>
								<input type="checkbox" name="template_quick_input_show_modify" id="template_quick_input_show_modify" value="1"', $context['params']['template_quick_input_show_modify'] ? ' checked="checked"' : '', ' class="input_check" />
							</dd>
						</dl>
					</fieldset>';
	}

	echo '
					<fieldset>
						<legend>', $txt['cffp_template'], '</legend>
						<dl class="settings">
							<dt>
								<label for="template_type">', $txt['cffp_type'], '</label>
							</dt>
							<dd>
								<select name="template_type" id="template_type">';

	foreach ($context['params']['template_type_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['template_type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt>
								<a id="cffp_template_text" href="', $scripturl, '?action=helpadmin;help=cffp_template_text" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="template_text">', $txt['cffp_text'], '</label>
							</dt>
							<dd>
								<textarea name="template_text" id="template_text" rows="4" cols="30" style="min-width: 90%;">', $context['params']['template_text'], '</textarea>
							</dd>
						</dl>
					</fieldset>
					<fieldset>
						<legend>', $txt['cffp_template_message_index'], '</legend>
						<dl class="settings">
							<dt>
								<label for="template_message_index_type">', $txt['cffp_type'], '</label>
							</dt>
							<dd>
								<select name="template_message_index_type" id="template_message_index_type">';

	foreach ($context['params']['template_type_array'] as $k => $v)
		echo '
									<option value="', $k, '"', $context['params']['template_message_index_type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
								</select>
							</dd>
							<dt>
								<a id="cffp_template_message_index_text" href="', $scripturl, '?action=helpadmin;help=cffp_template_message_index_text" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" align="top" /></a>
								<label for="template_message_index_text">', $txt['cffp_text'], '</label>
							</dt>
							<dd>
								<textarea name="template_message_index_text" id="template_message_index_text" rows="4" cols="30" style="min-width: 90%;">', $context['params']['template_message_index_text'], '</textarea>
							</dd>
						</dl>
					</fieldset>
					<div class="righttext">
						<input type="submit" name="save" value="', $txt['save'], '" accesskey="s" class="button_submit" />
					</div>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
	</div>
	<br class="clear" />';
}

// Template for admin area settings (show).
function template_cffp_settings_show()
{
	global $txt, $scripturl, $context, $settings;

	echo '
	<div class="cat_bar">
		<h3 class="catbg">
			<a href="', $scripturl, '?action=helpadmin;help=cffp" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" class="icon" alt="', $txt['help'], '" /></a>
			', $context['settings_title'], '
		</h3>
	</div>';

	template_show_list('cffp_settings_show_groups');
}

// Template for show custom post fields.
function template_cffp_show($cffp_action, $params = null)
{
	global $scripturl, $context, $settings, $txt, $modSettings;

	if ('order_by_filters' == $cffp_action)
	{
		if (empty($context['cffp']['order_by']) && empty($context['cffp']['filters']))
			return;
	}
	elseif (empty($context['cffp'][$cffp_action]))
		return;

	if (WIRELESS)
	{
		switch ($cffp_action)
		{
			case 'display':
			case 'display_readonly':
			{
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					echo '
		<p>';
					if ('fields' != $group['type'] || $group['show_fields_set'])
						echo '
			<b>--- ', $group['name'], ' ---</b><br />';

					if (!empty($group['text_output']))
						echo '
			', template_cffp_html_to_wap($group['text_output']), '<br />';

					$subset = '';
					$begin_set = true;
					foreach ($group['settings_fields'] as $id_field => $settings_field)
					{
						template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

						$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
						echo '
			', $group['show_fields_name'] ? $field['name'] . ': ' : '', template_cffp_html_to_wap($field['html']), '<br />';
					}
					template_cffp_show_subset_end($subset, $group['show_fields_name']);

					if ('fields' != $group['type'] || $group['show_fields_set'])
						echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $group['name']), ' ---</b><br />';

					echo '
		</p>';
				}
				break;
			}
			case 'display_member':
			case 'display_member_topic_begin_all':
			case 'display_member_topic_end_all':
			case 'display_member_topic_begin_first':
			case 'display_member_topic_end_first':
			case 'display_member_readonly':
			case 'display_member_topic_begin_all_readonly':
			case 'display_member_topic_end_all_readonly':
			case 'display_member_topic_begin_first_readonly':
			case 'display_member_topic_end_first_readonly':
			{
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					if ($group['show_member_recent_at_top'])
					{
						$group_fields_array = array_merge(
							$context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['recent'],
							$context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['previous']
						);
					}
					else
					{
						$group_fields_array = array_merge(
							$context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['previous'],
							$context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['recent']
						);
					}
					if (empty($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']) && empty($group_fields_array))
						continue;

					echo '
		<p>
			<b>--- ', $group['name'], ' ---</b><br />';

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']))
						template_cffp_show_stats($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']);

					if (!empty($group['text_output']))
							echo '
			', template_cffp_html_to_wap($group['text_output']), '<br />';

					foreach ($group_fields_array as $group_fields)
					{
						echo '
			<b>--- ', $txt['cffp_group'], ' ---</b><br />';

						if ($group_fields['can_view'])
						{
							$subset = '';
							$begin_set = true;
							foreach ($group_fields['field_array'] as $id_field => $field)
							{
								$settings_field = $group['settings_fields'][$id_field];
								template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

								echo '
			', $group['show_fields_name'] ? $field['name'] . ': ' : '', template_cffp_html_to_wap($field['html']), '<br />';
							}
							template_cffp_show_subset_end($subset, $group['show_fields_name']);

						}
						else
							echo '
			', $txt['cffp_warning_cannot_see_group_fields'], '<br />';

						$posters = array();
						if (!empty($group_fields['poster_name']))
						{
							$posters[] = array(
								$txt['cffp_created'],
								$group_fields['poster_time'],
								$group_fields['poster_name']
							);
						}
						template_cffp_show_posters_actions($posters);

						echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $txt['cffp_group']), ' ---</b><br />';
					}
					echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $group['name']), ' ---</b><br />
		</p>';
				}
				break;
			}
			default: // message_index, message_index_member, order_by, filters.
			{
				// No support.
				break;
			}
		}
	}
	else
	{
		$printpage = 'printpage' == $context['current_action'];
		switch ($cffp_action)
		{
			case 'display':
			case 'display_readonly':
			{
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					echo '
							<div class="cffp_post">';

					if (empty($group['template_text']))
					{
						if ('fields' != $group['type'] || $group['show_fields_set'])
						{
							echo '
								<fieldset>
									<legend>', $group['name'], '</legend>';
						}

						if (!empty($group['text_output']))
							echo '
									', $group['text_output'];

						$subset = '';
						$begin_set = true;
						foreach ($group['settings_fields'] as $id_field => $settings_field)
						{
							template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

							$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
							if ($group['show_fields_name'])
							{
								echo '
										<dt>
											', $field['name'], ':
										</dt>
										<dd>
											', $field['html'], '
										</dd>';
							}
							else
								echo '
										', $field['html'], '<br />';
						}
						template_cffp_show_subset_end($subset, $group['show_fields_name']);

						if ('fields' != $group['type'] || $group['show_fields_set'])
							echo '
								</fieldset>';
					}
					else
					{
						$trans = array(
							'{ID_MSG}' => $context['cffp'][$cffp_action]['id_msg'],
						);
						foreach ($group['settings_fields'] as $id_field => $f)
						{
							$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
							$trans['{FIELD_' . $id_field . '_NAME}'] = $field['name'];
							$trans['{FIELD_' . $id_field . '_VALUE}'] = $field['html'];
						}

						echo '
								', cffpParseTemplate($group['template_text'], $group['template_type'], $trans);
					}

					$posters = array();
					if ('record' == $group['type'] && $group['show_poster_data'] && !empty($group['poster_name']) && !$printpage)
					{
						$posters[] = array(
							$txt['cffp_created'],
							$group['poster_time'],
							$group['poster_name']
						);
						if ($group['show_modified_data'] && !empty($group['modified_name']))
						{
							$posters[] = array(
								$txt['last_edit'],
								$group['modified_time'],
								$group['modified_name']
							);
						}
					}
					$actions = array();
					$show_actions_as_buttons = 'button' == $group['show_actions_as'];
					if ($group['can_move'] && !$printpage)
					{
						$params = '0, ' . $context['cffp'][$cffp_action]['id_msg'] . ', 0, ' . $id_group . ', ' . $context['current_board'] . ', \'' . $scripturl . '\', \'' . $context['session_var'] . '\', \'' . $context['session_id'] . '\'';
						if ($show_actions_as_buttons)
						{
							if (!$context['cffp'][$cffp_action]['first_msg'] && $group['show_first_post_topic'])
							{
								$actions[] = array(
									$txt['cffp_move_to_first_post'],
									'if (confirm(\'' . addslashes($txt['quickmod_confirm']) . '\')) return cffpSubmitGroup(this.form, \'move_to_first_post\', ' . $params . '); else return false;'
								);
							}
							$actions[] = array(
								$txt['cffp_move_to_other_post'],
								'return cffpSubmitGroup(this.form, \'move_to_post\', ' . $params . ');'
							);
						}
						else // icon_text, icon, text.
						{
							if (!$context['cffp'][$cffp_action]['first_msg'] && $group['show_first_post_topic'])
							{
								$actions[] = array(
									$txt['cffp_move_to_first_post'],
									'if (confirm(\'' . addslashes($txt['quickmod_confirm']) . '\')) return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'move_to_first_post\', ' . $params . '); else return false;',
									'text' != $group['show_actions_as'] ? 'move_button' : ''
								);
							}
							$actions[] = array(
								$txt['cffp_move_to_other_post'],
								'return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'move_to_post\', ' . $params . ');',
								'text' != $group['show_actions_as'] ? 'move_button' : ''
							);
						}
					}
					template_cffp_show_posters_actions($posters, $actions, $show_actions_as_buttons);

					echo '
							</div>';
				}
				break;
			}
			case 'message_index':
			{
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					echo '
							<div class="cffp_message_index">';

					if (empty($group['template_message_index_text']))
					{
						if ($group['show_group_name_message_index'])
							echo '
								<span class="cffp_group_name">', $group['name'], '</span>';
						if ($group['show_fields_name'])
						{
							echo '
								<dl class="cffp_data">';
							foreach ($group['settings_fields'] as $id_field => $f)
							{
								$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
								echo '
									<dt>
										', $field['name'], ':
									</dt>
									<dd>
										', $field['html'], '
									</dd>';
							}
							echo '
								</dl>';
						}
						else
						{
							echo '
								<div class="cffp_data">';
							foreach ($group['settings_fields'] as $id_field => $f)
							{
								$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
								echo '
									', $field['html'];
							}
							echo '
								</div>';
						}
					}
					else
					{
						$trans = array(
							'{ID_MSG}' => $context['cffp'][$cffp_action]['id_msg'],
						);
						foreach ($group['settings_fields'] as $id_field => $f)
						{
							$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
							$trans['{FIELD_' . $id_field . '_NAME}'] = $field['name'];
							$trans['{FIELD_' . $id_field . '_VALUE}'] = $field['html'];
						}

						echo '
								', cffpParseTemplate($group['template_message_index_text'], $group['template_message_index_type'], $trans);
					}

					echo '
							</div>';
				}
				break;
			}
			case 'display_member':
			case 'display_member_topic_begin_all':
			case 'display_member_topic_end_all':
			case 'display_member_topic_begin_first':
			case 'display_member_topic_end_first':
			case 'display_member_readonly':
			case 'display_member_topic_begin_all_readonly':
			case 'display_member_topic_end_all_readonly':
			case 'display_member_topic_begin_first_readonly':
			case 'display_member_topic_end_first_readonly':
			{
				$action_readonly = '_readonly' == substr($cffp_action, -9);
				$action_display_member_topic = 'display_member_topic_' == substr($cffp_action, 0, 21);
				$css_class = !empty($params) ? $params : 'windowbg';

				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					$infix = $context['cffp'][$cffp_action]['id_msg'] . '_group' . $id_group;
					$div_id = 'cffp_' . $infix . '_div';
					$fieldset_id = 'cffp_' . $infix . '_fieldset';

					if ($action_display_member_topic && !$printpage)
					{
						echo '
				<div class="', $css_class, '">
					<span class="topslice"><span></span></span>
					<div class="content">';
					}

					if ($printpage)
					{
						echo '
							<div class="cffp_member">
								<fieldset>
									<legend>
										', $group['name'], '
									</legend>
									<div class="cffp_member_data">';
					}
					else
					{
						echo '
							<div class="cffp_member" id="cffp_msg', $infix, '">
								<fieldset id="', $fieldset_id, '"', $group['show_member_expanded'] ? '' : ' style="border-style: none;"', '>
									<legend>';

						if (2 == $group['show_member_expanded']) // Forever expanded.
							echo '
										', $group['name'];
						else // No/Yes expanded.
						{
							$img_id = 'cffp_' . $infix . '_img';
							echo '
										<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'', $fieldset_id, '\'); return false;">
											<img src="', $settings['images_url'], '/', $group['show_member_expanded'] ? 'collapse' : 'expand', '.gif" alt="+" id="', $img_id,'" class="icon" />
										</a>
										<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'', $fieldset_id, '\'); return false;">
											', $group['name'], '
										</a>';
						}

						echo '
									</legend>
									<div class="cffp_member_data" id="', $div_id, '"', $group['show_member_expanded'] ? '' : ' style="display: none;"', '>';
					}

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']))
					{
						echo '
										<div class="cffp_member_data_fields">
											<div class="cffp_member_fields windowbg2">
												<span class="topslice"><span></span></span>
												<div class="cffp_member_stats content">';

						template_cffp_show_stats($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']);

						echo '
												</div>
												<span class="botslice"><span></span></span>
											</div>
										</div>';
					}

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['previous']) || !empty($context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']['recent']))
					{
						if ($printpage)
							echo '
											<div class="cffp_member_data_fields">';
						elseif (2 == $group['show_member_expanded_data']) // Forever expanded.
							echo '
											<div class="cffp_member_data_fields"', !empty($group['member_max_height']) ? ' style="max-height: ' . $group['member_max_height'] . 'px; overflow: scroll;"' : '', '>';
						else // No/Yes expanded.
						{
							$infix = $context['cffp'][$cffp_action]['id_msg'] . '_group' . $id_group . '_data';
							$div_id = 'cffp_' . $infix . '_div';
							$img_id = 'cffp_' . $infix . '_img';
							$fieldset_id = 'cffp_' . $infix . '_fieldset';

							$style = '';
							if (!empty($group['member_max_height']))
								$style = 'max-height: ' . $group['member_max_height'] . 'px; overflow: scroll;';
							if (!$group['show_member_expanded_data'])
							{
								if (!empty($style))
									$style .= ' ';
								$style .= 'display: none;';
							}

							echo '
										<fieldset id="', $fieldset_id, '"', $group['show_member_expanded_data'] ? '' : ' style="border-style: none;"', '>
											<legend>
												<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'', $fieldset_id, '\'); return false;">
													<img src="', $settings['images_url'], '/', $group['show_member_expanded_data'] ? 'collapse' : 'expand', '.gif" alt="+" id="', $img_id, '" class="icon" />
												</a>
												<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'', $fieldset_id, '\'); return false;">
													', $txt['cffp_show'], '
												</a>
											</legend>
											<div class="cffp_member_data_fields" id="', $div_id, '"', !empty($style) ? ' style="' . $style . '"' : '', '>';
						}

						if (!empty($group['text_output']))
							echo '
												', $group['text_output'];

						$location_array = $group['show_member_recent_at_top'] ? array('recent', 'previous') : array('previous', 'recent');
						$alternate = false;
						foreach ($location_array as $location)
						{
							$group_fields_array = $context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array'][$location];
							if (empty($group_fields_array))
								continue;

							if (!$printpage && 'previous' == $location)
							{
								$infix = $context['cffp'][$cffp_action]['id_msg'] . '_group' . $id_group . '_data_' . $location;
								$div_id = 'cffp_' . $infix . '_div';
								$img_id = 'cffp_' . $infix . '_img';

								echo '
												<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
													<img src="', $settings['images_url'], '/', 'expand.gif" alt="+" id="', $img_id, '" class="icon" />
												</a>
												<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
													', $txt['cffp_show_previous'], '
												</a>
												<div class="cffp_member_data_fields" id="', $div_id, '" style="display: none;">';
							}

							foreach ($group_fields_array as $group_fields)
							{
								echo '
												<div class="cffp_member_fields ', !$alternate ? 'windowbg' : 'windowbg2', '" id="cffp', $group_fields['id_cffp'], '">
													<span class="topslice"><span></span></span>
													<div class="content">';

								if ($group_fields['can_view'])
								{
									if (empty($group['template_text']))
									{
										$subset = '';
										$begin_set = true;
										foreach ($group_fields['field_array'] as $id_field => $field)
										{
											$settings_field = $group['settings_fields'][$id_field];
											template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

											if ($group['show_fields_name'])
											{
												echo '
															<dt>
																', $field['name'], ':
															</dt>
															<dd>
																', $field['html'], '
															</dd>';
											}
											else
												echo '
															', $field['html'], '<br />';
										}
										template_cffp_show_subset_end($subset, $group['show_fields_name']);
									}
									else
									{
										$trans = array(
											'{ID_MSG}' => $context['cffp'][$cffp_action]['id_msg'],
										);
										foreach ($group_fields['field_array'] as $id_field => $field)
										{
											$trans['{FIELD_' . $id_field . '_NAME}'] = $field['name'];
											$trans['{FIELD_' . $id_field . '_VALUE}'] = $field['html'];
										}

										echo '
														', cffpParseTemplate($group['template_text'], $group['template_type'], $trans);
									}
								}
								else
									echo '
														<p>', $txt['cffp_warning_cannot_see_group_fields'], '</p>';

								$posters = array();
								if (!empty($group_fields['poster_name']))
								{
									$posters[] = array(
										$txt['cffp_created'],
										$group_fields['poster_time'],
										$group_fields['poster_name']
									);
									if ($settings['show_modify'] && !empty($group_fields['modified_name']))
									{
										$posters[] = array(
											$txt['last_edit'],
											$group_fields['modified_time'],
											$group_fields['modified_name']
										);
									}
								}
								$actions = array();
								$show_actions_as_buttons = 'button' == $group['show_actions_as'];
								if (($group_fields['can_modify'] || $group_fields['can_remove'] || $group_fields['can_move']) && !$printpage)
								{
									$params = $context['start'] . ', ' . $context['cffp'][$cffp_action]['id_msg'] . ', ' . $group_fields['id_cffp'] . ', ' . $id_group . ', ' . $context['current_board'] . ', \'' . $scripturl . '\', \'' . $context['session_var'] . '\', \'' . $context['session_id'] . '\'';
									if ($show_actions_as_buttons)
									{
										if ($group_fields['can_modify'])
										{
											$actions[] = array(
												$txt['modify'],
												'return cffpSubmitGroup(this.form, \'modify\', ' . $params . ');'
											);
										}
										if ($group_fields['can_remove'])
										{
											$actions[] = array(
												$txt['remove'],
												'if (confirm(\'', addslashes($txt['quickmod_confirm']), '\')) return cffpSubmitGroup(this.form, \'remove\', ', $params, '); else return false;'
											);
										}
										if ($group_fields['can_move'])
										{
											if (!$context['cffp'][$cffp_action]['first_msg'] && $group['show_first_post_topic'])
											{
												$actions[] = array(
													$txt['cffp_move_to_first_post'],
													'if (confirm(\'' . addslashes($txt['quickmod_confirm']) . '\')) return cffpSubmitGroup(this.form, \'move_to_first_post\', ' . $params . '); else return false;'
												);
											}
											$actions[] = array(
												$action_display_member_topic ? $txt['cffp_move_to_other_topic'] : $txt['cffp_move_to_other_post'],
												'return cffpSubmitGroup(this.form, \'move_to_post\', ' . $params . ');'
											);
										}
									}
									else // icon_text, icon, text.
									{
										if ($group_fields['can_modify'])
										{
											$actions[] = array(
												'icon' == $group['show_actions_as'] ? '<img src="' . $settings['images_url'] . '/icons/modify_inline.gif" alt="' . $txt['modify'] . '" title="' . $txt['modify'] . '" />' : $txt['modify'],
												'return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'modify\', ' . $params . ');',
												'icon_text' == $group['show_actions_as'] ? 'modify_button' : ''
											);
										}
										if ($group_fields['can_remove'])
										{
											$actions[] = array(
												'icon' == $group['show_actions_as'] ? '<img src="' . $settings['images_url'] . '/icons/delete.gif" alt="' . $txt['remove'] . '" title="' . $txt['remove'] . '" />' : $txt['remove'],
												'if (confirm(\'' . addslashes($txt['quickmod_confirm']) . '\')) return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'remove\', ' . $params . '); else return false;',
												'icon_text' == $group['show_actions_as'] ? 'remove_button' : ''
											);
										}
										if ($group_fields['can_move'])
										{
											if (!$context['cffp'][$cffp_action]['first_msg'] && $group['show_first_post_topic'])
											{
												$actions[] = array(
													$txt['cffp_move_to_first_post'],
													'if (confirm(\'' . addslashes($txt['quickmod_confirm']) . '\')) return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'move_to_first_post\', ' . $params . '); else return false;',
													'text' != $group['show_actions_as'] ? 'move_button' : ''
												);
											}
											$actions[] = array(
												$action_display_member_topic ? $txt['cffp_move_to_other_topic'] : $txt['cffp_move_to_other_post'],
												'return cffpSubmitGroup(document.getElementById(\'quickModForm\'), \'move_to_post\', ' . $params . ');',
												'text' != $group['show_actions_as'] ? 'move_button' : ''
											);
										}
									}
								}
								template_cffp_show_posters_actions($posters, $actions, $show_actions_as_buttons);

								echo '
													</div>
													<span class="botslice"><span></span></span>
												</div>';

								$alternate = !$alternate;
							}

							if (!$printpage && 'previous' == $location)
								echo '
												</div>';
						}

						echo '
											</div>';
						if (!$printpage && 2 != $group['show_member_expanded_data']) // No/Yes expanded.
							echo '
										</fieldset>';
					}

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['add_group_fields']) && !$printpage)
					{
						$add_group_fields = $context['cffp'][$cffp_action]['field_array'][$id_group]['add_group_fields'];
						$infix = $context['cffp'][$cffp_action]['id_msg'] . '_group' . $id_group . '_new';
						$infix2 = $context['cffp'][$cffp_action]['id_msg'] . '_group' . $id_group;
						$div_id = 'cffp_' . $infix . '_div';

						if (2 != $group['show_member_expanded_new']) // No/Yes expanded.
						{
							$img_id = 'cffp_' . $infix . '_img';
							echo '
										<div class="cffp_member_new_title">
											<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
												<img src="', $settings['images_url'], '/', $group['show_member_expanded_new'] ? 'collapse' : 'expand', '.gif" alt="+" id="', $img_id, '" class="icon" />
											</a>
											<a href="#" onclick="javascript: cffpExpandCollapseWithImage(\'', $settings['images_url'], '\', \'', $img_id, '\', \'', $div_id, '\', \'\'); return false;">
												', $txt['cffp_add'], '
											</a>
										</div>';
						}

						echo '
										<div class="cffp_member_new_fields" id="', $div_id, '"', $group['show_member_expanded_new'] ? '' : ' style="display: none;"', '>';

						if (!empty($group['text_input']))
							echo '
											', $group['text_input'];

						echo '
											<input type="hidden" name="cffp[', $infix2, '][set]" value="1" />
											<input type="hidden" name="cffp[', $infix2, '][id_cffp]" value="0" />
											<input type="hidden" name="cffp[', $infix2, '][name]" value="', $group['name'], '" />';

						// Guests have to put in their name and email...
						$put_guest_data = $context['user']['is_guest'];
						if ($put_guest_data)
						{
							echo '
											<dl class="cffp_data">
												<dt>
													<label for="cffp_', $infix2, '_guest_name">', $txt['name'], ':</label>
												</dt>
												<dd>
													<input type="text" name="cffp[', $infix2, '][guest_name]" id="cffp_', $infix2, '_guest_name" size="25" value="', $add_group_fields['guest_name'], '" class="input_text" />
												</dd>';

							if (empty($modSettings['guest_post_no_email']))
							{
								echo '
												<dt>
													<label for="cffp_', $infix2, '_guest_email">', $txt['email'], ':</label>
												</dt>
												<dd>
													<input type="text" name="cffp[', $infix2, '][guest_email]" id="cffp_', $infix2, '_guest_email" size="25" value="', $add_group_fields['guest_email'], '" class="input_text" />
												</dd>';
							}
						}

						$js = '';
						$subset = '';
						if ($group['show_fields_name'])
						{
							$begin_set = !$put_guest_data;
							foreach ($add_group_fields['field_array'] as $id_field => $field)
							{
								$settings_field = $group['settings_fields'][$id_field];
								template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

								echo '
												<dt>
													', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
													$field['name'], ':',
													(empty($field['html']['id']) ? '' : '</label>'),
													(!cffpIsNotEmptyString($field['field_desc']) ? '' : '<br />
													<span class="smalltext">' . $field['field_desc'] . '</span>'), '
													<input type="hidden" name="cffp[', $infix2, '][name_fields][', $id_field, ']" value="', $field['name'], '" />
												</dt>
												<dd>', (!cffpIsNotEmptyString($field['field_long_desc']) ? '' : '
													' . $field['field_long_desc'] . '<br />'), '
													', $field['html']['html'], '
												</dd>';
								if (!empty($field['html']['js']))
									$js .= '
' . $field['html']['js'];
							}
						}
						else
						{
							if ($put_guest_data)
								echo '
											</dl>';

							$begin_set = true;
							foreach ($add_group_fields['field_array'] as $id_field => $field)
							{
								$settings_field = $group['settings_fields'][$id_field];
								template_cffp_show_subset_begin($subset, $settings_field['subset'], $begin_set, $group['show_fields_name']);

								echo '
												<input type="hidden" name="cffp[', $infix2, '][name_fields][', $id_field, ']" value="', $field['name'], '" />
												', $field['html']['html'], '<br />';
								if (!empty($field['html']['js']))
									$js .= '
' . $field['html']['js'];
							}
						}
						template_cffp_show_subset_end($subset, $group['show_fields_name']);

						if (!empty($js))
						{
							echo '
											<script type="text/javascript"><!-- // --><![CDATA[', $js, '
											// ]]></script>';
						}

						// Is visual verification enabled?
						if ($context['require_verification'])
						{
							echo '
											<div class="post_verification">
												<strong>', $txt['verification'], ':</strong>
												', template_control_verification($context['visual_verification_id'], 'all'), '
											</div>';
						}

						echo '
											<p class="righttext">
												<input type="submit" name="save" value="', $txt['post'], '" onclick="return cffpSubmitGroup(this.form, \'add\', ', $context['start'], ', ', $context['cffp'][$cffp_action]['id_msg'], ', 0, ', $id_group, ', ', $context['current_board'], ', \'', $scripturl, '\', \'', $context['session_var'], '\', \'', $context['session_id'], '\');" accesskey="p" class="button_submit" />
											</p>
										</div>';
					}

					echo '
									</div>
								</fieldset>
							</div>';

					if ($action_display_member_topic && !$printpage)
					{
						echo '
					</div>
					<span class="botslice"><span></span></span>
				</div>';

						if (!$action_readonly)
						echo '
				<hr class="post_separator" />';
					}
				}
				break;
			}
			case 'message_index_member':
			{
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					echo '
							<div class="cffp_message_index_member">';

					if ($group['show_group_name_message_index'])
						echo '
								<span class="cffp_group_name">', $group['name'], '</span>';

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']))
					{
						echo '
								<div class="cffp_member_fields cffp_message_index_member_stats">';

						template_cffp_show_stats($context['cffp'][$cffp_action]['field_array'][$id_group]['stats']);

						echo '
								</div>';
					}

					if (!empty($context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array']))
					{
						foreach ($context['cffp'][$cffp_action]['field_array'][$id_group]['group_fields_array'] as $group_fields)
						{
							echo '
								<div class="cffp_member_fields">';

							if (empty($group['template_message_index_text']))
							{
								if ($group['show_fields_name'])
								{
									echo '
									<dl class="cffp_data">';
									foreach ($group_fields['field_array'] as $id_field => $field)
									{
										echo '
										<dt>
											', $field['name'], ':
										</dt>
										<dd>
											', $field['html'], '
										</dd>';
									}
									echo '
									</dl>';
								}
								else
								{
									echo '
									<div class="cffp_data">';
									foreach ($group_fields['field_array'] as $id_field => $field)
										echo '
										', $field['html'];
									echo '
									</div>';
								}
							}
							else
							{
								$trans = array(
									'{ID_MSG}' => $context['cffp'][$cffp_action]['id_msg'],
								);
								foreach ($group_fields['field_array'] as $id_field => $field)
								{
									$trans['{FIELD_' . $id_field . '_NAME}'] = $field['name'];
									$trans['{FIELD_' . $id_field . '_VALUE}'] = $field['html'];
								}

								echo '
									', cffpParseTemplate($group['template_message_index_text'], $group['template_message_index_type'], $trans);
							}

							$posters = array();
							if (!empty($group_fields['poster_name']))
							{
								$posters[] = array(
									$txt['cffp_created'],
									$group_fields['poster_time'],
									$group_fields['poster_name']
								);
								if ($settings['show_modify'] && !empty($group_fields['modified_name']))
								{
									$posters[] = array(
										$txt['last_edit'],
										$group_fields['modified_time'],
										$group_fields['modified_name']
									);
								}
							}
							template_cffp_show_posters_actions($posters);

							echo '
								</div>';
						}
					}

					echo '
							</div>';
				}
				break;
			}
			case 'order_by':
			{
				$form = !empty($params);

				if (!$form)
				{
					echo '
	<form action="', $scripturl, '?board=', $context['current_board'], '.0;', $context['session_var'], '=', $context['session_id'], '" id="cffp_filters" method="post" accept-charset="', $context['character_set'], '">
		<div class="windowbg2">
			<span class="topslice"><span></span></span>
			<div class="content">';
				}

				echo '
				<div class="cffp_filters">
					<select name="cffp_order_by">';

				if ($context['cffp'][$cffp_action]['field_array']['no_checked'])
					echo '
						<option value="" selected="selected"></option>';

				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					echo '
						<optgroup label="', $group['name'], '">';
					foreach ($context['cffp'][$cffp_action]['field_array']['option_array'][$id_group] as $option)
						echo '
							<option value="', $option['value'], '"', $option['checked'] ? ' selected="selected"' : '', '>', $option['text'], '</option>';
					echo '
						</optgroup>';
				}

				echo '
					</select>
				</div>
				<div class="cffp_filters_button">
					<input type="submit" name="cffp_sort" value="', $txt['cffp_sort'], '" accesskey="s" class="button_submit" />
				</div>';

				if (!$form)
				{
					echo '
			</div>
			<span class="botslice"><span></span></span>
		</div>
	</form>';
				}
				break;
			}
			case 'filters':
			{
				$form = !empty($params);

				if (!$form)
				{
					echo '
	<form action="', $scripturl, '?board=', $context['current_board'], '.0;', $context['session_var'], '=', $context['session_id'], '" id="cffp_filters" method="post" accept-charset="', $context['character_set'], '">
		<div class="windowbg2">
			<span class="topslice"><span></span></span>
			<div class="content">';
				}

				$js = '';
				foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
				{
					$filter_tags = isset($group['filter_tags']) ? $group['filter_tags'] : array('' => array_keys($group['settings_fields']));

					echo '
				<div class="cffp_filters">';

					if ($group['show_group_name_filter'])
						echo '
					<span>', $group['name'], '</span>';

					$k = 0;
					foreach ($filter_tags as $tag => $id_fields)
					{
						if (cffpIsNotEmptyString($tag))
						{
							$dl_id = 'cffp_filter' . $id_group . '_' . $k . '_dl';
							$dl_attr = ' id="' . $dl_id . '" style="display: none;"';
							$k++;

							echo '
					<a href="#" onclick="javascript: ', $dl_id, '.style.display = \'\'; this.style.display = \'none\'; return false;">
						', $tag, '
					</a>';
						}
						else
							$dl_attr = '';

						echo '
					<dl', $dl_attr, '>';
						foreach ($id_fields as $id_field)
						{
							$field = $context['cffp'][$cffp_action]['field_array'][$id_group][$id_field];
							echo '
						<dt>
							', (empty($field['html']['id']) ? '' : '<label for="' . $field['html']['id'] . '">'),
							$field['name'], ':',
							(empty($field['html']['id']) ? '' : '</label>'), '
						</dt>
						<dd>
							', $field['html_operator'], $field['html']['html'], '
						</dd>';
							if (!empty($field['html']['js']))
								$js .= '
' . $field['html']['js'];
						}
						echo '
					</dl>';
					}

					echo '
				</div>';
				}

				echo '
				<div class="cffp_filters_button">
					<input type="submit" name="cffp_filter" value="', $txt['cffp_filter'], '" accesskey="f" class="button_submit" />
				</div>';

				if (!empty($js))
				{
					echo '
				<script type="text/javascript"><!-- // --><![CDATA[', $js, '
				// ]]></script>';
				}

				if (!$form)
				{
					echo '
			</div>
			<span class="botslice"><span></span></span>
		</div>
	</form>';
				}
				break;
			}
			case 'order_by_filters':
			{
				echo '
	<form action="', $scripturl, '?board=', $context['current_board'], '.0;', $context['session_var'], '=', $context['session_id'], '" id="cffp_filters" method="post" accept-charset="', $context['character_set'], '">
		<div class="windowbg2">
			<span class="topslice"><span></span></span>
			<div class="content">';

				template_cffp_show('order_by', true);
				template_cffp_show('filters', true);

				echo '
			</div>
			<span class="botslice"><span></span></span>
		</div>
	</form>';
			}
		}
	}
}

// Template for show begin subset.
function template_cffp_show_subset_begin(&$subset_previous, $subset_current, &$begin_set, $show_fields_name = true)
{
	static $fieldset = 1;
	global $txt;

	if (WIRELESS)
	{
		if (cffpIsNotEmptyString($subset_previous) && cffpIsNotEmptyString($subset_current) && $subset_previous != $subset_current)
		{
			echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $subset_previous), ' ---</b><br />
			<b>--- ', $subset_current, ' ---</b><br />';
		}
		elseif (cffpIsNotEmptyString($subset_previous) && !cffpIsNotEmptyString($subset_current))
			echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $subset_previous), ' ---</b><br />';
		elseif (!cffpIsNotEmptyString($subset_previous) && cffpIsNotEmptyString($subset_current))
			echo '
			<b>--- ', $subset_current, ' ---</b><br />';
	}
	else
	{
		$element = $show_fields_name ? 'dl': 'div';

		if (cffpIsNotEmptyString($subset_previous) && cffpIsNotEmptyString($subset_current) && $subset_previous != $subset_current)
		{
			echo '
		</', $element, '>
	</fieldset>
	<fieldset id="cffp_fieldset_', $fieldset, '">
		<legend>', $subset_current, '</legend>
		<', $element, ' class="cffp_data">';

			$fieldset++;
		}
		elseif (cffpIsNotEmptyString($subset_previous) && !cffpIsNotEmptyString($subset_current))
		{
			echo '
		</', $element, '>
	</fieldset>
	<', $element, ' class="cffp_data">';
		}
		elseif (!cffpIsNotEmptyString($subset_previous) && cffpIsNotEmptyString($subset_current))
		{
			if (!$begin_set)
				echo '
	</', $element, '>';

			echo '
	<fieldset id="cffp_fieldset_', $fieldset, '">
		<legend>', $subset_current, '</legend>
		<', $element, ' class="cffp_data">';

			$fieldset++;
		}
		elseif (!cffpIsNotEmptyString($subset_previous) && !cffpIsNotEmptyString($subset_current))
		{
			if ($begin_set)
				echo '
	<', $element, ' class="cffp_data">';
		}
	}

	$subset_previous = $subset_current;
	$begin_set = false;
}

// Template for show end subset.
function template_cffp_show_subset_end($subset_previous, $show_fields_name = true)
{
	global $txt;

	if (WIRELESS)
	{
		if (cffpIsNotEmptyString($subset_previous))
			echo '
			<b>--- ', sprintf($txt['cffp_wireless_end_group'], $subset_previous), ' ---</b><br />';
	}
	else
	{
		$element = $show_fields_name ? 'dl': 'div';

		if (cffpIsNotEmptyString($subset_previous))
		{
		echo '
		</', $element, '>
	</fieldset>';
		}
		else
		echo '
	</', $element, '>';
	}
}

// Template for show posters and actions.
// $posters = array(array(text1, date1, name1), array(text2, date2, name2), ...)
// $actions = array($action1, $action2, ...)
// 	if $show_actions_as_buttons, $action = array(label, onclick)
// 	else, $action = array(label, onclick, class)
function template_cffp_show_posters_actions($posters, $actions = array(), $show_actions_as_buttons = true)
{
	global $txt;

	if (WIRELESS)
	{
		if (!empty($posters))
		{
			foreach ($posters as $poster)
				echo '
	&#171; <em>', $poster[0], ': ', timeformat($poster[1]), ' ', $txt['by'], ' ', $poster[2], '</em> &#187;<br />';
		}
	}
	else
	{
		if (!empty($posters))
		{
			echo '
	<div class="moderatorbar smalltext', !empty($actions) ? ' floatleft' : '', '">';
			$first = true;
			foreach ($posters as $poster)
			{
				if ($first)
					$first = false;
				else
					echo '<br />';

				echo '
		&#171; <em>', $poster[0], ': ', timeformat($poster[1]), ' ', $txt['by'], ' ', $poster[2], '</em> &#187;';
			}
			echo '
	</div>';
		}

		if (!empty($actions))
		{
			if ($show_actions_as_buttons)
			{
				echo '
	<p class="floatright">';
				foreach ($actions as $action)
					echo '
		<input type="submit" value="', $action[0], '" onclick="', $action[1], '" class="button_submit" />';
				echo '
	</p>';
			}
			else // icon_text, icon, text.
			{
			echo '
	<ul class="reset smalltext quickbuttons floatright">';
			foreach ($actions as $action)
				echo '
		<li', !empty($action[2]) ? ' class="' . $action[2] . '"' : '', '><a href="#" onclick="', $action[1], '">', $action[0], '</a></li>';
			echo '
	</ul>';
			}
		}
	}
}

// Template for show stats.
function template_cffp_show_stats($stats, $type = '')
{
	global $txt;

	if (empty($type))
		$type = 'chart_average,chart_hbars,chart_vbars,summary';
	$type_array = explode(',', $type);

	if (WIRELESS)
	{
		if (!empty($stats['text']))
			echo '
	', template_cffp_html_to_wap($stats['text']), '<br />
	<br />';

		$chart_hvbars = false;
		foreach ($type_array as $type)
		{
			if (!empty($stats[$type]))
			{
				switch ($type)
				{
					case 'chart_average':
					{
						echo '
	', $txt['cffp_show_stats_summary_min'], ': ', comma_format($stats['min_num'], $stats['min_num'] == (int) $stats['min_num'] ? 0 : 1), '<br />
	', $txt['cffp_show_stats_summary_average'], ': ', comma_format($stats['average'], 1), '<br />
	', $txt['cffp_show_stats_summary_max'], ': ', comma_format($stats['max_num'], $stats['max_num'] == (int) $stats['max_num'] ? 0 : 1), '<br />';

						if (!empty($stats['options_text']) && $stats['chart_average']['options_text'])
							echo implode('
	<br />', $stats['options_text']), '<br />';

						echo '
	<br />';
						break;
					}
					case 'chart_hbars':
					case 'chart_vbars':
					{
						if ($chart_hvbars)
							continue;

						foreach ($stats['data'] as $value_data)
							echo '
	', $value_data['text'], ': ', comma_format($value_data['num']), ' (', comma_format($value_data['percent'], 1), '%)<br />';

						echo '
	<br />';

						$chart_hvbars = true;
						break;
					}
					case 'summary':
					{
						foreach ($stats['summary'] as $k => $summary)
						{
							if (in_array($k, array('average', 'sum')))
								$summary[1] = comma_format($summary[1], 1);
							elseif ('total' == $k)
								$summary[1] = comma_format($summary[1]);

							echo '
	', $summary[0], ': ', is_array($summary[1]) ? implode(' / ', $summary[1]) : $summary[1], '<br />';
						}

						echo '
	<br />';
						break;
					}
				}
			}
		}
	}
	else
	{
		if (!empty($stats['text']))
			echo '
	', $stats['text'];

		foreach ($type_array as $type)
		{
			if (!empty($stats[$type]))
			{
				switch ($type)
				{
					case 'chart_average':
					{
						echo '
	<div class="cffp_stats_average">
		<div class="cffp_stats_average_bar windowbg3">', !empty($stats['average']) ? '
			<div style="width: ' . 100 * $stats['average'] / ($stats['max_num'] - $stats['min_num']) . '%;"></div>' : '', '
		</div>';

						if ($stats['chart_average']['average'] || $stats['chart_average']['minmax'])
						{
							echo '
		<div class="centertext">', $stats['chart_average']['average'] ? '
			<span>' . comma_format($stats['average'], 1) . '</span>' : '', $stats['chart_average']['minmax'] ? '
			<div class="floatleft">' . comma_format($stats['min_num'], $stats['min_num'] == (int) $stats['min_num'] ? 0 : 1) . '</div>
			<div class="floatright">' . comma_format($stats['max_num'], $stats['max_num'] == (int) $stats['max_num'] ? 0 : 1) . '</div>' : '', !$stats['chart_average']['average'] ? '
			<br />' : '', '
		</div>';
						}

						if (!empty($stats['options_text']) && $stats['chart_average']['options_text'])
						{
							echo '
		<div class="smalltext">
			', implode('
			<br />', $stats['options_text']), '
		</div>';
						}

						echo '
	</div>';
						break;
					}
					case 'chart_hbars':
					{
						echo '
	<div class="cffp_stats">
		<dl class="stats">';

						foreach ($stats['data'] as $value_data)
						{
							echo '
			<dt>
				', $value_data['text'], '
			</dt>
			<dd class="statsbar">';

							if (!empty($value_data['percent']))
							{
								echo '
				<div class="bar" style="width: ', $value_data['percent'] * 2 + 4, 'px;">
					<div style="width: ', $value_data['percent'] * 2, 'px;"></div>
				</div>';
							}

							echo '
				<span class="righttext">', comma_format($value_data['num']), ' (', comma_format($value_data['percent'], 1), '%)</span>
			</dd>';
						}

						echo '
		</dl>
	</div>';
						break;
					}
					case 'chart_vbars':
					{
						echo '
	<ul class="activity_stats flow_hidden">';

						foreach ($stats['data'] as $value_data)
						{
							$title = $value_data['text'] . ': ' . comma_format($value_data['num']) . ' (' . comma_format($value_data['percent'], 1) . '%)';

							echo '
		<li', !empty($value_data['is_last']) ? ' class="last"' : '', ' style="width: ', $stats['chart_vbars']['width_category'], ';">
			<div class="bar" style="padding-top: ', 100 - $value_data['percent'], 'px;" title="', $title, '">
				<div style="height: ', $value_data['percent'], 'px;">
					<span>', $title, '</span>
				</div>
			</div>
			<div class="bar" style="width: ', $value_data['percent'] * 2 + 4, 'px;">
				<div style="width: ', $value_data['percent'] * 2, 'px;"></div>
			</div>
			<span class="stats_hour">', $stats['is_numeric'] ? comma_format((float) $value_data['value'], $value_data['value'] == (int) $value_data['value'] ? 0 : 1) : $value_data['value'], '</span>
		</li>';
						}

						echo '
	</ul>';

						if (!empty($stats['options_text']) && $stats['chart_vbars']['options_text'])
						{
							echo '
	<div class="smalltext">
		', implode('
		<br />', $stats['options_text']), '
	</div>';
						}
						break;
					}
					case 'summary':
					{
						echo '
	<div class="cffp_stats">
		<dl class="stats">';

						foreach ($stats['summary'] as $k => $summary)
						{
							if (in_array($k, array('average', 'sum')))
								$summary[1] = comma_format($summary[1], 1);
							elseif ('total' == $k)
								$summary[1] = comma_format($summary[1]);

							echo '
			<dt>
				', $summary[0], ':
			</dt>
			<dd class="statsbar">
				<span class="righttext">
					', is_array($summary[1]) ? implode('<br />
					', $summary[1]) : $summary[1], '
				</span>
			</dd>';
						}

						echo '
		</dl>
	</div>';
						break;
					}
				}
			}
		}
	}
}

// This is a special modification to the post so it will work on phones.
function template_cffp_html_to_wap($text)
{
	global $txt;

	$text = preg_replace('~<div class="(?:quote|code)header">(.+?)</div>~', '<br />--- $1 ---', $text);
	$text = strip_tags(str_replace(
		array(
			'<blockquote>',
			'</blockquote>',
			'<code>',
			'</code>',
			'<li>',
			$txt['code_select'],
		),
		array(
			'<br>',
			'<br>--- ' . $txt['wireless_end_quote'] . ' ---<br>',
			'<br>',
			'<br>--- ' . $txt['wireless_end_code'] . ' ---<br>',
			'<br>* ',
			'',
		), $text), '<br>');

	return $text;
}

// Template for list on Moderation Center.
function template_cffp_moderation_list()
{
	template_show_list('cffp_moderation_list');
}

?>