<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 1.5
 * @author davidhs
 * @copyright 2014-2017 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once (dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

if (empty($context['uninstalling']))
{
	global $db_prefix;

	db_extend('packages');

	$tables = array(
		'cffp_count_groups' => array(
			'columns' => array(
				array(
					'name' => 'id_count',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_COUNT',
				),
				array(
					'name' => 'id_member',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MEMBER',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'groups',
					'type' => 'mediumint',
					'size' => 8,
					'default' => '0',
					'unsigned' => true,
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_count'),
				),
			),
		),
		'cffp_fields' => array(
			'columns' => array(
				array(
					'name' => 'id_cffp',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_CFFP',
				),
				array(
					'name' => 'id_msg',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MSG',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'id_member',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MEMBER',
				),
				array(
					'name' => 'poster_name',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterName',
				),
				array(
					'name' => 'poster_email',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterEmail',
				),
				array(
					'name' => 'poster_ip',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterIP',
				),
				array(
					'name' => 'poster_time',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'posterTime',
				),
				array(
					'name' => 'modified_name',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'modifiedName',
				),
				array(
					'name' => 'modified_time',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'modifiedTime',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_cffp'),
				),
			),
		),
		'cffp_stats' => array(
			'columns' => array(
				array(
					'name' => 'id_stats',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_STATS',
				),
				array(
					'name' => 'id_msg',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MSG',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'data',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'options_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'is_numeric',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'average',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'sum',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'max',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'min',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'highest',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'lowest',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'most_frequent',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'least_frequent',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'total',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_stats'),
				),
			),
		),
		'cffp_settings_fields' => array(
			'columns' => array(
				array(
					'name' => 'id_field',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_FIELD',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'id_column',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
				),
				array(
					'name' => 'name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'field_desc',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_long_desc',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'field_search_desc',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_search_long_desc',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'description',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_order',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'type',
					'type' => 'varchar',
					'size' => 8,
					'default' => 'text',
				),
				array(
					'name' => 'type_filter',
					'type' => 'varchar',
					'size' => 15,
					'default' => 'text',
				),
				array(
					'name' => 'length',
					'type' => 'smallint',
					'size' => 5,
					'default' => '255',
				),
				array(
					'name' => 'options',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'options_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'mask',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'bbc',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'default_value',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'text_previous',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'text_next',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'enclose_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'enclose_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'show_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_filter_operator',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'hide_filter',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_filter_used_options',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_record_list_type',
					'type' => 'varchar',
					'size' => 5,
					'default' => 'no',
				),
				array(
					'name' => 'show_record_list_width',
					'type' => 'varchar',
					'size' => 7,
					'default' => '',
				),
				array(
					'name' => 'show_record_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_moderation_list_type',
					'type' => 'varchar',
					'size' => 5,
					'default' => 'no',
				),
				array(
					'name' => 'show_moderation_list_width',
					'type' => 'varchar',
					'size' => 7,
					'default' => '',
				),
				array(
					'name' => 'show_moderation_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'not_empty_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'unique_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'subset',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'permissions',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'active',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_field'),
				),
			),
		),
		'cffp_settings_groups' => array(
			'columns' => array(
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'description',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'group_order',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'text_input_before',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'text_input',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'text_output',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'boards',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'child_boards',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
					'null' => true,
				),
				array(
					'name' => 'type',
					'type' => 'varchar',
					'size' => 10,
					'default' => 'fields',
				),
				array(
					'name' => 'show_group_name_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_group_name_filter',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_group_name_search',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_fields_name',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_fields_set',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_empty_fields_post',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_empty_fields_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_poster_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_modified_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_actions_as',
					'type' => 'varchar',
					'size' => 10,
					'default' => 'icon_text',
				),
				array(
					'name' => 'show_member_expanded',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_data_recent',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_new',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_recent_at_top',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'member_max_height',
					'type' => 'smallint',
					'size' => 5,
					'default' => '0',
				),
				array(
					'name' => 'member_one_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_stats',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_stats_post_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_chart_average',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_chart_hbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_chart_vbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_summary',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_chart_average',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_chart_hbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_chart_vbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_summary',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_stats_order_by',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_sticky',
					'type' => 'tinyint',
					'size' => 3,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'show_locked',
					'type' => 'tinyint',
					'size' => 3,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'show_first_post_topic',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_replies_topic',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'no_show_with_subject_prefix',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'show_in_topic',
					'type' => 'varchar',
					'size' => 11,
					'default' => 'no',
				),
				array(
					'name' => 'show_filters',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'show_filters_operator',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'javascript',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'search_page_name',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'search_page_order_by',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'counter_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'counter_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'top_poster_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'top_poster_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'profile_list_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'profile_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'moderation_list_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'moderation_list_menu',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'moderation_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'moderation_list_order_by',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'permissions',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'active',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'template_quick_input_regex',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'template_quick_input_params',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'template_quick_input_help',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'template_quick_input_show_modify',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'template_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'template_text',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'template_message_index_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'template_message_index_text',
					'type' => 'text',
					'default' => '',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_group'),
				),
			),
		),
	);

	$current_tables = $smcFunc['db_list_tables'](false, '%cffp%');
	$real_prefix = preg_match('~^(`?)(.+?)\\1\\.(.*?)$~', $db_prefix, $match) === 1 ? $match[3] : $db_prefix;

	// Loop through each table and do what needed.
	$delete_stats = false;
	$cffp_stats_columns = in_array(strtolower($real_prefix . 'cffp_stats'), array_map('strtolower', $current_tables)) ? $smcFunc['db_list_columns']('{db_prefix}cffp_stats') : array();
	foreach ($tables as $table => $data)
	{
		if (in_array(strtolower($real_prefix . $table), array_map('strtolower', $current_tables)))
		{
			foreach ($data['columns'] as $column)
			{
				if (!isset($column['deprecated_name']) || !$smcFunc['db_change_column']('{db_prefix}' . $table, $column['deprecated_name'], $column))
				{
					$smcFunc['db_add_column']('{db_prefix}' . $table, $column);

					if (!empty($cffp_stats_columns) && !$delete_stats && 'cffp_stats' == $table && !in_array($column['name'], $cffp_stats_columns))
						$delete_stats = true;
				}
			}
			foreach ($data['indexes'] as $index)
				$smcFunc['db_add_index']('{db_prefix}' . $table, $index, array(), 'ignore');
		}
		else
			$smcFunc['db_create_table']('{db_prefix}' . $table, $data['columns'], $data['indexes'], array(), 'ignore');
	}

	// Remove deprecated columns.
	$deprecated_columns = array(
		'cffp_settings_fields' => array(
			'filter_message_index', // From 1.0 to 1.1.
		),
	);
	foreach ($deprecated_columns as $table => $columns)
	{
		if (in_array(strtolower($real_prefix . $table), array_map('strtolower', $current_tables)))
		{
			foreach ($columns as $name_field)
				$smcFunc['db_remove_column']('{db_prefix}' . $table, $name_field);
		}
	}

	// Deletes statistics.
	if ($delete_stats)
		$smcFunc['db_query']('', '
			TRUNCATE TABLE {db_prefix}cffp_stats'
		);

}

?>