<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 1.5
 * @author davidhs
 * @copyright 2014-2017 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Returns boards and children boards.
function cffpAddChildrenBoards($board_array, $child_boards)
{
	global $db_prefix;

	if ((!is_numeric($child_boards) || !empty($child_boards)) && !empty($board_array))
	{
		$request = db_query("
			SELECT ID_BOARD
			FROM {$db_prefix}boards
			WHERE ID_PARENT IN (" . implode(', ', $board_array) . ")", __FILE__, __LINE__);
		$child_array = array();
		while ($row = mysql_fetch_assoc($request))
			$child_array[] = $row['ID_BOARD'];
		mysql_free_result($request);

		if (is_numeric($child_boards))
			$child_boards--;
		$child_array = cffpAddChildrenBoards($child_array, $child_boards);
		$board_array = array_merge($board_array, $child_array);
	}
	return $board_array;
}

// Edits custom post fields of a group type.
function cffpEditGroup()
{
	global $context, $db_prefix, $func, $txt;

	loadTemplate('CustomFieldFilterPost');

	if (empty($_GET['ID_MSG']) || empty($_GET['ID_GROUP']) || !isset($_GET['board']))
		fatal_lang_error('error_cffp_params');

	// Sort out the context!
	$context['start'] = (int) $_GET['start'];
	$context['ID_MSG'] = (int) $_GET['ID_MSG'];
	$context['ID_GROUP'] = (int) $_GET['ID_GROUP'];
	$context['board'] = (int) $_GET['board'];
	$context['ID_CFFP'] = !empty($_GET['ID_CFFP']) ? (int) $_GET['ID_CFFP'] : 0;

	$request = db_query("
		SELECT " . implode(', ', $context['cffp']['list_columns']['fields']) . "
		FROM {$db_prefix}cffp_fields
		WHERE ID_CFFP = " . $context['ID_CFFP'], __FILE__, __LINE__);
	$fields_value = mysql_fetch_assoc($request);
	mysql_free_result($request);

	$user = cffpGetTypeUser();
	$owner = cffpIsOwner(empty($context['ID_CFFP']), !empty($fields_value) ? $fields_value['ID_MEMBER'] : $context['user']['id']);

	$data_msg = cffpGetDataMsgTopic($context['ID_MSG']);
	$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, $context['ID_GROUP'], 'edit', $context['board'], $user, $owner);
	if (empty($group_array))
		fatal_lang_error('error_cffp_params');

	$context['params']['group'] = $group_array[$context['ID_GROUP']];

	if (isset($_GET['move_to_post']))
		$title = 'no' == $context['params']['group']['show_in_topic'] ? $txt['cffp_move_group_to_other_post'] : $txt['cffp_move_group_to_other_topic'];
	else
		$title = $txt['cffp_edit_group'];

	$context['page_title'] = sprintf($title, $context['params']['group']['name']);
	$context['sub_template'] = isset($_GET['move_to_post']) ? 'cffp_move_group' : 'cffp_edit_group';

	foreach ($context['params']['group']['settings_fields'] as $row)
	{
		$name_field = 'column_' . $row['id_column'];
		$value = isset($fields_value[$name_field]) ? $fields_value[$name_field] : '';

		$row['show_filter_used_options'] = 0;
		$context['params']['field_array'][$row['ID_FIELD']] = array(
			'name' => $row['name'],
			'field_desc' => $row['field_desc'],
			'field_long_desc' => parse_bbc(censorText($row['field_long_desc'])),
			'html' => cffpHtmlOfField($row, $value, false, $context['ID_GROUP'], $name_field),
		);
	}

	// Are we saving?
	if ((isset($_POST['save']) && cffpHavePermission($user, $owner, 'modify', $context['params']['group']['permissions'])) || (isset($_GET['add']) && cffpHavePermission($user, $owner, 'add', $context['params']['group']['permissions'])))
	{
		checkSession('get');

		// Validate inputs.
		if (isset($_GET['add']))
		{
			$infix = $context['ID_MSG'] . '_group' . $context['ID_GROUP'];
			$_REQUEST['cffp'] = array($context['ID_GROUP'] => $_REQUEST['cffp'][$infix]);
		}

		$post_errors = cffpValidateRequest('member', 0, 'return_post_errors');

		if ($post_errors)
		{
			loadLanguage('Errors');

			$error = array();
			foreach ($post_errors as $post_error)
			{
				if ('cffp_' == substr($post_error, 0, 5))
				{
					list ($post_error2, ) = explode(',', $post_error);
					$eval = '$txt[\'error_' . $post_error . '\'] = sprintf($txt[\'error_' . $post_error2 . '\'], \'' . implode('\', \'', $context['cffp']['validate'][$post_error]) . '\');';
					eval($eval);
				}
				$error[] = $txt['error_' . $post_error];
			}
			$txt['error_cffp_all_txt'] = implode('<br />', $error);
			fatal_lang_error('error_cffp_all_txt');
		}

		// Do the insertion/updates.
		if (isset($_GET['add']))
			$context['ID_CFFP'] = cffpInsertFields('member', $context['ID_MSG'], $context['ID_GROUP'], $context['params']['group']['settings_fields']);
		else
			cffpUpdateFields($context['ID_CFFP'], $context['ID_GROUP'], $context['params']['group']['settings_fields']);

		if ('member' == $context['params']['group']['type'])
			cffpUpdateStats($context['ID_GROUP'], $context['ID_MSG']);
	}
	// Deleting?
	elseif (isset($_GET['delete']) && cffpHavePermission($user, $owner, 'remove', $context['params']['group']['permissions']) && $context['ID_CFFP'])
	{
		checkSession('get');

		cffpDeleteFields($context['ID_CFFP']);

		if ('member' == $context['params']['group']['type'])
			cffpUpdateStats($context['ID_GROUP'], $context['ID_MSG']);
	}
	// Moving?
	elseif (isset($_REQUEST['move']) && cffpHavePermission($user, $owner, 'move', $context['params']['group']['permissions']) && $context['ID_MSG'] && $context['ID_GROUP'])
	{
		checkSession('get');

		if (isset($_POST['msg_to']))
		{
			$msg_to = (int) $_POST['msg_to'];

			if ('no' != $context['params']['group']['show_in_topic'])
			{
				$request = db_query("
					SELECT ID_FIRST_MSG
					FROM {$db_prefix}topics
					WHERE ID_TOPIC = $msg_to", __FILE__, __LINE__);
				$row = mysql_fetch_assoc($request);
				mysql_free_result($request);

				if ($row)
					$msg_to = $row['ID_FIRST_MSG'];
				else
					fatal_lang_error('error_cffp_move_missing_topic');
			}

			$request = db_query("
				SELECT ID_BOARD
				FROM {$db_prefix}messages
				WHERE ID_MSG = $msg_to", __FILE__, __LINE__);
			$row = mysql_fetch_assoc($request);
			mysql_free_result($request);

			if ($row)
			{
				if (!cffpIsGroupAllowInBoard($context['params']['group']['boards'], $context['params']['group']['child_boards'], $row['ID_BOARD']))
					fatal_lang_error('no' == $context['params']['group']['show_in_topic'] ? 'error_cffp_move_board_post_not_allowed' : 'error_cffp_move_board_topic_not_allowed');
			}
			else
				fatal_lang_error('error_cffp_move_missing_post');
		}
		else
		{
			$request = db_query("
				SELECT t.ID_FIRST_MSG
				FROM {$db_prefix}messages AS m
					INNER JOIN {$db_prefix}topics AS t ON (t.ID_TOPIC = m.ID_TOPIC)
				WHERE m.ID_MSG = " . $context['ID_MSG'], __FILE__, __LINE__);
			$row = mysql_fetch_assoc($request);
			mysql_free_result($request);

			$msg_to = $row ? $row['ID_FIRST_MSG'] : 0;
		}

		if ($msg_to && $msg_to != $context['ID_MSG'])
		{
			$data_msg_to = cffpGetDataMsgTopic($msg_to);
			$error_cffp_move_not_allowed = 'no' == $context['params']['group']['show_in_topic'] ? 'error_cffp_move_post_not_allowed' : 'error_cffp_move_topic_not_allowed';

			if (is_numeric($context['params']['group']['show_sticky']) && $context['params']['group']['show_sticky'] != $data_msg_to['sticky'])
				fatal_lang_error($error_cffp_move_not_allowed);

			if (is_numeric($context['params']['group']['show_locked']) && $context['params']['group']['show_locked'] != $data_msg_to['locked'])
				fatal_lang_error($error_cffp_move_not_allowed);

			if (!$context['params']['group']['show_first_post_topic'] && $data_msg_to['first_msg'])
				fatal_lang_error($error_cffp_move_not_allowed);

			if (!$context['params']['group']['show_replies_topic'] && !$data_msg_to['first_msg'])
				fatal_lang_error($error_cffp_move_not_allowed);

			if (!empty($context['params']['group']['no_show_with_subject_prefix']))
			{
				$subject_prefix = explode(',', $context['params']['group']['no_show_with_subject_prefix']);
				foreach ($subject_prefix as $pre)
				{
					if (0 === $func['strpos']($data_msg_to['subject'], $pre))
						fatal_lang_error($error_cffp_move_not_allowed);
				}
			}

			if ('member' == $context['params']['group']['type'])
			{
				if ($context['params']['group']['member_one_value'] && !empty($fields_value['ID_MEMBER']))
				{
					$request = db_query("
						SELECT ID_CFFP
						FROM {$db_prefix}cffp_fields
						WHERE ID_MSG = $msg_to
							AND ID_GROUP = " . $context['ID_GROUP'] . "
							AND ID_MEMBER = " . $fields_value['ID_MEMBER'], __FILE__, __LINE__);
					$num_rows = mysql_num_rows($request);
					mysql_free_result($request);

					if (0 < $num_rows)
					{
						$error_cffp_move_already_has_data = 'no' == $context['params']['group']['show_in_topic'] ? 'error_cffp_move_post_already_has_data' : 'error_cffp_move_topic_already_has_data';
						fatal_lang_error($error_cffp_move_already_has_data);
					}
				}
			}
			else
			{
				$request = db_query("
					SELECT ID_CFFP
					FROM {$db_prefix}cffp_fields
					WHERE ID_MSG = $msg_to
						AND ID_GROUP = " . $context['ID_GROUP'], __FILE__, __LINE__);
				$num_rows = mysql_num_rows($request);
				mysql_free_result($request);

				if (0 < $num_rows)
					fatal_lang_error('error_cffp_move_already_has_data');
			}

			cffpMoveFields($context['ID_GROUP'], $context['ID_CFFP'], $context['ID_MSG'], $msg_to);

			if ('member' == $context['params']['group']['type'])
			{
				cffpUpdateStats($context['ID_GROUP'], $context['ID_MSG']);
				cffpUpdateStats($context['ID_GROUP'], $msg_to);
			}
		}
	}

	if (isset($_GET['delete']) || isset($_GET['add']) || isset($_POST['save']) || isset($_REQUEST['move']))
	{
		checkSession('get');

		$request = db_query("
			SELECT ID_TOPIC
			FROM {$db_prefix}messages
			WHERE ID_MSG = " . $context['ID_MSG'], __FILE__, __LINE__);
		$row = mysql_fetch_assoc($request);
		mysql_free_result($request);

		if ('member' == $context['params']['group']['type'])
		{
			$page = 'no' == $context['params']['group']['show_in_topic'] ? '.msg' . $context['ID_MSG'] : '.' . $context['start'];
			$params = ';cffp_show=' . $context['ID_MSG'] . ',' . $context['ID_GROUP'] . '#cffp' . (isset($_GET['delete']) || isset($_REQUEST['move']) ? '_msg' . $context['ID_MSG'] . '_group' . $context['ID_GROUP'] : $context['ID_CFFP']);
		}
		else
		{
			$page = '.msg' . $context['ID_MSG'];
			$params = '#msg' . $context['ID_MSG'];
		}

		redirectexit('topic=' . $row['ID_TOPIC'] . $page . $params);
	}
}

// Gets data of message and topic.
function cffpGetDataMsgTopic($id_msg = 0, $id_topic = 0)
{
	global $context;

	if (!empty($id_msg))
	{
		if (!isset($context['cffp']['data_msg_topic'][$id_msg]))
			cffpLoadDataMsgTopic($id_msg);
		$data = $context['cffp']['data_msg_topic'][$id_msg];
	}
	elseif (!empty($id_topic))
	{
		if (!isset($context['cffp']['data_msg_topic']['topic_' . $id_topic]))
			cffpLoadDataMsgTopic(array(), $id_topic);
		$data = $context['cffp']['data_msg_topic']['topic_' . $id_topic];
	}
	else
		$data = $context['cffp']['data_msg_topic']['topic_new'];

	return $data;
}

// Gets groups and fields of each group.
function cffpGetGroupsAndFieldsOfGroup($data_msg, $id_group, $cffp_action, $current_board = 0, $user = '', $owner = false, $search_page_name = false, $only_type_array = array())
{
	global $context, $func, $txt;

	// Filter by group.
	if (empty($id_group))
		$group_array = $context['cffp']['settings_groups'];
	elseif (is_array($id_group))
	{
		$group_array = array();
		foreach ($context['cffp']['settings_groups'] as $id => $settings_group)
		{
			if (in_array($id, $id_group))
				$group_array[$id] = $settings_group;
		}
	}
	else // Integer.
		$group_array = array($id_group => $context['cffp']['settings_groups'][$id_group]);

	// More filters.
	$filters = false;
	$user_gr = $user;
	$owner_gr = $owner;
	$show_in_topic = '';
	if ('search_posts' != $cffp_action)
		$search_page_name = false;

	$action_message_index = 'message_index' == substr($cffp_action, 0, 13);
	$action_search = 'search' == substr($cffp_action, 0, 6);
	$action_readonly = '_readonly' == substr($cffp_action, -9);
	$action_display_member_topic = 'display_member_topic_' == substr($cffp_action, 0, 21);

	switch ($cffp_action)
	{
		case 'display':
		case 'display_readonly':
		case 'message_index':
		{
			$type_array = array('fields', 'record');
			$perm_group_array = array('view');
			$perm_field_array = array('view');
			break;
		}
		case 'display_member':
		case 'display_member_topic_begin_all':
		case 'display_member_topic_end_all':
		case 'display_member_topic_begin_first':
		case 'display_member_topic_end_first':
		{
			$type_array = array('member');
			$user_gr = '';
			$owner_gr = false;
			$perm_group_array = array('view', 'stats', 'add', 'modify', 'remove');
			$perm_field_array = array('view');

			if ($action_display_member_topic)
				$show_in_topic = substr($cffp_action, 21);
			else
				$show_in_topic = 'no';
			break;
		}
		case 'display_member_readonly':
		case 'display_member_topic_begin_all_readonly':
		case 'display_member_topic_end_all_readonly':
		case 'display_member_topic_begin_first_readonly':
		case 'display_member_topic_end_first_readonly':
		case 'message_index_member':
		{
			$type_array = array('member');
			$user_gr = '';
			$owner_gr = false;
			$perm_group_array = array('view', 'stats');
			$perm_field_array = array('view');

			if ($action_display_member_topic)
				$show_in_topic = substr($cffp_action, 21, -9);
			elseif ('display_member_readonly' == $cffp_action)
				$show_in_topic = 'no';
			break;
		}
		case 'post':
		{
			$type_array = array('fields', 'record');
			$perm_group_array = array('add', 'modify', 'remove');
			$perm_field_array = array('view');
			break;
		}
		case 'edit':
		{
			$type_array = array('fields', 'record', 'member');
			$perm_group_array = array('add', 'modify', 'remove', 'move');
			$perm_field_array = array('view');
			break;
		}
		case 'order_by':
		{
			$type_array = array('fields', 'record', 'member');
			$perm_group_array = array('view', 'stats');
			$perm_field_array = array('sort');
			break;
		}
		case 'filters':
		{
			$type_array = array('fields', 'record', 'member');
			$filters = true;
			$perm_group_array = array('view');
			$perm_field_array = array('filter');
			break;
		}
		case 'search_posts':
		case 'search_posts_menu':
		{
			$type_array = array('fields', 'member');
			$filters = true;
			$perm_group_array = array('search');
			$perm_field_array = array('search');
			break;
		}
		case 'search_records':
		case 'search_records_menu':
		{
			$type_array = array('record');
			$perm_group_array = array('search');
			$perm_field_array = array('search');
			break;
		}
	}

	if (!empty($only_type_array))
		$type_array = array_intersect($type_array, $only_type_array);

	foreach ($group_array as $id_group => $settings_group)
	{
		if (!(in_array($settings_group['type'], $type_array) || ($filters && 'filters' == $settings_group['type'] && !empty($settings_group['show_filters']))))
		{
			unset($group_array[$id_group]);
			continue;
		}

		if (!cffpHavePermission($user_gr, $owner_gr, $perm_group_array, $settings_group['permissions']))
		{
			unset($group_array[$id_group]);
			continue;
		}

		if (!empty($show_in_topic) && $show_in_topic != $settings_group['show_in_topic'])
		{
			unset($group_array[$id_group]);
			continue;
		}

		if (is_string($search_page_name))
		{
			if (cffpIsNotEmptyString($search_page_name) xor cffpIsNotEmptyString($settings_group['search_page_name']))
			{
				unset($group_array[$id_group]);
				continue;
			}
			elseif (cffpIsNotEmptyString($search_page_name) && cffpIsNotEmptyString($settings_group['search_page_name']))
			{
				$search_page_name_array = explode(',', $settings_group['search_page_name']);
				if (!in_array($search_page_name, $search_page_name_array))
				{
					unset($group_array[$id_group]);
					continue;
				}
			}
		}

		if ($action_search)
		{
			if (empty($settings_group['boards']))
			{
				unset($group_array[$id_group]);
				continue;
			}
		}
		else
		{
			if (!('all' === $current_board) && !cffpIsGroupAllowInBoard($settings_group['boards'], $settings_group['child_boards'], $current_board))
			{
				unset($group_array[$id_group]);
				continue;
			}

			if ('filters' != $cffp_action && 'filters' != $settings_group['type'] && !empty($data_msg))
			{
				if (is_numeric($data_msg['sticky']) && is_numeric($settings_group['show_sticky']) && $settings_group['show_sticky'] != $data_msg['sticky'])
				{
					unset($group_array[$id_group]);
					continue;
				}

				if (is_numeric($data_msg['locked']) && is_numeric($settings_group['show_locked']) && $settings_group['show_locked'] != $data_msg['locked'])
				{
					unset($group_array[$id_group]);
					continue;
				}

				if (is_numeric($data_msg['first_msg']))
				{
					if (empty($settings_group['show_first_post_topic']) && $data_msg['first_msg'])
					{
						unset($group_array[$id_group]);
						continue;
					}

					if (empty($settings_group['show_replies_topic']) && !$data_msg['first_msg'])
					{
						unset($group_array[$id_group]);
						continue;
					}
				}

				if ('post' != $cffp_action && 0 < strlen($data_msg['subject']) && !empty($settings_group['no_show_with_subject_prefix']))
				{
					$subject_prefix = explode(',', $settings_group['no_show_with_subject_prefix']);
					foreach ($subject_prefix as $pre)
					{
						if (0 === $func['strpos']($data_msg['subject'], $pre))
						{
							unset($group_array[$id_group]);
							continue 2; // Exit foreach $subject_prefix and continue foreach $group_array.
						}
					}
				}
			}
		}

		if ('filters' == $settings_group['type'])
		{
			$settings_filters = cffpGetSettingsPredefinedFilters();
			$filters = explode(',', $settings_group['show_filters']);
			$show_filters_operator = explode(',', $settings_group['show_filters_operator']);

			foreach ($filters as $filter)
			{
				$group_array[$id_group]['settings_fields'][$filter] = $settings_filters[$filter];
				$group_array[$id_group]['settings_fields'][$filter]['show_filter_operator'] = in_array($filter, $show_filters_operator) ? 1 : 0;
			}
		}
		else
		{
			foreach ($settings_group['settings_fields'] as $id_field => $settings_field)
			{
				if ($action_message_index && !$settings_field['show_message_index'])
				{
					unset($group_array[$id_group]['settings_fields'][$id_field]);
					continue;
				}

				if (!cffpHavePermission($user_gr, $owner_gr, $perm_field_array, $settings_field['permissions']))
				{
					unset($group_array[$id_group]['settings_fields'][$id_field]);
					continue;
				}

				if ($user)
					$group_array[$id_group]['settings_fields'][$id_field]['can_view'] = cffpHavePermission($user, $owner, 'view', $settings_field['permissions']);
			}

			if (empty($group_array[$id_group]['settings_fields']) && ('order_by' == $cffp_action || !in_array('stats', $perm_group_array)))
			{
				unset($group_array[$id_group]);
				continue;
			}
		}

		if (!empty($settings_group['text_input_before']))
			$group_array[$id_group]['text_input_before'] = parse_bbc(censorText($settings_group['text_input_before']));
		if (!empty($settings_group['text_input']))
			$group_array[$id_group]['text_input'] = parse_bbc(censorText($settings_group['text_input']));
		if (!empty($settings_group['text_output']))
			$group_array[$id_group]['text_output'] = parse_bbc(censorText($settings_group['text_output']));
		if (!empty($settings_group['show_stats_post_text']))
			$group_array[$id_group]['show_stats_post_text'] = parse_bbc(censorText($settings_group['show_stats_post_text']));
		if (!empty($settings_group['show_stats_message_index_text']))
			$group_array[$id_group]['show_stats_message_index_text'] = parse_bbc(censorText($settings_group['show_stats_message_index_text']));

		if (!empty($settings_group['template_quick_input_regex']))
		{
			if (!empty($settings_group['template_quick_input_help']))
				$group_array[$id_group]['template_quick_input_help'] = parse_bbc(censorText($settings_group['template_quick_input_help']));
			else
			{
				$bbc = '[code]' . $group_array[$id_group]['template_quick_input_regex'] . '[/code]';
				$group_array[$id_group]['template_quick_input_help'] =
					'<span class="smalltext">' . $txt['cffp_quick_input_field_desc'] . '</span><br />' .
					parse_bbc(censorText($bbc));
			}
		}

		if ($user)
		{
			$group_array[$id_group]['can_view'] = cffpHavePermission($user, $owner, 'view', $settings_group['permissions']);
			$group_array[$id_group]['can_add'] = !$action_readonly && cffpHavePermission($user, $owner, 'add', $settings_group['permissions']);
			$group_array[$id_group]['can_modify'] = !$action_readonly && cffpHavePermission($user, $owner, 'modify', $settings_group['permissions']);
			$group_array[$id_group]['can_remove'] = !$action_readonly && cffpHavePermission($user, $owner, 'remove', $settings_group['permissions']);
			$group_array[$id_group]['can_move'] = !$action_readonly && cffpHavePermission($user, $owner, 'move', $settings_group['permissions']);
		}

		if ('search_records' == $cffp_action)
		{
			$show_record_list = array();
			$column_list = array();
			foreach ($context['cffp']['settings_groups'][$id_group]['settings_fields'] as $id_field => $settings_field)
			{
				if ('no' == $settings_field['show_record_list_type'] || !cffpHavePermission($user, $owner, 'view', $settings_field['permissions']))
					continue;

				$settings_field2 = array(
					'ID_FIELD' => $settings_field['ID_FIELD'],
					'id_column' => $settings_field['id_column'],
					'show_record_list_type' => $settings_field['show_record_list_type'],
					'show_record_list_width' => $settings_field['show_record_list_width'],
					'show_record_list_name' => $settings_field['show_record_list_name'],
				);
				if ('multi' == $settings_field['show_record_list_type'])
				{
					$column = (!empty($settings_field['show_record_list_width']) ? $settings_field['show_record_list_width'] : 'auto') . ',' . $settings_field['show_record_list_name'];
					if (!isset($column_list[$column]))
					{
						$column_list[$column] = 'column_' . $settings_field['id_column'];
						$show_record_list[$column_list[$column]] = array($settings_field2, array());
					}
					$show_record_list[$column_list[$column]][1][] = $settings_field['ID_FIELD'];
				}
				else // one.
					$show_record_list[$settings_field['ID_FIELD']] = $settings_field2;
			}
			$group_array[$id_group]['show_record_list'] = $show_record_list;
		}
	}

	return $group_array;
}

// Gets list of search posts.
function cffpGetListSearchPosts($start, $items_per_page, $sort)
{
	global $context;

	if (!is_numeric($start) || empty($items_per_page) || empty($sort))
		return false;

	$params = cffpGetSqlSearch('search_posts');

	$request = db_query("
		SELECT DISTINCT
			t.isSticky, t.locked, t.ID_FIRST_MSG,
			m.ID_MSG, m.ID_TOPIC, m.ID_BOARD, m.posterTime, m.subject, m.icon,
			m.posterName, m.ID_MEMBER,
			IFNULL(mem.realName, m.posterName) AS display_name,
			(IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) < m.ID_MSG) AS new
		FROM " . $params['from'] . (!empty($params['cond']) ? "
		WHERE " . $params['cond'] : '') . "
		ORDER BY $sort
		LIMIT $start, $items_per_page", __FILE__, __LINE__);
	$list = array();
	$id_msg_array = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$list[] = $row;

		$id_msg_array[] = $row['ID_MSG'];
		$context['cffp']['data_msg_topic'][$row['ID_MSG']] = array(
			'sticky' => $row['isSticky'] ? 1 : 0,
			'locked' => $row['locked'] ? 1 : 0,
			'id_msg' => $row['ID_MSG'],
			'first_msg' => $row['ID_MSG'] == $row['ID_FIRST_MSG'] ? 1 : 0,
			'subject' => $row['subject'],
		);
	}
	mysql_free_result($request);

	cffpLoadValueOfFieldsByMsg($id_msg_array);

	return $list;
}

// Gets size of list of search posts.
function cffpGetListSearchPostsSize()
{
	$params = cffpGetSqlSearch('search_posts');

	$request = db_query("
		SELECT COUNT(DISTINCT m.ID_MSG)
		FROM " . $params['from'] . (!empty($params['cond']) ? "
		WHERE " . $params['cond'] : ''), __FILE__, __LINE__);

	list ($size) = mysql_fetch_row($request);
	mysql_free_result($request);

	return $size;
}

// Gets list of search records.
function cffpGetListSearchRecords($start, $items_per_page, $sort)
{
	global $context;

	if (!is_numeric($start) || empty($items_per_page) || empty($sort))
		return false;

	$params = cffpGetSqlSearch('search_records');

	$attr = '';
	foreach ($context['cffp']['settings_groups'][$context['ID_GROUP']]['settings_fields'] as $settings_fields)
	{
		if ('no' != $settings_fields['show_record_list_type'])
			$attr .= ', cffpf0.column_' . $settings_fields['id_column'];
	}

	$request = db_query("
		SELECT DISTINCT
			cffpf0.ID_MSG, cffpf0.ID_MEMBER, cffpf0.posterTime,
			m.icon, m.ID_TOPIC,
			IFNULL(mem.realName, cffpf0.posterName) AS display_name$attr
		FROM " . $params['from'] . "
		WHERE " . $params['cond'] . "
		ORDER BY $sort
		LIMIT $start, $items_per_page", __FILE__, __LINE__);
	$list = array();
	while ($row = mysql_fetch_assoc($request))
		$list[] = $row;
	mysql_free_result($request);

	return $list;
}

// Gets size of list of search records.
function cffpGetListSearchRecordsSize()
{
	$params = cffpGetSqlSearch('search_records');

	$request = db_query("
		SELECT COUNT(DISTINCT cffpf0.ID_CFFP)
		FROM " . $params['from'] . "
		WHERE " . $params['cond'], __FILE__, __LINE__);

	list ($size) = mysql_fetch_row($request);
	mysql_free_result($request);

	return $size;
}

// Gets options of combobox.
function cffpGetOptionsCombobox($id_group, $name_field, $option_array = array())
{
	global $db_prefix, $context, $txt;

	if (empty($id_group) || empty($name_field))
		return false;

	if (!isset($context['cffp']['options_combobox'][$id_group][$name_field]))
	{
		$option_array2 = array();

		// Get options with one or more than one values.
		$request = db_query("
			SELECT DISTINCT $name_field
			FROM {$db_prefix}cffp_fields
			WHERE ID_GROUP = $id_group
				AND $name_field <> ''", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			if (strpos($row[$name_field], ','))
				$option_array2 = array_merge($option_array2, explode(',', $row[$name_field]));
			else
				$option_array2[] = $row[$name_field];
		}
		mysql_free_result($request);

		// Remove duplicate options.
		$option_array2 = array_unique($option_array2);
		sort($option_array2);

		$context['cffp']['options_combobox'][$id_group][$name_field] = $option_array2;
	}

	$add_empty_value = !empty($option_array) && strtr($txt['cffp_field_empty_value'], array(',' => '')) == $option_array[0];
	if ($add_empty_value)
		array_shift($option_array);
	$option_array = array_merge($option_array, $context['cffp']['options_combobox'][$id_group][$name_field]);

	// Remove duplicate options.
	$option_array = array_unique($option_array);
	sort($option_array);

	if ($add_empty_value)
		array_unshift($option_array, strtr($txt['cffp_field_empty_value'], array(',' => '')));

	return $option_array;
}

// Gets options used of select or combobox.
function cffpGetOptionsUsed($id_group, $name_field, $board, $add_empty_value = false)
{
	global $db_prefix, $context, $txt;

	if (empty($id_group) || empty($name_field) || empty($board))
		return false;

	if (!isset($context['cffp']['options_used'][$id_group][$name_field][$board]))
	{
		$option_array = array();

		// Get options with one or more than one values.
		$request = db_query("
			SELECT DISTINCT $name_field
			FROM {$db_prefix}cffp_fields as cffpf
				INNER JOIN {$db_prefix}messages AS m ON (m.ID_MSG = cffpf.ID_MSG)
			WHERE ID_GROUP = $id_group
				AND ID_BOARD = $board
				AND $name_field <> ''", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			if (strpos($row[$name_field], ','))
				$option_array = array_merge($option_array, explode(',', $row[$name_field]));
			else
				$option_array[] = $row[$name_field];
		}
		mysql_free_result($request);

		// Remove duplicate options.
		$option_array = array_unique($option_array);
		sort($option_array);

		$context['cffp']['options_used'][$id_group][$name_field][$board] = $option_array;
	}

	$option_array = $context['cffp']['options_used'][$id_group][$name_field][$board];
	if ($add_empty_value)
		array_unshift($option_array, strtr($txt['cffp_field_empty_value'], array(',' => '')));

	return $option_array;
}

// Gets value of field on $_REQUEST['cffp'][$id_group] array.
function cffpGetRequestValueOfField($id_group, $name_field, $type, $length, $options, $default_value = '')
{
	global $func;

	if (empty($id_group) || empty($name_field))
		return false;

	if (isset($_REQUEST['cffp'][$id_group]))
	{
		$value = isset($_REQUEST['cffp'][$id_group][$name_field]) ? $_REQUEST['cffp'][$id_group][$name_field] : '';
		if (is_array($value))
			$value = implode(',', $value);
		$value = $func['htmlspecialchars']($value, ENT_QUOTES);

		if ($type == 'boolean')
			$value = !empty($value) ? 1 : 0;
		elseif (cffpIsNotEmptyString($value))
		{
			switch ($type)
			{
				case 'text':
				case 'textarea':
				{
					if ($length)
						$value = $func['substr']($value, 0, $length);
					break;
				}
				case 'combobox':
				{
					list ($select_multiple, ) = explode(',', $options);
					if ($select_multiple)
					{
						$value_array = explode(',', $value);
						$value2_array = array();
						foreach ($value_array as $v)
						{
							$v = trim($v);
							if (cffpIsNotEmptyString($v))
							{
								if ($length)
									$v = $func['substr']($v, 0, $length);
								$value2_array[] = $v;
							}
						}
						$value = implode(',', array_unique($value2_array));
					}
					else
					{
						$value = strtr($value, array(',' => ''));
						$value = trim($value);
						if ($length)
							$value = $func['substr']($value, 0, $length);
					}
					break;
				}
			}
		}
	}
	else
		$value = $default_value;

	return $value;
}

// Gets filter operator on $_REQUEST['cffp_operator'][$id_group] array.
function cffpGetRequestFilterOperator($id_group, $name_field, $type)
{
	if (empty($id_group) || empty($name_field) || empty($type) || 'empty_non_empty' == $type)
		return false;

	if (in_array($name_field, array('date_topic', 'date_replies')))
		$default_operator = '<=';
	elseif ('subject_start' == $name_field || 'select' == $type)
		$default_operator = '=';
	else
		$default_operator = 'LIKE';

	return isset($_REQUEST['cffp_operator'][$id_group][$name_field]) ? $_REQUEST['cffp_operator'][$id_group][$name_field] : $default_operator;
}

// Gets settings for predefined filters.
function cffpGetSettingsPredefinedFilters()
{
	global $txt, $user_info, $board;

	$settings_filters = array();

	$settings_filters['boards'] = array(
		'id' => 'boards',
		'name' => array('', $txt['cffp_show_filters_boards']),
		'field' => array('', 'm.ID_BOARD'),
		'table_as' => array(array(), array('m')),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '1,5',
		'options_text' => '',
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 0,
	);

	$data_msg = array(
		'sticky' => null,
		'locked' => null,
		'ID_MSG' => null,
		'first_msg' => 1,
		'subject' => '',
	);
	$user = cffpGetTypeUser();
	$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, 0, 'message_index', 'all', $user, true, false, array('record'));
	foreach ($group_array as $group)
		$settings_filters['record_' . $group['ID_GROUP']] = array(
			'id' => 'record_' . $group['ID_GROUP'],
			'name' => array($group['name'], $group['name']),
			'field' => array('cffpf' . $group['ID_GROUP'] . '.ID_GROUP', 'cffpf' . $group['ID_GROUP'] . '.ID_GROUP'),
			'table_as' => array(array(), array()),
			'type' => 'select',
			'size' => 0,
			'length' => 0,
			'options' => '0,1,1,0',
			'options_text' => strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => '')),
			'mask' => '',
			'subset' => '',
			'text_previous' => '',
			'text_next' => '',
			'show_filter_operator' => 0,
		);

	$settings_filters['subject'] = array(
		'id' => 'subject',
		'name' => array($txt[70], $txt[70]),
		'field' => array('mf.subject', 'm.subject'),
		'table_as' => array(array('mf'), array('m')),
		'type' => 'text',
		'size' => 15,
		'length' => 0,
		'options' => '',
		'options_text' => '',
		'mask' => 'nohtml',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['subject_start'] = array(
		'id' => 'subject_start',
		'name' => array($txt['cffp_show_filters_subject_start'], $txt['cffp_show_filters_subject_start']),
		'field' => array('mf.subject', 'm.subject'),
		'table_as' => array(array('mf'), array('m')),
		'type' => 'text',
		'size' => 15,
		'length' => 0,
		'options' => '',
		'options_text' => '',
		'mask' => 'nohtml',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$options = '0,1,symbol,number';
	$options_text = strtr($txt['cffp_symbol'], array(',' => '')) . ',' . strtr($txt['cffp_number'], array(',' => ''));
	if (!empty($txt['cffp_alphabet_letters']))
	{
		$options .= ',' . $txt['cffp_alphabet_letters'];
		$options_text .= ',' . $txt['cffp_alphabet_letters'];
	}
	$settings_filters['subject_first_char'] = array(
		'id' => 'subject_first_char',
		'name' => array($txt['cffp_show_filters_subject_first_char'], $txt['cffp_show_filters_subject_first_char']),
		'field' => array('mf.subject', 'm.subject'),
		'table_as' => array(array('mf'), array('m')),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => $options,
		'options_text' => $options_text,
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['date_topic'] = array(
		'id' => 'date_topic',
		'name' => array($txt['cffp_show_filters_date_topic'], $txt['cffp_poster_time']),
		'field' => array('mf.posterTime', 'm.posterTime'),
		'table_as' => array(array('mf'), array('m')),
		'type' => 'text',
		'size' => 4,
		'length' => 0,
		'options' => '',
		'options_text' => '',
		'mask' => 'number',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['date_replies'] = array(
		'id' => 'date_replies',
		'name' => array($txt['cffp_show_filters_date_replies'], $txt['cffp_poster_time']),
		'field' => array('ml.posterTime', 'm.posterTime'),
		'table_as' => array(array('ml'), array('m')),
		'type' => 'text',
		'size' => 4,
		'length' => 0,
		'options' => '',
		'options_text' => '',
		'mask' => 'number',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['posted_by'] = array(
		'id' => 'posted_by',
		'name' => array($txt[279], $txt[279]),
		'field' => array(
			'IFNULL(memf.realName, mf.posterName)',
			'IFNULL(mem.realName, m.posterName)',
		),
		'table_as' => array(array('memf', 'mf'), array('mem', 'm')),
		'type' => 'text',
		'size' => 15,
		'length' => 0,
		'options' => '',
		'options_text' => '',
		'mask' => 'nohtml',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['new'] = array(
		'id' => 'new',
		'name' => array($txt['cffp_show_filters_topic_new_posts'], $txt[302]),
		'field' => array(
			($user_info['is_guest'] ? '0' : 'IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1') . ' <= ml.ID_MSG_MODIFIED',
			($user_info['is_guest'] ? '0' : 'IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0))') . ' < m.ID_MSG',
		),
		'table_as' => array(array('lt', 'lmr', 'ml'), array('lt', 'lmr', 'm')),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '0,1,1,0',
		'options_text' => strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => '')),
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 0,
	);

	$settings_filters['sticky'] = array(
		'id' => 'sticky',
		'name' => array($txt['cffp_show_filters_sticky'], $txt['cffp_show_filters_sticky']),
		'field' => array('t.isSticky', 't.isSticky'),
		'table_as' => array(array('t'), array('t')),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '0,1,1,0',
		'options_text' => strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => '')),
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 0,
	);

	$settings_filters['locked'] = array(
		'id' => 'locked',
		'name' => array($txt['cffp_show_filters_locked'], $txt['cffp_show_filters_locked']),
		'field' => array('t.locked', 't.locked'),
		'table_as' => array(array('t'), array('t')),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '0,1,1,0',
		'options_text' => strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => '')),
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 0,
	);

	$settings_filters['replies'] = array(
		'id' => 'replies',
		'name' => array($txt[110], ''),
		'field' => array('t.numReplies', ''),
		'table_as' => array(array('t'), array()),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '0,1,no,normal,hot,very_hot',
		'options_text' =>
			strtr($txt['cffp_topic_without_replies'], array(',' => '')) . ',' .
			strtr($txt[457], array(',' => '')) . ',' .
			strtr($txt[454], array(',' => '')) . ',' .
			strtr($txt[455], array(',' => '')),
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 1,
	);

	$settings_filters['poll'] = array(
		'id' => 'poll',
		'name' => array($txt['smf43'], ''),
		'field' => array('t.ID_POLL', ''),
		'table_as' => array(array('t'), array()),
		'type' => 'select',
		'size' => 0,
		'length' => 0,
		'options' => '0,1,1,0',
		'options_text' => strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => '')),
		'mask' => '',
		'subset' => '',
		'text_previous' => '',
		'text_next' => '',
		'show_filter_operator' => 0,
	);

	return $settings_filters;
}

// Gets tokens from a string to search.
function cffpGetTokensSearch($string)
{
	// Get tokens between comma.
	$string = strtr($string, array('&quot;' => '"'));
	preg_match_all('~"([^"]+)"~', $string, $match);
	$string = strtr(preg_replace('~"[^"]+"~', ' ', $string), array('"' => '&quot;'));

	// Add token between spaces.
	$tokens = array_merge($match[1], preg_split('~\s+~', $string));

	// Remove empty tokens.
	return array_filter($tokens, 'cffpIsNotEmptyString');
}

// Gets SQL parameters of filter.
function cffpGetSqlFilter($cffp_action)
{
	global $context, $txt, $modSettings, $func, $db_prefix;

	$filter_index = 'filters' == $cffp_action ? 0 : 1;
	$group_checked = 'filters' == $cffp_action && !empty($context['cffp']['order_by']['field_array']['group_checked']) ? $context['cffp']['order_by']['field_array']['group_checked'] : 0;
	$record_checked_array = array();

	$from = '';
	$from_join_cffp_fields = array();
	$cond = '';
	$cond_array = array();
	$query_table_as = array();

	if (!empty($context['cffp'][$cffp_action]) && isset($_REQUEST['cffp']) && is_array($_REQUEST['cffp']))
	{
		$attr_id_msg = 'filters' == $cffp_action ? 't.ID_FIRST_MSG' : 'm.ID_MSG';
		foreach ($context['cffp'][$cffp_action]['group_array'] as $id_group => $group)
		{
			if (empty($_REQUEST['cffp'][$id_group]))
				continue;

			$table_as = 'cffpf' . $id_group;
			$cond_group_array =array();

			if ('filters' == $group['type'])
			{
				foreach ($group['settings_fields'] as $settings_field)
				{
					$name_field = $settings_field['id'];
					if (!isset($_REQUEST['cffp'][$id_group][$name_field]) || !cffpIsNotEmptyString($_REQUEST['cffp'][$id_group][$name_field]))
						continue;

					$value = $func['htmlspecialchars']($_REQUEST['cffp'][$id_group][$name_field], ENT_QUOTES);
					$value_slash = strtr($value, array('%' => '\%', '_' => '\_'));

					$operator = cffpGetRequestFilterOperator($id_group, $name_field, $settings_field['type']);
					$operator_like = !(false === strpos($operator, 'LIKE'));
					$operator_not = '<>' == $operator;

					switch ($settings_field['id'])
					{
						case 'boards':
						{
							$cond_array[] = $settings_field['field'][$filter_index] . " IN ($value)";
							break;
						}
						case 'subject':
						case 'posted_by':
						{
							if ($operator_like)
							{
								$tokens = cffpGetTokensSearch($value_slash);
								foreach ($tokens as $token)
									$cond_group_array[] = $settings_field['field'][$filter_index] . " $operator '%$token%'";
							}
							else // Operators =, <>
								$cond_group_array[] = $settings_field['field'][$filter_index] . " $operator '$value'";
							break;
						}
						case 'subject_start':
						{
							$cond_group_array[] = $settings_field['field'][$filter_index] . ($operator_not ? ' NOT' : '') . " LIKE '$value_slash%'";
							break;
						}
						case 'subject_first_char':
						{
							if ('symbol' == $value)
							{
								$cond_group_array2 = array();
								$cond_group_array2[] = $settings_field['field'][$filter_index] . ($operator_not ? '' : ' NOT') . " RLIKE '^[0-9]'";
								if (!empty($txt['cffp_alphabet_letters']))
								{
									$letters = explode(',', $txt['cffp_alphabet_letters']);
									foreach ($letters as $letter)
										$cond_group_array2[] = $settings_field['field'][$filter_index] . ($operator_not ? '' : ' NOT') . " LIKE '" . strtr($letter, array('%' => '\%', '_' => '\_')) . "%'";
								}

								if ($operator_not)
									$cond_group_array[] = '(' . implode(' OR ', $cond_group_array2) . ')';
								else
									$cond_group_array = array_merge($cond_group_array, $cond_group_array2);
							}
							elseif ('number' == $value)
								$cond_group_array[] = $settings_field['field'][$filter_index] . ($operator_not ? ' NOT' : '') . " RLIKE '^[0-9]'";
							else
								$cond_group_array[] = $settings_field['field'][$filter_index] . ($operator_not ? ' NOT' : '') . " LIKE '$value_slash%'";
							break;
						}
						case 'date_topic':
						case 'date_replies':
						{
							$cond_group_array[] = '((UNIX_TIMESTAMP() - ' . $settings_field['field'][$filter_index] . ") / 86400 $operator $value)";
							break;
						}
						case 'new':
						{
							$cond_group_array[] = $value ? $settings_field['field'][$filter_index] : 'NOT (' . $settings_field['field'][$filter_index] . ')';
							break;
						}
						case 'sticky':
						case 'locked':
						{
							$cond_group_array[] = $settings_field['field'][$filter_index] . " = $value";
							break;
						}
						case 'replies':
						{
							switch ($value)
							{
								case 'no':
								{
									$cond_group_array[] = $settings_field['field'][$filter_index] . " $operator 0";
									break;
								}
								case 'normal':
								{
									if ($operator_not)
										$cond_group_array[] = '(' . $settings_field['field'][$filter_index] . ' = 0 OR ' . $settings_field['field'][$filter_index] . ' >= ' . $modSettings['hotTopicPosts'] . ')';
									else
									{
										$cond_group_array[] = $settings_field['field'][$filter_index] . ' > 0';
										$cond_group_array[] = $settings_field['field'][$filter_index] . ' < ' . $modSettings['hotTopicPosts'];
									}
									break;
								}
								case 'hot':
								{
									if ($operator_not)
										$cond_group_array[] = '(' . $settings_field['field'][$filter_index] . ' < ' . $modSettings['hotTopicPosts'] . ' OR ' . $settings_field['field'][$filter_index] . ' >= ' . $modSettings['hotTopicVeryPosts'] . ')';
									else
									{
										$cond_group_array[] = $settings_field['field'][$filter_index] . ' >= ' . $modSettings['hotTopicPosts'];
										$cond_group_array[] = $settings_field['field'][$filter_index] . ' < ' . $modSettings['hotTopicVeryPosts'];
									}
									break;
								}
								case 'very_hot':
								{
									$cond_group_array[] = $settings_field['field'][$filter_index] . ' ' . ($operator_not ? '<' : '>=') . ' ' . $modSettings['hotTopicVeryPosts'];
									break;
								}
							}
							break;
						}
						case 'poll':
						{
							$cond_group_array[] = $settings_field['field'][$filter_index] . ' ' . (empty($value) ? '=' : '<>') . ' 0';
							break;
						}
						default: // record_ID
						{
							$id_group2 = substr($settings_field['id'], 7);
							if ($value)
							{
								$record_checked_array[] = $id_group2;
								$cond_group_array[] = $settings_field['field'][$filter_index] . " = $id_group2";
							}
							else
							{
								$request = db_query("
									SELECT DISTINCT m.ID_MSG
									FROM {$db_prefix}messages AS m
										INNER JOIN {$db_prefix}cffp_fields AS cffpf ON (cffpf.ID_MSG = m.ID_MSG)
									WHERE ID_GROUP = $id_group2", __FILE__, __LINE__);
								$message_with_group = array();
								while ($row = mysql_fetch_assoc($request))
									$message_with_group[] = $row['ID_MSG'];
								mysql_free_result($request);

								$settings_field['table_as'] = array(array('mf'), array('m'));
								$cond_group_array[] = $settings_field['table_as'][$filter_index][0] . '.ID_MSG NOT IN (' . implode(',', $message_with_group) . ')';
							}
							break;
						}
					}

					$query_table_as = array_merge($query_table_as, $settings_field['table_as'][$filter_index]);
				}
			}
			else
			{
				foreach ($group['settings_fields'] as $settings_field)
				{
					$name_field = 'column_' . $settings_field['id_column'];
					if (!isset($_REQUEST['cffp'][$id_group][$name_field]) || !cffpIsNotEmptyString($_REQUEST['cffp'][$id_group][$name_field]))
						continue;

					$value = $func['htmlspecialchars']($_REQUEST['cffp'][$id_group][$name_field], ENT_QUOTES);
					$value_slash = strtr($value, array('%' => '\%', '_' => '\_'));
					$operator = cffpGetRequestFilterOperator($id_group, $name_field, $settings_field['type_filter']);
					$operator_like = !(false === strpos($operator, 'LIKE'));
					switch ($settings_field['type_filter'])
					{
						case 'empty_non_empty':
						{
							if ('empty' == $value)
								$cond_group_array[] = "($table_as.$name_field = '' OR $table_as.$name_field IS NULL)";
							else
								$cond_group_array[] = "($table_as.$name_field <> '' AND $table_as.$name_field IS NOT NULL)";
							break;
						}
						case 'select':
						case 'combobox':
						{
							if (strtr($txt['cffp_field_empty_value'], array(',' => '')) == $value)
								$cond_group_array[] = "($table_as.$name_field = '' OR $table_as.$name_field IS NULL)";
							else
							{
								$options = explode(',', $settings_field['options']);
								$select_multiple = array_shift($options);
								if ($select_multiple && !$operator_like)
								{
									$cond_group_array[] =
										('=' == $operator ? '' : 'NOT ') .
										"(" .
											"$table_as.$name_field = '$value'" .
											" OR $table_as.$name_field LIKE '%,$value_slash,%'" .
											" OR $table_as.$name_field LIKE '$value_slash,%'" .
											" OR $table_as.$name_field LIKE '%,$value_slash'" .
										")";
								}
								else
									$cond_group_array[] = "$table_as.$name_field $operator '" . ($operator_like ? "%" . $value_slash . "%" : $value) . "'";
							}
							break;
						}
						default: // text.
						{
							$tokens = cffpGetTokensSearch($value);
							$tokens_slash = cffpGetTokensSearch($value_slash);
							foreach ($tokens as $k => $token)
								$cond_group_array[] = "$table_as.$name_field $operator '" . ($operator_like ? "%" . $tokens_slash[$k] . "%" : $token) . "'";
							break;
						}
					}
				}

				if (!empty($cond_group_array) || $group_checked == $id_group)
				{
					if ($group_checked == $id_group)
						$group_checked = 0;

					$from .= "
			LEFT JOIN {$db_prefix}cffp_fields AS $table_as ON ($table_as.ID_MSG = $attr_id_msg AND $table_as.ID_GROUP = $id_group)";
					$from_join_cffp_fields[] = $id_group;
				}
			}

			$cond_array = array_merge($cond_array, $cond_group_array);
		}

		if (!empty($cond_array))
			$cond = implode(' AND ', $cond_array);
		$query_table_as = array_unique($query_table_as);
	}

	if (!empty($group_checked))
	{
		$attr_id_msg = 't.ID_FIRST_MSG';
		if (is_numeric($group_checked))
		{
			$id_group = $group_checked;
			$table_as = 'cffpf' . $id_group;

			$from .= "
			LEFT JOIN {$db_prefix}cffp_stats AS $table_as ON ($table_as.ID_MSG = $attr_id_msg AND $table_as.ID_GROUP = $id_group)";
			$from_join_cffp_fields[] = $id_group;
		}
		else
		{
			$id_group = substr($group_checked, 6);
			$table_as = 'cffps' . $id_group;

			$from .= "
			LEFT JOIN {$db_prefix}cffp_stats AS $table_as ON ($table_as.ID_MSG = $attr_id_msg AND $table_as.ID_GROUP = $id_group)";
		}
	}

	$record_checked_array = array_diff($record_checked_array, $from_join_cffp_fields);
	foreach ($record_checked_array as $id_group)
	{
		$attr_id_msg = 't.ID_FIRST_MSG';
		$table_as = 'cffpf' . $id_group;
		$from .= "
			LEFT JOIN {$db_prefix}cffp_fields AS $table_as ON ($table_as.ID_MSG = $attr_id_msg)";
	}

	return compact('from', 'cond', 'query_table_as');
}

// Gets SQL parameters of search.
function cffpGetSqlSearch($cffp_action)
{
	global $db_prefix, $context, $ID_MEMBER;

	$params = cffpGetSqlFilter($cffp_action);

	$cond_array = array();
	$from = "{$db_prefix}messages AS m";
	if ('search_posts' == $cffp_action)
	{
		$from .= "
			INNER JOIN {$db_prefix}topics AS t ON (t.ID_TOPIC = m.ID_TOPIC)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = t.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)";

		$board_array = array();
		$all_boards = true;
		$show_sticky = array(false, false);
		$show_locked = array(false, false);
		$show_first_post_topic = true;
		$show_replies_topic = true;
		$no_show_with_subject_prefix = array();
		foreach ($context['cffp']['search_posts']['group_array'] as $id_group => $group)
		{
			if ('filters' != $group['type'])
			{
				if (is_numeric($group['show_sticky']))
					$show_sticky[(int) $group['show_sticky']] = true;
				if (is_numeric($group['show_locked']))
					$show_locked[(int) $group['show_locked']] = true;
				if (!$group['show_first_post_topic'])
					$show_first_post_topic = false;
				if (!$group['show_replies_topic'])
					$show_replies_topic = false;
				if (cffpIsNotEmptyString($group['no_show_with_subject_prefix']))
					$no_show_with_subject_prefix = array_merge($no_show_with_subject_prefix, explode(',', $group['no_show_with_subject_prefix']));
			}

			if ('all' != $group['boards'])
			{
				$current_board_array = is_numeric($group['boards']) ? array($group['boards']) : explode(',', $group['boards']);
				$current_board_array = cffpAddChildrenBoards($current_board_array, $group['child_boards']);

				if ($all_boards)
				{
					$board_array = $current_board_array;
					$all_boards = false;
				}
				else
					$board_array = array_intersect($board_array, $current_board_array);
			}
		}
		if (!$all_boards)
		{
			if (empty($board_array))
				$board_array = array(0);

			$cond_array[] = 'm.ID_BOARD IN (' . implode(', ', $board_array) . ')';
		}
		if ($show_sticky[0])
			$cond_array[] = 't.isSticky = 0';
		if ($show_sticky[1])
			$cond_array[] = 't.isSticky = 1';
		if ($show_locked[0])
			$cond_array[] = 't.locked = 0';
		if ($show_locked[1])
			$cond_array[] = 't.locked = 1';
		if (!$show_first_post_topic)
			$cond_array[] = 'm.ID_MSG <> t.ID_FIRST_MSG';
		if (!$show_replies_topic)
			$cond_array[] = 'm.ID_MSG = t.ID_FIRST_MSG';
		if (!empty($no_show_with_subject_prefix))
		{
			$no_show_with_subject_prefix = array_unique($no_show_with_subject_prefix);
			foreach ($no_show_with_subject_prefix as $k => $prefix)
				$cond_array[] = "m.subject NOT LIKE '" . strtr($prefix, array('%' => '\%', '_' => '\_')) . "%'";
		}
	}
	else // search_records.
	{
		$from .= "
			INNER JOIN {$db_prefix}cffp_fields AS cffpf0 ON (cffpf0.ID_MSG = m.ID_MSG)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = cffpf0.ID_MEMBER)";
		$cond_array[] = 'cffpf0.ID_GROUP = ' . $context['ID_GROUP'];
	}

	if (!empty($params['from']))
		$from .= $params['from'];
	if (!empty($params['cond']))
		$cond_array[] = $params['cond'];

	$cond = (!empty($cond_array)) ? implode(' AND ', $cond_array) : '';

	return compact('from', 'cond');
}

// Gets number total of topics on current board. Assumes !empty($context['cffp_filters']['sql']['from']) || !empty($context['cffp_filters']['sql']['cond']).
function cffpGetTotalTopics()
{
	global $context, $user_info, $board, $db_prefix, $ID_MEMBER;

	$request = db_query("
		SELECT DISTINCT t.ID_TOPIC
		FROM {$db_prefix}topics AS t
			INNER JOIN {$db_prefix}messages AS ml ON (ml.ID_MSG = t.ID_LAST_MSG)
			INNER JOIN {$db_prefix}messages AS mf ON (mf.ID_MSG = t.ID_FIRST_MSG)
			LEFT JOIN {$db_prefix}members AS meml ON (meml.ID_MEMBER = ml.ID_MEMBER)
			LEFT JOIN {$db_prefix}members AS memf ON (memf.ID_MEMBER = mf.ID_MEMBER)" . ($user_info['is_guest'] ? '' : "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = $board AND lmr.ID_MEMBER = $ID_MEMBER)") . $context['cffp_filters']['sql']['from'] . "
		WHERE t.ID_BOARD = $board" . (empty($context['cffp_filters']['sql']['cond']) ? '' : "
			AND " . $context['cffp_filters']['sql']['cond']), __FILE__, __LINE__);
	$num_rows = mysql_num_rows($request);
	mysql_free_result($request);

	return $num_rows;
}

// Gets type of user.
function cffpGetTypeUser()
{
	global $context;

	if ($context['user']['is_admin'])
		$user = 'admin';
	elseif (allowedTo('moderate_forum'))
		$user = 'globalmod';
	elseif ($context['user']['is_mod'])
		$user = 'localmod';
	elseif ($context['user']['is_logged'])
		$user = 'user';
	elseif ($context['user']['is_guest'])
		$user = 'guest';

	return $user;
}

// Gets value of fields by post.
function cffpGetValueOfFieldsByMsg($id_msg, $member)
{
	global $context;

	if (empty($id_msg))
		return array();

	if (!isset($context['cffp']['fields_value'][$id_msg]))
		cffpLoadValueOfFieldsByMsg($id_msg);

	return $context['cffp']['fields_value'][$id_msg][$member ? 1 : 0];
}

// Indicates if user have permission.
function cffpHavePermission($user, $owner, $perm, $permissions)
{
	if (!is_array($permissions))
		$permissions = explode(',', $permissions);

	if (!is_array($perm))
		$perm = array($perm);

	$have = false;

	if (empty($user))
	{
		foreach ($perm as $p)
		{
			foreach ($permissions as $p2)
			{
				if (strpos($p2, ':' . $p))
				{
					$have = true;
					break 2; // Exit foreach $perm.
				}
			}
		}
	}
	else
	{
		foreach ($perm as $p)
		{
			$have = in_array($user . ':' . $p, $permissions);
			if ($have)
				break; // Exit foreach.
		}
	}

	if (!$have && $owner)
	{
		foreach ($perm as $p)
		{
			$have = in_array('owner:' . $p, $permissions);
			if ($have)
				break; // Exit foreach.
		}
	}

	return $have;
}

// Returns HTML code (input or ouput) of field.
// If $output then $id is $id_msg else $id is $id_cffp_group.
function cffpHtmlOfField($field, $value, $output = true, $id = 0, $name_field = '')
{
	global $txt;

	if ($output)
	{
		$id_msg = $id;
		$html = $value;
		switch ($field['type'])
		{
			case 'text':
			{
				if ($field['bbc'])
					$html = parse_bbc(censorText($html));
				break;
			}
			case 'textarea':
			{
				if ($field['bbc'])
					$html = parse_bbc(censorText($html));
				else
					$html = strtr($html, array("\n" => '<br />'));
				break;
			}
			case 'select':
			case 'combobox':
			{
				$options = explode(',', $field['options']);
				$select_multiple = array_shift($options);
				if ('combobox' != $field['type'] && cffpIsNotEmptyString($field['options_text']))
				{
					array_shift($options);
					$trans = array_combine($options, explode(',', $field['options_text']));
					if (!empty($trans))
					{
						$value_array = $select_multiple ? explode(',', $value) : array($value);
						foreach ($value_array as $k => $v)
						{
							if (isset($trans[$v]))
								$value_array[$k] = $trans[$v];
						}
						$html = implode(',', $value_array);
					}
				}
				if ($select_multiple)
					$html = str_replace(',', ', ', $html);
				break;
			}
			case 'radio':
			case 'check':
			{
				if (cffpIsNotEmptyString($field['options']) && cffpIsNotEmptyString($field['options_text']))
				{
					$trans = array_combine(explode(',', $field['options']), explode(',', $field['options_text']));
					if (!empty($trans))
					{
						$value_array = 'check' == $field['type'] ? explode(',', $value) : array($value);
						foreach ($value_array as $k => $v)
						{
							if (isset($trans[$v]))
								$value_array[$k] = $trans[$v];
						}
						$html = implode(',', $value_array);
					}
				}

				if ('check' == $field['type'])
					$html = str_replace(',', ', ', $html);
				break;
			}
			case 'boolean':
			{
				$html = $html ? $txt[163] : $txt[164];
				break;
			}
		}

		// Enclosing the output text within some other text.
		if (cffpIsNotEmptyString($html))
		{
			if (!empty($field['enclose_text']))
			{
				$trans = array(
					'{INPUT}' => $html,
					'{ID_MSG}' => $id_msg,
					'{TEXT_PREVIOUS}' => $field['text_previous'],
					'{TEXT_NEXT}' => $field['text_next'],
				);
				$html = cffpParseTemplate($field['enclose_text'], $field['enclose_type'], $trans);
			}
			else
			{
				if (cffpIsNotEmptyString($field['text_previous']))
					$html = $field['text_previous'] . ' ' . $html;
				if (cffpIsNotEmptyString($field['text_next']))
					$html .= ' ' . $field['text_next'];
			}
		}
	}
	else // Input.
	{
		$id_cffp_group = $id;
		$size_max = 100;
		$width_total = 'width: 100%; max-width: 100%; min-width: 100%;';
		$width_max = 'max-width: 100%;';

		$name = 'cffp[' . $id_cffp_group . '][' . $name_field . ']';
		$id = 'cffp_' . $id_cffp_group . '_' . $name_field;
		$id2 = 'cffp_' . $id_cffp_group . '_' . $name_field;
		$js = '';
		switch ($field['type'])
		{
			case 'text':
			{
				if (isset($field['size']))
					$size = $field['size'] ? $field['size'] : $size_max;
				else
					$size = $field['length'] ? (int) ceil($field['length'] / 10) * 10 : $size_max;
				$size = min($size_max, $size);
				$width = $size_max == $size ? $width_total : $width_max;
				$html = '<input type="text" name="' . $name . '" id="' . $id . '" value="' . $value . '"' . (!empty($field['length']) ? ' maxlength="' . $field['length'] . '"' : '') . ' size="' . $size . '" style="' . $width . '" />';
				break;
			}
			case 'textarea':
			{
				list ($rows, $cols) = explode(',', $field['options']);
				$width = empty($cols) || $size_max <= $cols ? $width_total : $width_max;
				$html = '<textarea name="' . $name . '" id="' . $id . '"' . (!empty($rows) ? ' rows="' . $rows . '"' : '') . (!empty($cols) ? ' cols="' . $cols . '"' : '') . ' style="' . $width . '">' . $value . '</textarea>';
				break;
			}
			case 'select':
			case 'combobox':
			{
				$options = explode(',', $field['options']);
				$trans = array();
				$select_multiple = array_shift($options);
				$select_size = array_shift($options);
				$options_group = !empty($field['options_group']) ? $field['options_group'] : array();
				if (!empty($options_group))
				{
					$options = array();
					$field['options_text'] = '';
				}

				if ('select' == $field['type'])
				{
					$html = '<select name="' . $name . ($select_multiple ? '[]' : '') . '" id="' . $id . '"' . ($select_multiple ? ' multiple="multiple"' : '') . (1 < $select_size ? ' size="' . $select_size . '"' : '') . ' style="' . $width_max . '">';
					if (cffpIsNotEmptyString($field['options_text']))
						$trans = array_combine($options, explode(',', $field['options_text']));
					if (empty($options_group) && !empty($field['show_filter_used_options']))
					{
						$add_empty_value = !empty($options) && strtr($txt['cffp_field_empty_value'], array(',' => '')) == $options[0];
						$options = cffpGetOptionsUsed($field['ID_GROUP'], $name_field, $field['show_filter_used_options'], $add_empty_value);
					}
				}
				// combobox.
				else
				{
					if (empty($options_group))
					{
						if (empty($field['show_filter_used_options']))
							$options = cffpGetOptionsCombobox($field['ID_GROUP'], $name_field, $options);
						else
						{
							$add_empty_value = !empty($options) && strtr($txt['cffp_field_empty_value'], array(',' => '')) == $options[0];
							$options = cffpGetOptionsUsed($field['ID_GROUP'], $name_field, $field['show_filter_used_options'], $add_empty_value);
						}
					}

					if (isset($field['size']))
						$size = $field['size'] ? $field['size'] : $size_max;
					else
						$size = $field['length'] ? (int) ceil($field['length'] / 10) * 10 : $size_max;
					$size = min($size_max, $size);
					$width = $size_max == $size ? $width_total : 'width: ' . ($size * 6) . 'px; ' . $width_max;

					$select_name = 'cffp[' . $id_cffp_group . '][' . $name_field . '_select]';
					$select_id = 'cffp_' . $id_cffp_group . '_' . $name_field . '_select';

					if (!empty($field['dropdown']))
					{
						$select_multiple = 0;
						$select_size = 1;
						$select_width = $width_max;
						$br = '';
					}
					else
					{
						$select_width = $width;
						$br = '<br />';
					}

					$html =
						'<input type="text" name="' . $name . '" id="' . $id . '" value="' . $value . '"' . (!empty($field['length']) && !$select_multiple ? ' maxlength="' . $field['length'] . '"' : '') . ' size="' . $size . '" style="' . $width . '" />' .
						$br .
						'<select name="' . $select_name . ($select_multiple ? '[]' : '') . '" id="' . $select_id . '"' . ($select_multiple ? ' multiple="multiple"' : '') . (1 < $select_size ? ' size="' . $select_size . '"' : '') . ' style="' . $select_width . '">';
				}

				if ($select_multiple)
				{
					$value_array = cffpIsNotEmptyString($value) ? explode(',', $value) : array();
					$no_checked_array = array_flip($value_array);
					if (empty($options_group))
					{
						foreach ($options as $v)
						{
							$checked = !empty($value_array) && cffpIsNotEmptyString($v) && in_array($v, $value_array);
							$html .= '<option value="' . $v . '"' . ($checked ? ' selected="selected"' : '') . '>' . (isset($trans[$v]) ? $trans[$v] : $v) . '</option>';
							if ($checked)
								unset($no_checked_array[$v]);
						}
					}
					else
					{
						if (isset($options_group[0]['settings']))
						{
							if (!empty($options_group[0]['settings']['show_empty_option']))
							{
								$checked = empty($value_array) || in_array('', $value_array);
								if ($checked)
								{
									$value_array = array();
									$no_checked_array = array();
								}
								if ($checked || !$field['not_empty_value'])
									$html .= '<option value=""' . ($checked ? ' selected="selected"' : '') . '>' . (isset($field['empty_option_text']) ? $field['empty_option_text'] : '') . '</option>';
							}
							unset($options_group[0]);
						}

						foreach ($options_group as $option_group)
						{
							if (isset($option_group['name']))
							{
								$html .=
									'<option value="" disabled="disabled">-----------------------------</option>' .
									'<option value="" disabled="disabled">' . $option_group['name'] . '</option>' .
									'<option value="" disabled="disabled">-----------------------------</option>';
							}
							foreach ($option_group['options'] as $op)
							{
								$checked = !empty($value_array) && in_array($op['value'], $value_array);
								$html .= '<option value="' . $op['value'] . '"' . ($checked ? ' selected="selected"' : '') . '>' . $op['text'] . '</option>';
								if ($checked)
									unset($no_checked_array[$op['value']]);
							}
						}
					}
					foreach ($no_checked_array as $v => $i)
						$html .= '<option value="' . $v . '" selected="selected">' . $v . '</option>';
				}
				else // No select multiple.
				{
					$checked = !cffpIsNotEmptyString($value);
					$no_checked = !$checked;
					if ($checked || !$field['not_empty_value'])
						$html .= '<option value=""' . ($checked ? ' selected="selected"' : '') . '>' . (isset($field['empty_option_text']) ? $field['empty_option_text'] : '') . '</option>';
					if (empty($options_group))
					{
						foreach ($options as $v)
						{
							$checked = cffpIsNotEmptyString($v) && cffpIsNotEmptyString($value) && $value == $v;
							$html .= '<option value="' . $v . '"' . ($checked ? ' selected="selected"' : '') . '>' . (isset($trans[$v]) ? $trans[$v] : $v) . '</option>';
							if ($checked)
								$no_checked = false;
						}
					}
					else
					{
						foreach ($options_group as $option_group)
						{
							if (isset($option_group['name']))
							{
								$html .=
									'<option value="" disabled="disabled">-----------------------------</option>' .
									'<option value="" disabled="disabled">' . $option_group['name'] . '</option>' .
									'<option value="" disabled="disabled">-----------------------------</option>';
							}
							foreach ($option_group['options'] as $op)
							{
								$checked = cffpIsNotEmptyString($value) && $value == $op['value'];
								$html .= '<option value="' . $op['value'] . '"' . ($checked ? ' selected="selected"' : '') . '>' . $op['text'] . '</option>';
								if ($checked)
									$no_checked = false;
							}
						}
					}
					if ($no_checked)
						$html .= '<option value="' . $value . '" selected="selected">' . $value . '</option>';
				}
				$html .= '</select>';

				if ('combobox' == $field['type'])
				{
					$js = 'document.getElementById("' . $select_id . '").onchange = function (event)
{
	cffpOnchangeCombobox(document.getElementById("' . $id . '"), this);
}';
				}
				break;
			}
			case 'radio':
			{
				$id = '';
				$options = explode(',', $field['options']);
				$trans = cffpIsNotEmptyString($field['options_text']) ? array_combine($options, explode(',', $field['options_text'])) : array();
				$html = '';
				$no_checked = true;
				foreach ($options as $v)
				{
					$checked = cffpIsNotEmptyString($v) && cffpIsNotEmptyString($value) && $value == $v;
					$html .= '<label><input type="radio" name="' . $name . '" value="' . $v . '"' . ($checked ? ' checked="checked"' : '') . ' class="check" /> ' . (isset($trans[$v]) ? $trans[$v] : $v) . '</label><br />';
					if ($checked)
						$no_checked = false;
				}
				if ($no_checked && cffpIsNotEmptyString($value))
					$html .= '<label><input type="radio" name="' . $name . '" value="' . $value . '" checked="checked" class="check" /> ' . $value . '</label>';
				break;
			}
			case 'check':
			{
				$id = '';
				$options = explode(',', $field['options']);
				$trans = cffpIsNotEmptyString($field['options_text']) ? array_combine($options, explode(',', $field['options_text'])) : array();
				$value_array = cffpIsNotEmptyString($value) ? explode(',', $value) : array();
				$html = '';
				$no_checked_array = array_flip($value_array);
				foreach ($options as $v)
				{
					$checked = !empty($value_array) && cffpIsNotEmptyString($v) && in_array($v, $value_array);
					$html .= '<label><input type="checkbox" name="' . $name . '[]" value="' . $v . '"' . ($checked ? ' checked="checked"' : '') . ' class="check" /> ' . (isset($trans[$v]) ? $trans[$v] : $v) . '</label><br />';
					if ($checked)
						unset($no_checked_array[$v]);
				}
				foreach ($no_checked_array as $v => $i)
					$html .= '<label><input type="checkbox" name="' . $name . '[]" value="' . $v . '" checked="checked" class="check" /> ' . $v . '</label><br />';
				break;
			}
			case 'boolean':
			{
				$html = '<input type="checkbox" name="' . $name . '" id="' . $id . '" value="1"' . ($value ? ' checked="checked"' : '') . ' class="check" />';
				break;
			}
		}

		// Enclosing the input button within some other text.
		if (cffpIsNotEmptyString($html))
		{
			if (cffpIsNotEmptyString($field['text_previous']))
				$html = $field['text_previous'] . ' ' . $html;
			if (cffpIsNotEmptyString($field['text_next']))
				$html .= ' ' . $field['text_next'];
		}
	}

	return $output ? $html : compact('html', 'id', 'id2', 'js');
}

// Returns HTML code of filter operator.
function cffpHtmlOfFilterOperator($select_multiple, $value, $id_group, $name_field)
{
	global $func, $txt;

	switch ($name_field)
	{
		case 'subject': // Predefined filters type text.
		case 'posted_by':
		{
			$operators = array('=', '<>', 'LIKE', 'NOT LIKE');
			break;
		}
		case 'subject_start': // Predefined filter type text.
		case 'subject_first_char': // Predefined filters type select.
		case 'replies':
		{
			$operators = array('=', '<>');
			break;
		}
		case 'date_topic': // Predefined filters type text (number of days).
		case 'date_replies':
		{
			$operators = array('<=', '>');
			break;
		}
		default: // Filters of fields.
		{
			$operators = $select_multiple ? array('=', '<>', 'LIKE', 'NOT LIKE') : array('=', '<>', '<', '<=', '>', '>=', 'LIKE', 'NOT LIKE');
			break;
		}
	}
	$trans = array(
		'LIKE' => $txt['cffp_show_filter_operator_like'],
		'NOT LIKE' => $txt['cffp_show_filter_operator_not_like'],
	);

	$name = 'cffp_operator[' . $id_group . '][' . $name_field . ']';
	$id = 'cffp_operator_' . $id_group . '_' . $name_field;

	$html = '<select name="' . $name . '" id="' . $id . '">';
	foreach ($operators as $v)
		$html .= '<option value="' . $v . '"' . ($value == $v ? ' selected="selected"' : '') . '>' . $func['htmlspecialchars'](isset($trans[$v]) ? $trans[$v] : $v, ENT_QUOTES) . '</option>';
	$html .= '</select>';

	return $html;
}

// Indicates if group (with $boards and $child_boards attributes) is allowed in current board.
function cffpIsGroupAllowInBoard($boards, $child_boards, $current_board = 0)
{
	if (empty($boards))
		$allow = false;
	elseif ('all' == $boards)
		$allow = true;
	else
	{
		if (empty($current_board))
		{
			global $board;
			$current_board = $board;
		}
		$board_array = is_numeric($boards) ? array($boards) : explode(',', $boards);
		$board_array = cffpAddChildrenBoards($board_array, $child_boards);
		$allow = in_array($current_board, $board_array);
	}
	return $allow;
}

// Indicates if is not an empty string.
function cffpIsNotEmptyString($string)
{
	return !empty($string) || is_numeric($string);
}

// Indicates if user is owner of message.
function cffpIsOwner($new_msg, $id_member_poster)
{
	global $context;

	return !$context['user']['is_guest'] && ($new_msg || $context['user']['id'] == $id_member_poster);
}

// Loads custom post fields of a post.
function cffpLoad($id_msg, $id_member_poster, $cffp_action, $current_board = 0, $id_group = 0, $search_page_name = false)
{
	global $context, $txt, $modSettings;

	$user = cffpGetTypeUser();

	$action_readonly = '_readonly' == substr($cffp_action, -9);

	if (in_array($cffp_action, array('order_by', 'filters')) || 'search' == substr($cffp_action, 0, 6))
		$data_msg = array();
	else
	{
		if (empty($id_msg))
			global $topic;

		$owner = cffpIsOwner(empty($id_msg), $id_member_poster);
		$data_msg = cffpGetDataMsgTopic($id_msg, !empty($topic) ? $topic : 0);
	}
	$context['cffp'][$cffp_action] = array();

	$group_array = array();
	$field_array = array();
	switch ($cffp_action)
	{
		case 'display':
		case 'display_readonly':
		case 'message_index':
		{
			$fields_value = cffpGetValueOfFieldsByMsg($id_msg, false);
			if (!empty($id_group))
				$fields_value = isset($fields_value[$id_group]) ? array($id_group => $fields_value[$id_group]) : array();
			if (empty($fields_value))
				return;

			$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, array_keys($fields_value), $cffp_action, $current_board, $user, $owner);
			foreach ($fields_value as $id_group => $fv)
			{
				if (!isset($group_array[$id_group]))
					continue;

				$group_array[$id_group]['posterName'] = $fv['posterName'];
				$group_array[$id_group]['posterTime'] = $fv['posterTime'];
				$group_array[$id_group]['modifiedName'] = $fv['modifiedName'];
				$group_array[$id_group]['modifiedTime'] = $fv['modifiedTime'];

				foreach ($group_array[$id_group]['settings_fields'] as $row)
				{
					$name_field = 'column_' . $row['id_column'];
					$value = $fv[$name_field];

					$html = cffpHtmlOfField($row, $value, true, $id_msg);
					if ((('message_index' == $cffp_action && !$group_array[$id_group]['show_empty_fields_message_index']) || ('message_index' != $cffp_action && !$group_array[$id_group]['show_empty_fields_post'])) && !cffpIsNotEmptyString($html))
					{
						unset($group_array[$id_group]['settings_fields'][$row['ID_FIELD']]);
						continue;
					}

					$field_array[$id_group][$row['ID_FIELD']] = array(
						'name' => $row['name'],
						'html' => $html,
					);
				}

				if (empty($field_array[$id_group]))
					unset($group_array[$id_group]);
			}
			break;
		}
		case 'display_member':
		case 'display_member_topic_begin_all':
		case 'display_member_topic_end_all':
		case 'display_member_topic_begin_first':
		case 'display_member_topic_end_first':
		case 'display_member_readonly':
		case 'display_member_topic_begin_all_readonly':
		case 'display_member_topic_end_all_readonly':
		case 'display_member_topic_begin_first_readonly':
		case 'display_member_topic_end_first_readonly':
		{
			$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, 0, $cffp_action, $current_board);
			if (empty($group_array))
				return;

			$fields_value = cffpGetValueOfFieldsByMsg($id_msg, true);

			foreach ($group_array as $id_group => $group)
			{
				$fvm = isset($fields_value[$id_group]) ? $fields_value[$id_group] : array();
				$group_fields_own = array();
				$group_fields_array = array();
				foreach ($fvm as $fv)
				{
					$owner2 = cffpIsOwner(false, $fv['ID_MEMBER']);
					$can_view = cffpHavePermission($user, $owner2, 'view', $group['permissions']);
					$can_modify = !$action_readonly && cffpHavePermission($user, $owner2, 'modify', $group['permissions']);
					$can_remove = !$action_readonly && cffpHavePermission($user, $owner2, 'remove', $group['permissions']);
					$can_move = !$action_readonly && cffpHavePermission($user, $owner2, 'move', $group['permissions']);
					if (!$can_view && !$can_modify && !$can_remove)
						continue;

					$field_array2 = array();
					if ($can_view)
					{
						foreach ($group['settings_fields'] as $row)
						{
							$can_view2 = cffpHavePermission($user, $owner2, 'view', $row['permissions']);
							if (!$can_view2)
								continue;

							$name_field = 'column_' . $row['id_column'];
							$value = $fv[$name_field];

							$html = cffpHtmlOfField($row, $value, true, $id_msg);
							if (!$group['show_empty_fields_post'] && !cffpIsNotEmptyString($html))
								continue;

							$field_array2[$row['ID_FIELD']] = array(
								'name' => $row['name'],
								'html' => $html,
							);
						}
					}
					if (empty($field_array2))
						continue;

					$group_fields = array(
						'ID_CFFP' => $fv['ID_CFFP'],
						'ID_MEMBER' => $fv['ID_MEMBER'],
						'posterName' => $fv['posterName'],
						'posterTime' => $fv['posterTime'],
						'modifiedName' => $fv['modifiedName'],
						'modifiedTime' => $fv['modifiedTime'],
						'can_view' => $can_view,
						'can_modify' => $can_modify,
						'can_remove' => $can_remove,
						'can_move' => $can_move,
						'field_array' => $field_array2,
					);
					if ($owner2 && $group['member_one_value'])
						$group_fields_own = $group_fields;
					else
						$group_fields_array[] = $group_fields;
				}

				$owner2 = cffpIsOwner(true, $context['user']['id']);
				$can_add = !$action_readonly && cffpHavePermission($user, $owner2, 'add', $group['permissions']) && empty($group_fields_own);
				$add_group_fields = array();
				if ($can_add)
				{
					foreach ($group['settings_fields'] as $row)
					{
						$can_view2 = cffpHavePermission($user, $owner2, 'view', $row['permissions']);
						if (!$can_view2)
							continue;

						$name_field = 'column_' . $row['id_column'];
						$value = $row['default_value'];

						$row['show_filter_used_options'] = 0;
						$add_group_fields['field_array'][$row['ID_FIELD']] = array(
							'name' => $row['name'],
							'field_desc' => $row['field_desc'],
							'field_long_desc' => parse_bbc(censorText($row['field_long_desc'])),
							'html' => cffpHtmlOfField($row, $value, false, $id_msg . '_group' . $id_group, $name_field),
						);
					}

					if (!empty($add_group_fields))
					{
						if ($context['user']['is_guest'])
						{
							$add_group_fields['guest_name'] = isset($_SESSION['guest_name']) ? $_SESSION['guest_name'] : '';

							if (empty($modSettings['guest_post_no_email']))
								$add_group_fields['guest_email'] = isset($_SESSION['guest_email']) ? $_SESSION['guest_email'] : '';
						}
					}
				}

				$stats = cffpLoadStatsOfGroupByMsg($id_group, $id_msg, true);
				$can_stats = cffpHavePermission($user, false, 'stats', $group['permissions']);
				$stats = !empty($stats) && $can_stats ? cffpGetStats($stats[$id_msg], $group, 'post') : array();

				if (empty($group_fields_array) && empty($group_fields_own) && empty($add_group_fields) && empty($stats))
				{
					unset($group_array[$id_group]);
					continue;
				}

				if (!empty($group['show_member_expanded_data_recent']) && !empty($group_fields_array) && count($group_fields_array) > $group['show_member_expanded_data_recent'])
				{
					$group_fields_previous_array = $group_fields_array;
					$group_fields_recent_array = array();
					for ($k = 0; $k < $group['show_member_expanded_data_recent']; $k++)
					{
						$recent = array_pop($group_fields_previous_array);
						if (empty($recent))
							break; // Exit for.

						$group_fields_recent_array[] = $recent;
					}

					if ($group['show_member_recent_at_top'])
						$group_fields_previous_array = array_reverse($group_fields_previous_array);
					else
						$group_fields_recent_array = array_reverse($group_fields_recent_array);
				}
				else
				{
					$group_fields_previous_array = array();
					$group_fields_recent_array = $group_fields_array;

					if ($group['show_member_recent_at_top'])
						$group_fields_recent_array = array_reverse($group_fields_recent_array);
				}

				if (!empty($group_fields_own))
				{
					if ($group['show_member_recent_at_top'])
						array_unshift($group_fields_recent_array, $group_fields_own);
					else
						$group_fields_recent_array[] = $group_fields_own;
				}

				$field_array[$id_group] = array(
					'stats' => $stats,
					'group_fields_array' => array(
						'previous' => $group_fields_previous_array,
						'recent' => $group_fields_recent_array,
					),
					'add_group_fields' => $add_group_fields,
				);
			}

			if (isset($_GET['cffp_show']))
			{
				list ($show_msg, $show_group) = explode(',', $_GET['cffp_show']);
				if ($id_msg == $show_msg && isset($group_array[$show_group]))
				{
					if (0 == $group_array[$show_group]['show_member_expanded'])
						$group_array[$show_group]['show_member_expanded'] = 1;
					if (0 == $group_array[$show_group]['show_member_expanded_data'])
						$group_array[$show_group]['show_member_expanded_data'] = 1;
				}
			}
			break;
		}
		case 'message_index_member':
		{
			$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, 0, $cffp_action, $current_board);
			if (empty($group_array))
				return;

			$fields_value = cffpGetValueOfFieldsByMsg($id_msg, true);

			foreach ($group_array as $id_group => $group)
			{
				$fvm = isset($fields_value[$id_group]) ? $fields_value[$id_group] : array();
				$group_fields_array = array();
				foreach ($fvm as $fv)
				{
					$owner2 = cffpIsOwner(false, $fv['ID_MEMBER']);
					$can_view = cffpHavePermission($user, $owner2, 'view', $group['permissions']);
					if (!$can_view)
						continue;

					$field_array2 = array();
					foreach ($group['settings_fields'] as $row)
					{
						$can_view2 = cffpHavePermission($user, $owner2, 'view', $row['permissions']);
						if (!$can_view2)
							continue;

						$name_field = 'column_' . $row['id_column'];
						$value = $fv[$name_field];

						$html = cffpHtmlOfField($row, $value, true, $id_msg);
						if (!$group['show_empty_fields_message_index'] && !cffpIsNotEmptyString($html))
							continue;

						$field_array2[$row['ID_FIELD']] = array(
							'name' => $row['name'],
							'html' => $html,
						);
					}
					if (empty($field_array2))
						continue;

					$group_fields_array[] = array(
						'ID_CFFP' => $fv['ID_CFFP'],
						'ID_MEMBER' => $fv['ID_MEMBER'],
						'posterName' => $fv['posterName'],
						'posterTime' => $fv['posterTime'],
						'modifiedName' => $fv['modifiedName'],
						'modifiedTime' => $fv['modifiedTime'],
						'field_array' => $field_array2,
					);
				}

				$stats = cffpLoadStatsOfGroupByMsg($id_group, $id_msg, true);
				$can_stats = cffpHavePermission($user, false, 'stats', $group['permissions']);
				$stats = !empty($stats) && $can_stats ? cffpGetStats($stats[$id_msg], $group, 'message_index') : array();

				if (empty($group_fields_array) && empty($stats))
				{
					unset($group_array[$id_group]);
					continue;
				}

				if (!empty($group_fields_array) && $group['show_member_recent_at_top'])
					$group_fields_array = array_reverse($group_fields_array);

				$field_array[$id_group] = array(
					'stats' => $stats,
					'group_fields_array' => $group_fields_array,
				);
			}
			break;
		}
		case 'post':
		{
			$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, 0, $cffp_action, $current_board, $user, $owner);
			if (empty($group_array))
				return;

			$fields_value = cffpGetValueOfFieldsByMsg($id_msg, false);

			foreach ($group_array as $id_group => $group)
			{
				$fv = isset($fields_value[$id_group]) ? $fields_value[$id_group] : array();
				if ((empty($fv) && !$group['can_add'] && 'record' == $group['type']) || (!empty($fv) && !$group['can_modify'] && !$group['can_remove']))
				{
					unset($group_array[$id_group]);
					continue;
				}

				$group_array[$id_group]['ID_CFFP'] = !empty($fv) ? $fv['ID_CFFP'] : 0;
				$group_array[$id_group]['set'] = isset($_REQUEST['cffp'][$id_group]) && ((empty($fv) && $group['can_add']) || (!empty($fv) && $group['can_remove'])) ? isset($_REQUEST['cffp'][$id_group]['set']) : !empty($fv);

				if (!empty($id_msg) && empty($fv) && $context['user']['is_guest'])
				{
					if (isset($_SESSION['guest_name']))
						$group_array[$id_group]['guest_name'] = $_SESSION['guest_name'];
					else
						$group_array[$id_group]['guest_name'] = isset($_REQUEST['cffp'][$id_group]['guest_name']) ? $_REQUEST['cffp'][$id_group]['guest_name'] : '';

					if (empty($modSettings['guest_post_no_email']))
					{
						if (isset($_SESSION['guest_email']))
							$group_array[$id_group]['guest_email'] = $_SESSION['guest_email'];
						else
							$group_array[$id_group]['guest_email'] = isset($_REQUEST['cffp'][$id_group]['guest_email']) ? $_REQUEST['cffp'][$id_group]['guest_email'] : '';
					}
				}

				$group_array[$id_group]['can_modify_fields'] = empty($fv) || $group['can_modify'];
				$group_array[$id_group]['can_view_fields'] = !$group_array[$id_group]['can_modify_fields'] && $group['can_remove'] && $group['can_view'];
				if (!$group_array[$id_group]['can_modify_fields'] && !$group_array[$id_group]['can_view_fields'])
					continue;

				foreach ($group['settings_fields'] as $row)
				{
					$name_field = 'column_' . $row['id_column'];

					if ($group_array[$id_group]['can_modify_fields'])
					{
						$value = cffpGetRequestValueOfField($id_group, $name_field, $row['type'], $row['length'], $row['options'], !empty($fv) ? $fv[$name_field] : $row['default_value']);
						$row['show_filter_used_options'] = 0;
						$html = cffpHtmlOfField($row, $value, false, $id_group, $name_field);
					}
					else // $group_array[$id_group]['can_view_fields'].
					{
						$value = !empty($fv) ? $fv[$name_field] : $row['default_value'];
						$html = cffpHtmlOfField($row, $value, true, $id_msg);
					}

					$field_array[$id_group][$row['ID_FIELD']] = array(
						'name' => $row['name'],
						'field_desc' => $row['field_desc'],
						'field_long_desc' => parse_bbc(censorText($row['field_long_desc'])),
						'html' => $html,
					);
				}
			}
			break;
		}
		case 'order_by':
		{
			$group_array = cffpGetGroupsAndFieldsOfGroup(array(), $id_group, $cffp_action, 0, $user);
			if (empty($group_array))
				return;

			if (!empty($_REQUEST['cffp_order_by']))
				$cffp_order_by = $_REQUEST['cffp_order_by'];
			elseif (!empty($_REQUEST['sort']))
				$cffp_order_by = $_REQUEST['sort'] . ' ' . (isset($_REQUEST['desc']) ? 'desc' : 'asc');
			else
				$cffp_order_by = '';
			$sort_array = array();
			$option_array = array();
			$no_checked = true;
			$group_checked = 0;
			foreach ($group_array as $id_group => $group)
			{
				if ($group['show_stats'])
				{
					$group = $context['cffp']['settings_groups'][$id_group];
					$show_stats = 1 == count($group['settings_fields']) && !empty($group['show_stats_order_by']);
					if (!$show_stats)
					{
						unset($group_array[$id_group]);
						continue;
					}

					$settings_field = current($group['settings_fields']);
					switch ($settings_field['type'])
					{
						case 'select':
						{
							$options = explode(',', $settings_field['options']);
							array_shift($options);
							array_shift($options);
							break;
						}
						case 'radio':
						case 'check':
						{
							$options = explode(',', $settings_field['options']);
							break;
						}
						default:
						{
							$show_stats = 0;
							break;
						}
					}
					if (!$show_stats)
					{
						unset($group_array[$id_group]);
						continue;
					}

					$is_numeric = true;
					foreach ($options as $value)
					{
						if (!is_numeric($value))
						{
							$is_numeric = false;
							break; // Exit foreach.
						}
					}

					$show_stats_order_by = explode(',', $group['show_stats_order_by']);
					if (!$is_numeric)
					{
						$show_stats_order_by = array_diff($show_stats_order_by, array('average', 'sum', 'highest', 'lowest'));
						if (empty($show_stats_order_by))
						{
							unset($group_array[$id_group]);
							continue;
						}
					}

					foreach ($show_stats_order_by as $order_by)
					{
						$sort = 'cffps' . $id_group . '.' . $order_by;
						$value_asc = $sort . ' asc';
						$value_desc = $sort . ' desc';
						$checked_asc = $cffp_order_by == $value_asc;
						$checked_desc = $cffp_order_by == $value_desc;
						if ($checked_asc || $checked_desc)
						{
							$no_checked = false;
							$group_checked = 'stats_' . $id_group;
						}

						$sort_array[] = $sort;
						$option_array[$id_group][] = array(
							'value' => $value_asc,
							'checked' => $checked_asc,
							'text' => $txt['cffp_show_stats_summary_' . $order_by] . ' (' . $txt['cffp_order_by_asc'] . ')',
						);
						$option_array[$id_group][] = array(
							'value' => $value_desc,
							'checked' => $checked_desc,
							'text' => $txt['cffp_show_stats_summary_' . $order_by] . ' (' . $txt['cffp_order_by_desc'] . ')',
						);
					}
				}
				else
				{
					foreach ($group['settings_fields'] as $row)
					{
						$sort = 'cffpf' . $id_group . '.column_' . $row['id_column'];
						$value_asc = $sort . ' asc';
						$value_desc = $sort . ' desc';
						$checked_asc = $cffp_order_by == $value_asc;
						$checked_desc = $cffp_order_by == $value_desc;
						if ($checked_asc || $checked_desc)
						{
							$no_checked = false;
							$group_checked = $id_group;
						}

						$sort_array[] = $sort;
						$option_array[$id_group][] = array(
							'value' => $value_asc,
							'checked' => $checked_asc,
							'text' => $row['name'] . ' (' . $txt['cffp_order_by_asc'] . ')',
						);
						$option_array[$id_group][] = array(
							'value' => $value_desc,
							'checked' => $checked_desc,
							'text' => $row['name'] . ' (' . $txt['cffp_order_by_desc'] . ')',
						);
					}
				}

				if (empty($option_array[$id_group]))
					unset($group_array[$id_group]);
			}

			if (empty($sort_array))
				return;

			$field_array = array(
				'sort_array' => $sort_array,
				'option_array' => $option_array,
				'no_checked' => $no_checked,
				'group_checked' => $group_checked,
			);
			break;
		}
		case 'filters':
		case 'search_posts':
		case 'search_posts_menu':
		case 'search_records':
		case 'search_records_menu':
		{
			$group_array = cffpGetGroupsAndFieldsOfGroup(array(), $id_group, $cffp_action, 0, $user, false, $search_page_name);
			if (empty($group_array))
				return;

			$size = 'filters' == $cffp_action ? 15 : 0;
			$filter_index = 'filters' == $cffp_action ? 0 : 1;
			$dropdown = 'filters' == $cffp_action;
			$action_menu = '_menu' == substr($cffp_action, -5);
			foreach ($group_array as $id_group => $group)
			{
				if ('filters' == $group['type'])
				{
					foreach ($group['settings_fields'] as $row)
					{
						if (('sticky' == $row['id'] && !$modSettings['enableStickyTopics']) || empty($row['field'][$filter_index]))
						{
							unset($group_array[$id_group]['settings_fields'][$row['id']]);
							continue;
						}

						if ('filters' != $cffp_action)
						{
							if (('date_topic' == $row['id'] && isset($field_array[$id_group]['date_replies'])) || ('date_replies' == $row['id'] && isset($field_array[$id_group]['date_topic'])))
							{
								unset($group_array[$id_group]['settings_fields'][$row['id']]);
								continue;
							}
						}

						if (!$action_menu)
						{
							$name_field = $row['id'];
							switch ($row['id'])
							{
								case 'boards':
								{
									loadJumpTo();
									$all_boards = $context['jump_to'];
									if ('all' != $group['boards'])
									{
										$board_array = is_numeric($group['boards']) ? array($group['boards']) : explode(',', $group['boards']);
										$board_array = cffpAddChildrenBoards($board_array, $group['child_boards']);

										foreach ($all_boards as $kc => $category)
										{
											$options = array();
											foreach ($category['boards'] as $kb => $board)
											{
												if (!in_array($board['id'], $board_array))
													unset($all_boards[$kc]['boards'][$kb]);
											}
											if (empty($all_boards[$kc]['boards']))
												unset($all_boards[$kc]);
										}
									}

									$options_group = array(
										array(
											'settings' => array(
												'show_empty_option' => true,
											),
										),
									);

									foreach ($all_boards as $category)
									{
										$options = array();
										foreach ($category['boards'] as $board)
										{
											$options[] = array(
												'value' => $board['id'],
												'text' => ' ' . str_repeat('==', $board['child_level']) . '=> ' . $board['name'],
											);
										}
										$options_group[] = array(
											'name' => $category['name'],
											'options' => $options,
										);
									}
									$row['options_group'] = $options_group;
									break;
								}
								case 'subject':
								case 'subject_start':
								case 'posted_by':
								{
									$row['size'] = $size;
									break;
								}
								default:
								{
									// VOID
									break;
								}
							}
							$row['show_filter_used_options'] = 0;
							$row['not_empty_value'] = 0;
							$row['empty_option_text'] = $txt[190];
							$value = cffpGetRequestValueOfField($id_group, $name_field, $row['type'], $row['length'], $row['options']);
							$error_code = cffpValidateMask($row['mask'], $value);
							if (!empty($error_code) || ('date_' == substr($row['id'], 0, 5) && empty($value)) || ('boards' == $row['id'] && (empty($value) || ',' == substr($value, 0, 1))))
							{
								$_REQUEST['cffp'][$id_group][$name_field] = '';
								$value = '';
							}
							elseif ('boards' == $row['id'])
								$_REQUEST['cffp'][$id_group][$name_field] = $value;

							$html = cffpHtmlOfField($row, $value, false, $id_group, $name_field);
							if ('date_' == substr($row['id'], 0, 5))
								$html['html'] = sprintf($txt['cffp_show_filters_date_lastdays'], $html['html']);

							if ($row['show_filter_operator'])
							{
								$operator = cffpGetRequestFilterOperator($id_group, $name_field, $row['type']);
								$html_operator = cffpHtmlOfFilterOperator(false, $operator, $id_group, $name_field);
							}
							else
								$html_operator = '';

							$field_array[$id_group][$row['id']] = array(
								'name' => $row['name'][$filter_index],
								'field_desc' => '',
								'field_long_desc' => '',
								'html' => $html,
								'html_operator' => $html_operator,
							);
						}
					}

					if (!$action_menu && empty($field_array[$id_group]))
					{
						unset($group_array[$id_group]);
						continue;
					}
				}
				elseif (!$action_menu)
				{
					foreach ($group['settings_fields'] as $row)
					{
						$name_field = 'column_' . $row['id_column'];
						$select_multiple = false;
						switch ($row['type_filter'])
						{
							case 'text': // type IN (text, textarea, select, combobox, radio, check).
							{
								if ('textarea' == $row['type'])
									list ($rows, $size_orig) = explode(',', $row['options']);
								elseif (!empty($row['length']))
									$size_orig = (int) ceil($row['length'] / 10) * 10;
								else
									$size_orig = 0;

								if (!empty($size_orig))
									$row['size'] = !empty($size) ? min($size, $size_orig) : $size_orig;
								else
									$row['size'] = $size;

								$row['length'] = 0;
								break;
							}
							case 'select': // type IN (select, combobox, radio, check, boolean).
							case 'combobox': // type IN (select, combobox, radio, check).
							{
								if ('combobox' == $row['type_filter'])
								{
									if (0 < strlen($row['options_text']))
										$row['type_filter'] = 'select';
									else
									{
										$row['dropdown'] = $dropdown;

										if ('combobox' == $row['type_filter'] && !empty($row['length']))
										{
											$size_orig = (int) ceil($row['length'] / 10) * 10;
											$row['size'] = !empty($size) ? min($size, $size_orig) : $size_orig;
										}
										else
											$row['size'] = $size;

										$row['length'] = 0;
									}
								}

								if (in_array($row['type'], array('radio', 'check')))
								{
									if ($row['not_empty_value'] || !$group['can_modify'])
										$row['options'] = '0,1' . (0 < strlen($row['options']) ? ',' . $row['options'] : '');
									else
									{
										$row['options'] = '0,1,' . strtr($txt['cffp_field_empty_value'], array(',' => '')) . (0 < strlen($row['options']) ? ',' . $row['options'] : '');
										if (0 < strlen($row['options_text']))
											$row['options_text'] = strtr($txt['cffp_field_empty_value'], array(',' => '')) . ',' . $row['options_text'];
									}
									$select_multiple = 'check' == $row['type'];
								}
								elseif ('boolean' == $row['type'])
								{
									$row['options'] = '0,1,1,0';
									$row['options_text'] = strtr($txt[163], array(',' => '')) . ',' . strtr($txt[164], array(',' => ''));
								}
								else // select, combobox.
								{
									$options = explode(',', $row['options']);
									$select_multiple = array_shift($options);
									array_shift($options);
									if ('combobox' == $row['type'])
										$options = cffpGetOptionsCombobox($id_group, $name_field, $options);

									if ($row['not_empty_value'] || !$group['can_modify'])
										$row['options'] = '0,1' . (!empty($options) ? ',' . implode(',', $options) : '');
									else
									{
										$row['options'] = '0,1,' . strtr($txt['cffp_field_empty_value'], array(',' => '')) . (!empty($options) ? ',' . implode(',', $options) : '');
										if (0 < strlen($row['options_text']))
											$row['options_text'] = strtr($txt['cffp_field_empty_value'], array(',' => '')) . ',' . $row['options_text'];
									}
								}
								break;
							}
							case 'empty_non_empty': // type IN (text, textarea, select, combobox, radio, check).
							{
								$row['type_filter'] = 'select';
								$row['options'] = '0,1,empty,non-empty';
								$row['options_text'] = strtr($txt['cffp_field_empty_value'], array(',' => '')) . ',' . strtr($txt['cffp_field_non_empty_value'], array(',' => ''));
								break;
							}
						}
						$row['type'] = $row['type_filter'];
						if ('filters' != $cffp_action)
							$row['show_filter_used_options'] = 0;
						elseif ($row['show_filter_used_options'])
						{
							global $board;
							$row['show_filter_used_options'] = $board;
						}
						$row['not_empty_value'] = 0;
						$row['empty_option_text'] = $txt[190];
						$value = cffpGetRequestValueOfField($id_group, $name_field, $row['type'], $row['length'], $row['options']);
						$operator = cffpGetRequestFilterOperator($id_group, $name_field, $row['type']);

						$field_array[$id_group][$row['ID_FIELD']] = array(
							'name' => $row['name'],
							'field_desc' => 'filters' != $cffp_action ? $row['field_search_desc'] : '',
							'field_long_desc' => 'filters' != $cffp_action ? parse_bbc(censorText($row['field_search_long_desc'])) : '',
							'html' => cffpHtmlOfField($row, $value, false, $id_group, $name_field),
							'html_operator' => $row['show_filter_operator'] ? cffpHtmlOfFilterOperator($select_multiple, $operator, $id_group, $name_field) : '',
						);
					}

					if ('filters' == $cffp_action)
					{
						$group_array[$id_group]['filter_tags'] = array();
						foreach ($group['settings_fields'] as $row)
							$group_array[$id_group]['filter_tags'][$row['hide_filter']][] = $row['ID_FIELD'];
					}
				}
			}
			break;
		}
	}

	$context['cffp'][$cffp_action] = array(
		'id_msg' => $id_msg,
		'sticky' => !empty($data_msg) ? $data_msg['sticky'] : null,
		'locked' => !empty($data_msg) ? $data_msg['locked'] : null,
		'first_msg' => !empty($data_msg) ? $data_msg['first_msg'] : null,
		'subject' => !empty($data_msg) ? $data_msg['subject'] : '',
		'id_member_poster' => $id_member_poster,
		'user' => $user,
		'group_array' => $group_array,
		'field_array' => $field_array,
	);
}

// Loads data of message and topic.
function cffpLoadDataMsgTopic($id_msg_array, $id_topic_array = array())
{
	global $db_prefix, $context;

	if (!empty($id_msg_array))
	{
		if (!is_array($id_msg_array))
			$id_msg_array = array($id_msg_array);

		foreach ($id_msg_array as $k => $id_msg)
		{
			if (isset($context['cffp']['data_msg_topic'][$id_msg]))
				unset($id_msg_array[$k]);
			else
				$context['cffp']['data_msg_topic'][$id_msg] = array();
		}

		if (empty($id_msg_array))
			return;

		$request = db_query("
			SELECT t.isSticky AS sticky, t.locked, m.ID_MSG, (t.ID_FIRST_MSG = m.ID_MSG) AS first_msg, m.subject
			FROM {$db_prefix}topics AS t
				INNER JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC = t.ID_TOPIC)
			WHERE ID_MSG IN (" . implode(', ', $id_msg_array) . ")", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
			$context['cffp']['data_msg_topic'][$row['ID_MSG']] = $row;
		mysql_free_result($request);
	}
	elseif (!empty($id_topic_array))
	{
		if (!is_array($id_topic_array))
			$id_topic_array = array($id_topic_array);

		foreach ($id_topic_array as $k => $id_topic)
		{
			if (isset($context['cffp']['data_msg_topic']['topic_' . $id_topic]))
				unset($id_topic_array[$k]);
			else
				$context['cffp']['data_msg_topic']['topic_' . $id_topic] = array();
		}

		if (empty($id_topic_array))
			return;

		$request = db_query("
			SELECT isSticky AS sticky, locked, ID_TOPIC
			FROM {$db_prefix}topics
			WHERE ID_TOPIC IN (" . implode(', ', $id_topic_array) . ")", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			$context['cffp']['data_msg_topic']['topic_' . $row['ID_TOPIC']] = $row;
			$context['cffp']['data_msg_topic']['topic_' . $row['ID_TOPIC']]['first_msg'] = 0;
			$context['cffp']['data_msg_topic']['topic_' . $row['ID_TOPIC']]['subject'] = '';
		}
		mysql_free_result($request);
	}
}

// Loads value of fields by post.
function cffpLoadValueOfFieldsByMsg($id_msg_array, $reload = false)
{
	global $db_prefix, $context;

	if (empty($id_msg_array))
		return;

	if (!is_array($id_msg_array))
		$id_msg_array = array($id_msg_array);

	foreach ($id_msg_array as $k => $id_msg)
	{
		if (isset($context['cffp']['fields_value'][$id_msg]) && !$reload)
			unset($id_msg_array[$k]);
		else
			$context['cffp']['fields_value'][$id_msg] = array(array(), array());
	}

	if (empty($id_msg_array))
		return;

	$request = db_query("
		SELECT g.type, f." . implode(', f.', $context['cffp']['list_columns']['fields']) . "
		FROM {$db_prefix}cffp_fields AS f
			INNER JOIN {$db_prefix}cffp_settings_groups AS g ON (g.ID_GROUP = f.ID_GROUP)
		WHERE ID_MSG IN (" . implode(', ', $id_msg_array) . ")
		ORDER BY f.posterTime ASC", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		// Fields of groups type member may have more than one value.
		if ('member' == $row['type'])
			$context['cffp']['fields_value'][$row['ID_MSG']][1][$row['ID_GROUP']][] = $row;
		// Fields of others group have one value.
		else
			$context['cffp']['fields_value'][$row['ID_MSG']][0][$row['ID_GROUP']] = $row;
	}
	mysql_free_result($request);
}

// Loads count groups.
function cffpLoadCountGroups($id_member = 0)
{
	global $db_prefix, $txt;

	if (empty($id_member))
	{
		$request = db_query("
			SELECT g.ID_GROUP, counter_name, name, SUM(groups) AS sum_groups
			FROM {$db_prefix}cffp_settings_groups AS g
				LEFT JOIN {$db_prefix}cffp_count_groups AS cg ON (cg.ID_GROUP = g.ID_GROUP)
			WHERE counter_show = 1
				AND active = 1
			GROUP BY g.ID_GROUP
			ORDER BY group_order ASC", __FILE__, __LINE__);
	}
	else
	{
		$request = db_query("
			SELECT g.ID_GROUP, counter_name, name, groups
			FROM {$db_prefix}cffp_settings_groups AS g
				LEFT JOIN {$db_prefix}cffp_count_groups AS cg ON (cg.ID_GROUP = g.ID_GROUP AND ID_MEMBER = $id_member)
			WHERE counter_show = 1
				AND active = 1
			ORDER BY group_order ASC", __FILE__, __LINE__);
	}

	$count_groups = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (!cffpIsNotEmptyString($row['counter_name']))
			$row['counter_name'] = $row['name'];
		$row['counter_name_total'] = sprintf($txt['cffp_counter_total'], $row['counter_name']);
		if (empty($id_member))
			$row['groups'] = $row['sum_groups'];
		if (!cffpIsNotEmptyString($row['groups']))
		{
			if (empty($id_member))
			{
				cffpUpdateCountGroupAllMembers($row['ID_GROUP']);
				$request2 = db_query("
					SELECT SUM(groups) AS sum_groups
					FROM {$db_prefix}cffp_count_groups
					WHERE ID_GROUP = " . $row['ID_GROUP'], __FILE__, __LINE__);
				$row2 = mysql_fetch_assoc($request2);
				mysql_free_result($request2);
				$row['groups'] = $row2 ? $row2['sum_groups'] : 0;
			}
			else
			{
				cffpUpdateCountGroup($id_member, $row['ID_GROUP']);
				$request2 = db_query("
					SELECT groups
					FROM {$db_prefix}cffp_count_groups
					WHERE ID_MEMBER = $id_member
						AND ID_GROUP = " . $row['ID_GROUP'], __FILE__, __LINE__);
				$row2 = mysql_fetch_assoc($request2);
				mysql_free_result($request2);
				$row['groups'] = $row2 ? $row2['groups'] : 0;
			}
		}
		$row['real_groups'] = $row['groups'];
		$row['special_groups'] = 100000 < $row['groups'] && !empty($id_member) ? $txt[683] : (1337 == $row['groups'] && !empty($id_member) ? 'leet' : comma_format($row['groups']));
		$row['groups'] = comma_format($row['groups']);
		$count_groups[] = $row;
	}
	mysql_free_result($request);

	return $count_groups;
}

// Loads top posters of each type of record.
function cffpLoadTopPostersByRecord()
{
	global $db_prefix, $context, $txt;

	$top_posters = array();
	foreach ($context['cffp']['settings_groups'] as $id_group => $settings_group)
	{
		if (!$settings_group['top_poster_show'])
			continue;

		if (!cffpIsNotEmptyString($settings_group['top_poster_name']))
			$settings_group['top_poster_name'] = $settings_group['name'];
		$settings_group['top_poster_name'] = sprintf($txt['cffp_top_posters'], $settings_group['top_poster_name']);

		$request = db_query("
			SELECT mem.ID_MEMBER, realName, groups
			FROM {$db_prefix}cffp_count_groups AS cg
				INNER JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = cg.ID_MEMBER)
			WHERE cg.ID_GROUP = $id_group
				AND groups > 0
			ORDER BY groups DESC
			LIMIT 10", __FILE__, __LINE__);
		$settings_group['top_posters'] = array();
		while ($row = mysql_fetch_assoc($request))
			$settings_group['top_posters'][] = $row;
		mysql_free_result($request);

		$top_posters[] = $settings_group;
	}

	return $top_posters;
}

// Loads statistics of a group by post.
function cffpLoadStatsOfGroupByMsg($id_group, $id_msg_array, $reload = false)
{
	global $db_prefix, $context;

	if (empty($id_group) || empty($id_msg_array) || !$context['cffp']['settings_groups'][$id_group]['show_stats'])
		return array();

	if (!is_array($id_msg_array))
		$id_msg_array = array($id_msg_array);

	$request = db_query("
		SELECT " . implode(', ', $context['cffp']['list_columns']['stats']) . "
		FROM {$db_prefix}cffp_stats
		WHERE ID_MSG IN (" . implode(', ', $id_msg_array) . ")
			AND ID_GROUP = $id_group", __FILE__, __LINE__);
	$stats = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$stats[$row['ID_MSG']] = array();
		foreach ($context['cffp']['list_columns']['stats'] as $column)
		{
			switch ($column)
			{
				case 'data':
				{
					$stats[$row['ID_MSG']][$column] = unserialize($row[$column]);
					break;
				}
				case 'options_text':
				{
					$stats[$row['ID_MSG']][$column] = 0 < strlen($row[$column]) ? explode(',', $row[$column]) : array();
					break;
				}
				case 'average':
				case 'sum':
				{
					$stats[$row['ID_MSG']][$column] = is_numeric($row[$column]) ? (float) $row[$column] : '';
					break;
				}
				case 'max':
				case 'min':
				{
					$stats[$row['ID_MSG']][$column . '_num'] = is_numeric($row[$column]) ? (float) $row[$column] : '';
					$stats[$row['ID_MSG']][$column] = is_numeric($row[$column]) ? $stats[$row['ID_MSG']]['data'][$row[$column]]['text'] : '';
					break;
				}
				case 'highest':
				case 'lowest':
				{
					$stats[$row['ID_MSG']][$column] = is_numeric($row[$column]) ? $stats[$row['ID_MSG']]['data'][$row[$column]]['text'] : '';
					break;
				}
				case 'most_frequent':
				case 'least_frequent':
				{
					$stats[$row['ID_MSG']][$column] = 0 < strlen($row[$column]) ? explode(',', $row[$column]) : array();
					foreach ($stats[$row['ID_MSG']][$column] as $k => $v)
						$stats[$row['ID_MSG']][$column][$k] = $stats[$row['ID_MSG']]['data'][$v]['text'];
					break;
				}
				default: // is_numeric, total.
				{
					$stats[$row['ID_MSG']][$column] = $row[$column];
					break;
				}
			}
		}
	}
	mysql_free_result($request);

	if ($reload)
	{
		if (!empty($stats))
			$id_msg_array = array_diff($id_msg_array, array_keys($stats));

		if (!empty($id_msg_array))
		{
			cffpUpdateStats($id_group, $id_msg_array);
			$stats2 = cffpLoadStatsOfGroupByMsg($id_group, $id_msg_array);
			foreach ($stats2 as $id_msg => $s2)
				$stats[$id_msg] = $s2;
		}
	}

	return $stats;
}

// Gets statistics of a group.
function cffpGetStats($stats, $group, $pos)
{
	global $txt;

	if (!empty($group['show_stats_' . $pos . '_chart_average']) && $stats['is_numeric'])
	{
		$chart_average = explode(',', $group['show_stats_' . $pos . '_chart_average']);
		$stats['chart_average'] = array(
			'show' => true,
			'average' => in_array('average', $chart_average),
			'minmax' => in_array('minmax', $chart_average),
			'options_text' => in_array('options_text', $chart_average),
		);
	}

	if (!empty($group['show_stats_' . $pos . '_chart_hbars']))
	{
		$stats['chart_hbars'] = array(
			'show' => true,
		);
	}

	if (!empty($group['show_stats_' . $pos . '_chart_vbars']))
	{
		$chart_vbars = explode(',', $group['show_stats_' . $pos . '_chart_vbars']);
		$stats['chart_vbars'] = array(
			'show' => true,
			'options_text' => in_array('options_text', $chart_vbars),
			'width_category' => floor(100 / count($stats['data']) * 100) / 100 . '%',
		);
	}

	if (!empty($group['show_stats_' . $pos . '_summary']))
	{
		$summary = explode(',', $group['show_stats_' . $pos . '_summary']);
		$stats['summary'] = array();
		foreach ($summary as $s)
		{
			if (($stats['is_numeric'] && in_array($s, array('average', 'sum', 'max', 'min', 'highest', 'lowest'))) || in_array($s, array('most_frequent', 'least_frequent', 'total')))
			{
				$stats['summary'][$s] = array(
					$txt['cffp_show_stats_summary_' . $s],
					$stats[$s],
				);
			}
		}
	}

	if (!empty($group['show_stats_' . $pos . '_value']))
	{
		if (($stats['is_numeric'] && in_array($group['show_stats_' . $pos . '_value'], array('average', 'sum', 'max', 'min', 'highest', 'lowest'))) || in_array($group['show_stats_' . $pos . '_value'], array('most_frequent', 'least_frequent', 'total')))
			$stats['value'] = $stats[$group['show_stats_' . $pos . '_value']];
	}

	if (empty($stats['chart_average']) && empty($stats['chart_hbars']) && empty($stats['chart_vbars']) && empty($stats['summary']) && !isset($stats['value']))
		$stats = array();
	elseif (!isset($stats['value']))
		$stats['text'] = $group['show_stats_' . $pos . '_text'];

	return $stats;
}

// Returns HTML code with template.
function cffpParseTemplate($text, $type, $trans = array())
{
	global $context, $boardurl, $scripturl, $settings;

	if ('php' == $type)
	{
		$trans['{SHOW_GROUP_MSG}'] = 'cffpShowGroupMsg';
		$trans['{SHOW_GROUP_MSGINDEX}'] = 'cffpShowGroupMsgIndex';
		$trans['{SHOW_GROUP_MSG_STATS}'] = 'cffpShowGroupMsgStats';
	}
	$trans = array_merge($trans, $context['cffp']['settings_vars'], array(
		'{BOARDURL}' => $boardurl,
		'{SCRIPTURL}' => $scripturl,
		'{IMAGES_URL}' => $settings['images_url'],
		'{DEFAULT_IMAGES_URL}' => $settings['default_images_url'],
	));
	$text = strtr($text, $trans);

	switch ($type)
	{
		case 'bbc':
		{
			$text = parse_bbc(censorText($text));
			break;
		}
		case 'php':
		{
			$text = trim($text);

			if ('<?php' == substr($text, 0, 5))
				$text = substr($text, 5);
			if ('?>' == substr($text, -2))
				$text = substr($text, 0, -2);

			ob_start();
			cffpEval($text);
			$text = ob_get_contents();
			ob_end_clean();
			break;
		}
		case 'html':
		default:
		{
			// VOID
			break;
		}
	}

	return $text;
}

// Shows a group of a message.
function cffpShowGroup($cffp_action, $id_msg, $id_group)
{
	global $db_prefix, $context;

	loadTemplate('CustomFieldFilterPost');

	$request = db_query("
		SELECT ID_MEMBER, ID_BOARD
		FROM {$db_prefix}messages
		WHERE ID_MSG = $id_msg", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($request);
	mysql_free_result($request);

	if (!$row)
		return;

	cffpLoadValueOfFieldsByMsg($id_msg);
	cffpLoadDataMsgTopic($id_msg);

	if (isset($context['cffp'][$cffp_action]))
		$context_cffp_action = $context['cffp'][$cffp_action];

	cffpLoad($id_msg, $row['ID_MEMBER'], $cffp_action, $row['ID_BOARD'], $id_group);
	template_cffp_show($cffp_action);

	if (isset($context_cffp_action))
		$context['cffp'][$cffp_action] = $context_cffp_action;
	else
		unset($context['cffp'][$cffp_action]);
}

// Shows a group of a message like in a message.
function cffpShowGroupMsg($id_msg, $id_group)
{
	cffpShowGroup('display_readonly', $id_msg, $id_group);
}

// Shows a group of a message like on the message index.
function cffpShowGroupMsgIndex($id_msg, $id_group)
{
	cffpShowGroup('message_index', $id_msg, $id_group);
}

// Shows statistical data of the group of a message.
function cffpShowGroupMsgStats($id_msg, $id_group, $type, $params = '')
{
	if (empty($id_msg) || empty($id_group) || !in_array($type, array('chart_average', 'chart_hbars', 'chart_vbars', 'summary', 'value')))
		return;

	if (empty($params))
	{
		if (in_array($type, array('chart_average', 'chart_hbars', 'chart_vbars')))
			$params = 'show';
		else // summary, value.
			return;
	}

	$stats = cffpLoadStatsOfGroupByMsg($id_group, $id_msg, true);
	if (empty($stats))
		return;

	$group = array(
		'show_stats_post_' . $type => $params,
		'show_stats_post_text' => '',
	);
	$stats = cffpGetStats($stats[$id_msg], $group, 'post');
	if (empty($stats))
		return;

	if ('value' == $type)
		echo is_array($stats['value']) ? implode('<br />', $stats['value']) : $stats['value'];
	else
		template_cffp_show_stats($stats, $type);
}

// Evaluates PHP code.
function cffpEval($cffp_eval)
{
	eval($cffp_eval);
}

// Saves custom post fields of groups type no member.
function cffpSaveGroupsPost($id_msg, $id_member_poster)
{
	global $txt, $context;

	if (empty($id_msg))
		return false;

	if (empty($_REQUEST['cffp']))
		return true;

	$user = cffpGetTypeUser();
	$owner = cffpIsOwner(false, $id_member_poster);
	$data_msg = cffpGetDataMsgTopic($id_msg);
	$group_array = cffpGetGroupsAndFieldsOfGroup($data_msg, 0, 'post', 0, $user, $owner);
	if (empty($group_array))
		return true;

	foreach ($group_array as $id_group => $group)
	{
		if (!isset($_REQUEST['cffp'][$id_group]))
			continue;

		if ('fields' == $group['type'])
		{
			// Are we saving?
			if (isset($_REQUEST['cffp'][$id_group]['set']))
			{
				// Do the insertion/updates.
				if (empty($_REQUEST['cffp'][$id_group]['ID_CFFP']))
					cffpInsertFields('post', $id_msg, $id_group, $group['settings_fields']);
				else
					cffpUpdateFields($_REQUEST['cffp'][$id_group]['ID_CFFP'], $id_group, $group['settings_fields']);
			}
			// Deleting?
			else
				cffpDeleteFields($_REQUEST['cffp'][$id_group]['ID_CFFP']);
		}
		else // record.
		{
			// Are we saving?
			if (isset($_REQUEST['cffp'][$id_group]['set']))
			{
				// Do the insertion/updates.
				if ($group['can_add'] && empty($_REQUEST['cffp'][$id_group]['ID_CFFP']))
					cffpInsertFields('post', $id_msg, $id_group, $group['settings_fields']);
				elseif ($group['can_modify'] && !empty($_REQUEST['cffp'][$id_group]['ID_CFFP']))
					cffpUpdateFields($_REQUEST['cffp'][$id_group]['ID_CFFP'], $id_group, $group['settings_fields']);
			}
			// Deleting?
			elseif ($group['can_remove'] && !empty($_REQUEST['cffp'][$id_group]['ID_CFFP']))
				cffpDeleteFields($_REQUEST['cffp'][$id_group]['ID_CFFP']);
		}
	}

	return true;
}

// Gets search pages.
function cffpGetSearchPages()
{
	global $context, $txt, $scripturl, $modSettings;

	$context['cffp']['search_pages'] = array();

	cffpLoad(0, 0, 'search_posts_menu');
	if (!empty($context['cffp']['search_posts_menu']) && (!$context['user']['is_guest'] || $modSettings['allow_guestAccess']))
	{
		$search_page_array = array();
		foreach ($context['cffp']['search_posts_menu']['group_array'] as $id_group => $group)
		{
			if (strpos($group['search_page_name'], ','))
			{
				$search_page_name_array = explode(',', $group['search_page_name']);
				$search_page_order_by_array = explode(',', $group['search_page_order_by']);
				foreach ($search_page_name_array as $k => $search_page_name)
					$search_page_array[] = $search_page_name . ',' . $search_page_order_by_array[$k];
			}
			else
				$search_page_array[] = $group['search_page_name'] . ',' . $group['search_page_order_by'];
		}
		$search_page_array = array_unique($search_page_array);
		sort($search_page_array);

		foreach ($search_page_array as $k => $search_page)
		{
			if (',' == substr($search_page, 0, 1))
			{
				$search_page_name = '';
				$search_page_order_by = substr($search_page, 1);
			}
			else
				list ($search_page_name, $search_page_order_by) = explode(',', $search_page);

			$context['cffp']['search_pages']['posts_' . $k] = array(
				'title' => cffpIsNotEmptyString($search_page_name) ? $search_page_name : $txt['cffp_search_posts'],
				'href' => $scripturl . '?action=cffpsearch;sa=search_posts;search_page=' . cffpUrlParamsCompress(array(array($search_page_name, $search_page_order_by))),
				'type' => 'posts',
				'search_page_name' => $search_page_name,
				'search_page_order_by' => $search_page_order_by,
			);
		}
	}

	cffpLoad(0, 0, 'search_records_menu');
	if (!empty($context['cffp']['search_records_menu']) && (!$context['user']['is_guest'] || $modSettings['allow_guestAccess']))
	{
		foreach ($context['cffp']['search_records_menu']['group_array'] as $id_group => $group)
		{
			$context['cffp']['search_pages']['records_' . $id_group] = array(
				'title' => cffpIsNotEmptyString($group['search_page_name']) ? $group['search_page_name'] : sprintf($txt['cffp_search_records_type'], $group['name']),
				'href' => $scripturl . '?action=cffpsearch;sa=search_records;ID_GROUP=' . $id_group,
				'type' => 'record',
				'id' => $id_group,
			);
		}
	}
}

// Search custom post fields.
function cffpSearch()
{
	global $context, $scripturl, $settings, $txt, $modSettings;

	loadTemplate('CustomFieldFilterPost');
	loadTemplate('GenericList-CustomFieldFilterPost');

	// This comes under the umbrella of search posts.
	isAllowedTo('search_posts');

	if (empty($context['cffp']['search_pages']))
		fatal_lang_error('error_cffp_search_not_allowed');

	if (empty($_GET['sa']) || !in_array($_GET['sa'], array('search_posts', 'search_records')) || ('search_records' == $_GET['sa'] && empty($_GET['ID_GROUP'])))
	{
		$search = reset($context['cffp']['search_pages']);
		if ('posts' == $search['type'])
		{
			$_GET['sa'] = 'search_posts';
			unset($_GET['ID_GROUP']);
			$_GET['search_page'] = cffpUrlParamsCompress(array(array($search['search_page_name'], $search['search_page_order_by'])));
		}
		else // record.
		{
			$_GET['sa'] = 'search_records';
			$_GET['ID_GROUP'] = $search['id'];
			unset($_GET['search_page']);
		}
	}

	// Set up the comforting bits...
	$context['page_title'] = $txt['cffp_search_posts_records'];

	// Sort out the context!
	$context['cffp_action'] = $_GET['sa'];
	$context['ID_GROUP'] = 'search_records' == $context['cffp_action'] ? (int) $_GET['ID_GROUP'] : 0;
	if ('search_posts' == $context['cffp_action'] && !empty($_GET['search_page']))
	{
		$search_page = cffpUrlParamsDecompress($_GET['search_page']);
		$context['search_page_name'] = $search_page[0][0];
		$context['search_page_order_by'] = $search_page[0][1];
	}
	else
	{
		$context['search_page_name'] = '';
		$context['search_page_order_by'] = '';
	}
	$context['search_page_compress'] = cffpUrlParamsCompress(array(array($context['search_page_name'], $context['search_page_order_by'])));

	if (isset($_REQUEST['cffp_search']))
		$_REQUEST['cffp'] = cffpUrlParamsDecompress($_REQUEST['cffp_search']);
	if (isset($_REQUEST['cffp_search_operator']))
		$_REQUEST['cffp_operator'] = cffpUrlParamsDecompress($_REQUEST['cffp_search_operator']);

	cffpLoad(0, 0, $context['cffp_action'], 0, $context['ID_GROUP'], $context['search_page_name']);
	if (empty($context['cffp'][$context['cffp_action']]))
		fatal_lang_error('error_cffp_search_not_allowed');

	$context['cffp_search']['expanded'] = empty($_REQUEST['no_expanded']);
	$context['cffp_search']['params'] = '';
	if (!$context['cffp_search']['expanded'])
		$context['cffp_search']['params'] .= ';no_expanded=1';
	if (isset($_REQUEST['cffp']))
		$context['cffp_search']['params'] .= ';cffp_search=' . cffpUrlParamsCompress($_REQUEST['cffp']);
	if (isset($_REQUEST['cffp_operator']))
		$context['cffp_search']['params'] .= ';cffp_search_operator=' . cffpUrlParamsCompress($_REQUEST['cffp_operator']);

	$context['cffp']['search'] = $context['cffp'][$context['cffp_action']];
	$context['page_desc'] = $txt['cffp_' . $context['cffp_action'] . '_desc'];
	$context['sub_template'] = 'cffp_' . $context['cffp_action'];

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=cffpsearch',
		'name' => $context['page_title'],
	);

	$links = array();
	foreach ($context['cffp']['search_pages'] as $k => $search)
	{
		$selected = false;
		if ('posts' == $search['type'] && 'search_posts' == $context['cffp_action'])
			$selected = $context['search_page_name'] == $search['search_page_name'];
		elseif ('record' == $search['type'] && 'search_records' == $context['cffp_action'])
			$selected = $context['ID_GROUP'] == $search['id'];

		$links[$k] = array(
			'href' => $search['href'],
			'label' => $search['title'],
			'selected' => $selected,
		);
	}
	$context['list_menu'] = array(
		'columns' => count($links),
		'show_on' => 'top',
		'links' => $links,
	);

	$items_per_page = !empty($modSettings['search_results_per_page']) ? $modSettings['search_results_per_page'] : 30;
	if ('search_posts' == $context['cffp_action'])
	{
		$title = $txt[21];
		$base_href = $scripturl . '?action=cffpsearch;sa=search_posts;search_page=' . $context['search_page_compress'] . $context['cffp_search']['params'];

		$get_count = cffpGetListSearchPostsSize();

		$headers = array(
			'sticky_locked' => array(
				'style' => 'width: 4%;',
			),
			'icon' => array(
				'style' => 'width: 4%;',
			),
			'm.subject' => array(
				'label' => $txt[70],
				'sort' => array(
					'default' => 'm.subject',
					'reverse' => 'm.subject DESC',
				),
			),
			'm.posterTime' => array(
				'label' => $txt['cffp_poster_time'],
				'style' => 'width: 18%;',
				'sort' => array(
					'default' => 'm.posterTime',
					'reverse' => 'm.posterTime DESC',
				),
			),
			'display_name' => array(
				'label' => $txt[279],
				'style' => 'width: 10%;',
				'sort' => array(
					'default' => 'display_name',
					'reverse' => 'display_name DESC',
				),
			),
		);

		$search_page_order_by = !empty($context['search_page_order_by']) ? $context['search_page_order_by'] : 'm.posterTime desc';
		list ($default_sort_col, $default_sort_dir) = explode(' ', $search_page_order_by);
		if (!isset($columns[$default_sort_col]))
			$default_sort_col = 'm.posterTime';

		if (isset($_REQUEST['sort']))
		{
			$sort = isset($headers[$_REQUEST['sort']]) && isset($headers[$_REQUEST['sort']]['sort']) ? $_REQUEST['sort'] : $default_sort_col;
			$desc = isset($_REQUEST['desc']);
		}
		else
		{
			$sort = $default_sort_col;
			$desc = 'desc' == $default_sort_dir;
		}
		$sort_order = $headers[$sort]['sort'][$desc ? 'reverse' : 'default'];
		$page_index = constructPageIndex($base_href . ';sort=' . $sort . ($desc ? ';desc' : ''), $_REQUEST['start'], $get_count, $items_per_page);
		$start = $_REQUEST['start'];
		$params_url = ';start=' . $start . ';sort=' . $sort . ($desc ? ';desc' : '');

		foreach ($headers as $col => $col_header)
		{
			if (isset($headers[$col]['sort']))
			{
				$headers[$col]['href'] = $base_href . ';sort=' . $col;
				if (!isset($_REQUEST['desc']) && $col == $sort)
					$headers[$col]['href'] .= ';desc';
				if ($col == $sort)
					$headers[$col]['sort_image'] = !isset($_REQUEST['desc']) ? 'down' : 'up';
				$headers[$col]['selected'] = $col == $sort;
			}
		}
		$num_columns = count($headers);

		$list = cffpGetListSearchPosts($start, $items_per_page, $sort_order);
		$rows = array();
		foreach ($list as $rowData)
		{
			$row = array();

			$text = '';
			if ($rowData['isSticky'])
				$text .= '<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" alt="' . $txt['cffp_show_filters_sticky'] . '" />';
			if ($rowData['locked'])
				$text .= '<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" alt="' . $txt['cffp_show_filters_locked'] . '" />';
			$row['sticky_locked'] = array(
				'value' => $text,
				'style' => 'text-align: center;',
			);

			// We need to check the topic icons exist...
			if (empty($modSettings['messageIconChecks_disable']))
			{
				if (!isset($context['icon_sources'][$rowData['icon']]))
					$context['icon_sources'][$rowData['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $rowData['icon'] . '.gif') ? 'images_url' : 'default_images_url';
			}
			else
			{
				if (!isset($context['icon_sources'][$rowData['icon']]))
					$context['icon_sources'][$rowData['icon']] = 'images_url';
			}
			$row['icon'] = array(
				'value' => '<img src="' . $settings[$context['icon_sources'][$rowData['icon']]] . '/post/' . $rowData['icon'] . '.gif" alt="" />',
				'style' => 'text-align: center;',
			);

			$href = $scripturl . '?topic=' . $rowData['ID_TOPIC'] . '.msg' . $rowData['ID_MSG'];
			$text = '';
			if ($rowData['new'] && $context['user']['is_logged'])
				$text .= '
					<a href="' . $href . '#new" id="newicon' . $rowData['ID_MSG'] . '"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt[302] . '" /></a>';

			cffpLoad($rowData['ID_MSG'], $rowData['ID_MEMBER'], 'message_index', $rowData['ID_BOARD']);
			cffpLoad($rowData['ID_MSG'], 0, 'message_index_member', $rowData['ID_BOARD']);

			ob_start();
			template_cffp_show('message_index');
			template_cffp_show('message_index_member');
			$text .= ob_get_contents();
			ob_end_clean();

			$row['m.subject'] = array(
				'value' => '<a href="' . $href . '#msg' . $rowData['ID_MSG'] . '">' . $rowData['subject'] . '</a>' . $text,
			);
			$row['m.posterTime'] = array(
				'value' => timeformat($rowData['posterTime']),
				'style' => 'text-align: center;',
			);
			$row['display_name'] = array(
				'value' => !empty($rowData['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $rowData['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $rowData['display_name'] . '">' . $rowData['display_name'] . '</a>' : $rowData['display_name'],
			);

			$rows[] = $row;
		}

		// Split groups in 2 columns.
		$group_num_fields_array = array();
		$group_order_array = array();
		foreach ($context['cffp']['search']['group_array'] as $id_group => $group)
		{
			$group_order_array[] = $id_group;
			$group_num_fields_array[$id_group] = count($group['settings_fields']);
		}
		arsort($group_num_fields_array);

		$column_num_fields_array = array(0, 0);
		$column_id_group_array = array(array(), array());
		foreach ($group_num_fields_array as $id_group => $num_fields)
		{
			$column = $column_num_fields_array[0] <= $column_num_fields_array[1] ? 0 : 1;
			$column_num_fields_array[$column] += $num_fields;
			$column_id_group_array[$column][] = $id_group;
		}

		$column_id_group_order_array = array(array(), array());
		foreach ($group_order_array as $id_group)
		{
			$column = in_array($id_group, $column_id_group_array[0]) ? 0 : 1;
			$column_id_group_order_array[$column][] = $id_group;
		}
		$context['cffp']['search']['columns_id_group'] = $column_id_group_order_array;
	}
	else // search_records.
	{
		$group = $context['cffp']['search']['group_array'][$context['ID_GROUP']];
		$cffp_record_settings_fields = $group['settings_fields'];

		$text_align = array(
			'text' => 'left',
			'text_email' => 'center',
			'text_number' => 'right',
			'textarea' => 'left',
			'select' => 'center',
			'select_multiple' => 'left',
			'combobox' => 'center',
			'combobox_multiple' => 'left',
			'radio' => 'center',
			'check' => 'left',
			'boolean' => 'center',
		);

		$title = $txt['cffp_records'];
		$base_href = $scripturl . '?action=cffpsearch;sa=search_records;ID_GROUP=' . $context['ID_GROUP'] . $context['cffp_search']['params'];

		$get_count = cffpGetListSearchRecordsSize();

		$headers = array();
		$headers['icon'] = array(
			'style' => 'width: 4%;',
		);
		if ($group['can_view'])
		{
			$headers['cffpf0.ID_MSG'] = array(
				'style' => 'width: 4%;',
			);
		}
		foreach ($group['show_record_list'] as $column => $show_record_list)
		{
			if (is_numeric($column))
			{
				$id_field = $column;
				$column_data = $show_record_list;

				if (!isset($cffp_record_settings_fields[$id_field]))
					$cffp_record_settings_fields[$id_field] = $context['cffp']['settings_groups'][$context['ID_GROUP']]['settings_fields'][$id_field];
				$name_field = 'column_' . $cffp_record_settings_fields[$id_field]['id_column'];

				$headers['cffpf0.' . $name_field] = array(
					'label' => $cffp_record_settings_fields[$id_field]['name'],
					'style' => !empty($column_data['show_record_list_width']) ? ('width: ' . $column_data['show_record_list_width'] . ';') : '',
					'sort' => array(
						'default' => 'cffpf0.' . $name_field,
						'reverse' => 'cffpf0.' . $name_field . ' DESC',
					),
				);
			}
			else
			{
				$name_field = $column;
				$column_data = $show_record_list[0];
				foreach ($show_record_list[1] as $id_field)
				{
					if (!isset($cffp_record_settings_fields[$id_field]))
						$cffp_record_settings_fields[$id_field] = $context['cffp']['settings_groups'][$context['ID_GROUP']]['settings_fields'][$id_field];
				}

				$headers['cffpf0.' . $name_field] = array(
					'label' => $column_data['show_record_list_name'],
					'style' => !empty($column_data['show_record_list_width']) ? ('width: ' . $column_data['show_record_list_width'] . ';') : '',
					'sort' => array(
						'default' => 'cffpf0.' . $name_field,
						'reverse' => 'cffpf0.' . $name_field . ' DESC',
					),
				);
			}
		}
		$headers['cffpf0.posterTime'] = array(
			'label' => $txt['cffp_poster_time'],
			'style' => !empty($group['show_record_list']) ? 'width: 10%;' : '',
			'sort' => array(
				'default' => 'cffpf0.posterTime',
				'reverse' => 'cffpf0.posterTime DESC',
			),
		);
		$headers['display_name'] = array(
			'label' => $txt[279],
			'style' => !empty($group['show_record_list']) ? 'width: 10%;' : '',
			'sort' => array(
				'default' => 'display_name',
				'reverse' => 'display_name DESC',
			),
		);

		$search_page_order_by = !empty($group['search_page_order_by']) ? $group['search_page_order_by'] : 'cffpf0.posterTime desc';
		list ($default_sort_col, $default_sort_dir) = explode(' ', $search_page_order_by);
		if (!isset($columns[$default_sort_col]))
			$default_sort_col = 'cffpf0.posterTime';

		if (isset($_REQUEST['sort']))
		{
			$sort = isset($headers[$_REQUEST['sort']]) && isset($headers[$_REQUEST['sort']]['sort']) ? $_REQUEST['sort'] : $default_sort_col;
			$desc = isset($_REQUEST['desc']);
		}
		else
		{
			$sort = $default_sort_col;
			$desc = 'desc' == $default_sort_dir;
		}
		$sort_order = $headers[$sort]['sort'][$desc ? 'reverse' : 'default'];
		$page_index = constructPageIndex($base_href . ';sort=' . $sort . ($desc ? ';desc' : ''), $_REQUEST['start'], $get_count, $items_per_page);
		$start = $_REQUEST['start'];
		$params_url = ';start=' . $start . ';sort=' . $sort . ($desc ? ';desc' : '');

		foreach ($headers as $col => $col_header)
		{
			if (isset($headers[$col]['sort']))
			{
				$headers[$col]['href'] = $base_href . ';sort=' . $col;
				if (!isset($_REQUEST['desc']) && $col == $sort)
					$headers[$col]['href'] .= ';desc';
				if ($col == $sort)
					$headers[$col]['sort_image'] = !isset($_REQUEST['desc']) ? 'down' : 'up';
				$headers[$col]['selected'] = $col == $sort;
			}
		}
		$num_columns = count($headers);

		$list = cffpGetListSearchRecords($start, $items_per_page, $sort_order);
		$rows = array();
		foreach ($list as $rowData)
		{
			$row = array();

			// We need to check the topic icons exist...
			if (empty($modSettings['messageIconChecks_disable']))
			{
				if (!isset($context['icon_sources'][$rowData['icon']]))
					$context['icon_sources'][$rowData['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $rowData['icon'] . '.gif') ? 'images_url' : 'default_images_url';
			}
			else
			{
				if (!isset($context['icon_sources'][$rowData['icon']]))
					$context['icon_sources'][$rowData['icon']] = 'images_url';
			}
			$row['icon'] = array(
				'value' => '<img src="' . $settings[$context['icon_sources'][$rowData['icon']]] . '/post/' . $rowData['icon'] . '.gif" alt="" />',
				'style' => 'text-align: center;',
			);

			if ($group['can_view'])
			{
				$row['cffpf0.ID_MSG'] = array(
					'value' => '<a href="' . $scripturl . '?topic=' . $rowData['ID_TOPIC'] . '.msg' . $rowData['ID_MSG'] . '#msg' . $rowData['ID_MSG'] . '">' . $txt[305] . '</a>',
					'style' => 'text-align: center;',
				);
			}

			foreach ($group['show_record_list'] as $column => $show_record_list)
			{
				if (is_numeric($column))
				{
					$id_field = $column;

					$name_field = 'column_' . $cffp_record_settings_fields[$id_field]['id_column'];

					$type_align = $cffp_record_settings_fields[$id_field]['type'];
					switch ($cffp_record_settings_fields[$id_field]['type'])
					{
						case 'text':
						{
							if (in_array($cffp_record_settings_fields[$id_field]['mask'], array('email', 'number')))
								$type_align .= '_' . $cffp_record_settings_fields[$id_field]['mask'];
							break;
						}
						case 'select':
						case 'combobox':
						{
							$options = explode(',', $cffp_record_settings_fields[$id_field]['options']);
							$select_multiple = array_shift($options);
							if ($select_multiple)
								$type_align .= '_multiple';
							break;
						}
					}

					$row['cffpf0.' . $name_field] = array(
						'value' => cffpHtmlOfField($cffp_record_settings_fields[$id_field], $rowData[$name_field], true, $rowData['ID_MSG']),
						'style' => 'text-align: ' . (!empty($text_align[$type_align]) ? $text_align[$type_align] : 'center') . ';',
					);
				}
				else
				{
					$name_field = $column;
					$text = '';
					foreach ($show_record_list[1] as $id_field)
					{
						$name_field2 = 'column_' . $cffp_record_settings_fields[$id_field]['id_column'];

						$text2 = cffpHtmlOfField($cffp_record_settings_fields[$id_field], $rowData[$name_field2], true, $rowData['ID_MSG']);
						if (cffpIsNotEmptyString($text2))
						{
							if (cffpIsNotEmptyString($text))
								$text .= '<br />';
							$text .= $text2;
						}
					}

					$row['cffpf0.' . $name_field] = array(
						'value' => $text,
						'style' => 'text-align: left;',
					);
				}
			}

			$row['cffpf0.posterTime'] = array(
				'value' => timeformat($rowData['posterTime']),
				'style' => 'text-align: center;',
			);
			$row['display_name'] = array(
				'value' => !empty($rowData['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $rowData['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $rowData['display_name'] . '">' . $rowData['display_name'] . '</a>' : $rowData['display_name'],
			);

			$rows[] = $row;
		}
	}

	// Result.
	$context['cffp_search_result'] = array(
		'title' => $title,
		'no_items_label' => $txt[170],
		'items_per_page' => $items_per_page,
		'page_index' => $page_index,
		'num_columns' => $num_columns,
		'headers' => $headers,
		'rows' => $rows,
	);
}

// Compress parameters of URL.
function cffpUrlParamsCompress($params)
{
	// All search params have been checked, let's compile them to a single string... made less simple by PHP 4.3.9 and below.
	$temp_params = $params;
	$params = array();
	foreach ($temp_params as $k => $v)
	{
		$kv2 = array();
		foreach ($v as $k2 => $v2)
			$kv2[] = $k2 . '|+|' . $v2;
		$params[] = $k . '|\'|' . implode('|-|', $kv2);
	}

	if (!empty($params))
	{
		$params = implode('|"|', $params);
		// Due to old IE's 2083 character limit, we have to compress long search strings
		$temp_params = @gzcompress($params);
		// Gzcompress failed, use try non-gz
		if (!empty($temp_params))
			$params = $temp_params;
		// Base64 encode, then replace +/= with uri safe ones that can be reverted
		$params = str_replace(array('+', '/', '='), array('-', '_', '.'), base64_encode($params));
	}

	return $params;
}

// Decompress parameters of URL.
function cffpUrlParamsDecompress($params)
{
	if (!empty($params))
	{
		// Due to IE's 2083 character limit, we have to compress long search strings
		$params = base64_decode(str_replace(array('-', '_', '.'), array('+', '/', '='), $params));
		// Test for gzuncompress failing
		$temp_params = @gzuncompress($params);
		$temp_params = explode('|"|', (!empty($temp_params) ? $temp_params : $params));

		$params = array();
		foreach ($temp_params as $data)
		{
			@list ($k, $v) = explode('|\'|', $data);
			$kv2_array = explode('|-|', $v);
			foreach ($kv2_array as $kv2)
			{
				@list ($k2, $v2) = explode('|+|', $kv2);
				$params[$k][$k2] = $v2;
			}
		}
	}

	return $params;
}

// Validates value with mask.
function cffpValidateMask($mask, $value)
{
	global $func;

	$error = '';
	if (!empty($mask) && $mask != 'none')
	{
		if ('email' == $mask && (0 === preg_match('~^[0-9A-Za-z=_+\-/][0-9A-Za-z=_\'+\-/\.]*@[\w\-]+(\.[\w\-]+)*(\.[\w]{2,6})$~', $value)))
			$error = 'cffp_group_invalid_email';
		elseif ('number' == $mask && (!is_numeric($value) || $value != (int) $value))
			$error = 'cffp_group_not_number';
		elseif ('regex' == $func['substr']($mask, 0, 5) && 0 === preg_match($func['substr']($mask, 5), $value))
			$error = 'cffp_group_inproper_format';
	}

	return $error;
}

// Validates values of custom post fields on $_REQUEST['cffp'] array.
function cffpValidateRequest($type, $id_msg, $cffp_action)
{
	global $context, $func, $sourcedir, $modSettings, $db_prefix;

	if ('return_post_errors' == $cffp_action)
		$post_errors = array();

	if (empty($_REQUEST['cffp']))
	{
		if ('return_post_errors' == $cffp_action)
			return $post_errors;
		else // fill_context.
			return;
	}

	$error = array();
	foreach ($_REQUEST['cffp'] as $id_group => $group)
	{
		if ('post' == $type && !empty($group['set']) && 0 < strlen($_REQUEST['subject']) && !empty($group['no_show_with_subject_prefix']))
		{
			$subject_prefix = explode(',', $group['no_show_with_subject_prefix']);
			foreach ($subject_prefix as $pre)
			{
				if (0 === $func['strpos']($_REQUEST['subject'], $pre))
				{
					unset($_REQUEST['cffp'][$id_group]['set']);
					continue 2; // Exit foreach $subject_prefix and continue foreach $_REQUEST['cffp'].
				}
			}
		}

		// Guest name and email.
		if ((('post' == $type && !empty($id_msg) && !empty($group['set'])) || 'member' == $type) && empty($group['ID_CFFP']) && $context['user']['is_guest'])
		{
			$_REQUEST['cffp'][$id_group]['guest_name'] = !isset($group['guest_name']) ? '' : trim($group['guest_name']);
			$_REQUEST['cffp'][$id_group]['guest_email'] = !isset($group['guest_email']) ? '' : trim($group['guest_email']);

			// Validate the name and email.
			if (!isset($_REQUEST['cffp'][$id_group]['guest_name']) || trim(strtr($_REQUEST['cffp'][$id_group]['guest_name'], '_', ' ')) == '')
				$error[$id_group]['cffp_group_no_name'] = true;
			elseif ($func['strlen']($_REQUEST['cffp'][$id_group]['guest_name']) > 25)
				$error[$id_group]['cffp_group_long_name'] = true;
			else
			{
				require_once($sourcedir . '/Subs-Members.php');
				if (isReservedName(htmlspecialchars($_REQUEST['cffp'][$id_group]['guest_name']), 0, true, false))
					$error[$id_group]['cffp_group_bad_name'] = true;
			}

			if (empty($modSettings['guest_post_no_email']))
			{
				if (!isset($_REQUEST['cffp'][$id_group]['guest_email']) || $_REQUEST['cffp'][$id_group]['guest_email'] == '')
					$error[$id_group]['cffp_group_no_email'] = true;
				else
				{
					$error_code = cffpValidateMask('email', $_REQUEST['cffp'][$id_group]['guest_email']);
					if (!empty($error_code))
						$error[$id_group]['cffp_group_bad_email'] = true;
				}
			}
		}

		if (!isset($group['set']) || !empty($group['without_fields']))
			continue;

		foreach ($context['cffp']['settings_groups'][$id_group]['settings_fields'] as $id_field => $settings_field)
		{
			$name_field = 'column_' . $settings_field['id_column'];
			if (!isset($group[$name_field]) && isset($group['name_fields'][$id_field]))
			{
				$_REQUEST['cffp'][$id_group][$name_field] = '';
				$group[$name_field] = '';
			}
			if (!isset($group[$name_field]))
				continue;

			// Not empty value.
			if ($settings_field['not_empty_value'] && !cffpIsNotEmptyString($group[$name_field]))
				$error[$id_group]['cffp_group_empty'][] = $id_field;

			// Unique value.
			if ($settings_field['unique_value'] && cffpIsNotEmptyString($group[$name_field]))
			{
				$request = db_query("
					SELECT $name_field
					FROM {$db_prefix}cffp_fields
					WHERE ID_GROUP = $id_group" . ('post' != $type || empty($id_msg) ? '' : "
						AND ID_MSG <> $id_msg") . ('member' != $type || empty($group['ID_CFFP']) ? '' : "
						AND ID_CFFP <> " . $group['ID_CFFP']) . "
						AND $name_field = '" . $group[$name_field] . "'", __FILE__, __LINE__);
				$num_rows = mysql_num_rows($request);
				mysql_free_result($request);
				if (0 < $num_rows)
					$error[$id_group]['cffp_group_value_not_unique'][] = $id_field;
			}

			// Mask.
			if (!empty($settings_field['mask']) && 'none' != $settings_field['mask'] && cffpIsNotEmptyString($group[$name_field]))
			{
				$error_code = cffpValidateMask($settings_field['mask'], $group[$name_field]);
				if (!empty($error_code))
					$error[$id_group][$error_code][] = $id_field;
			}
		}
	}

	foreach ($error as $id_group => $eg)
	{
		$group_name = $func['htmlspecialchars']($_REQUEST['cffp'][$id_group]['name'], ENT_QUOTES);
		foreach ($eg as $error_code => $ef)
		{
			if (is_array($ef))
			{
				foreach ($ef as $id_field)
				{
					$field_name = $func['htmlspecialchars']($_REQUEST['cffp'][$id_group]['name_fields'][$id_field], ENT_QUOTES);
					$error_code2 = $error_code . ',' . $id_field . ',' . $id_group;
					$context['cffp']['validate'][$error_code2] = array($field_name, $group_name);
					if ('return_post_errors' == $cffp_action)
						$post_errors[] = $error_code2;
					else // fill_context.
						$context['post_error'][$error_code2] = true;
				}
			}
			else
			{
				$error_code2 = $error_code . ',' . $id_group;
				$context['cffp']['validate'][$error_code2] = array($group_name);
				if ('return_post_errors' == $cffp_action)
					$post_errors[] = $error_code2;
				else // fill_context.
					$context['post_error'][$error_code2] = true;
			}
		}
	}

	if ('return_post_errors' == $cffp_action)
		return $post_errors;
}

// Inserts fields.
function cffpInsertFields($type, $id_msg, $id_group, $settings_fields)
{
	global $db_prefix, $user_info, $context, $sourcedir, $ID_MEMBER;

	if (empty($id_msg) || empty($id_group))
		return false;

	require_once ($sourcedir . '/Subs-Db-CustomFieldFilterPost-mysql.php');

	if ($context['user']['is_guest'])
	{
		if ('post' == $type)
		{
			// Guest creates a group of fields on post existent.
			if (isset($_REQUEST['cffp'][$id_group]['guest_name']))
			{
				$username = $_REQUEST['cffp'][$id_group]['guest_name'];
				$email = isset($_REQUEST['cffp'][$id_group]['guest_email']) ? $_REQUEST['cffp'][$id_group]['guest_email'] : '';
			}
			// Guest creates a group of fields on new post.
			else // isset($_REQUEST['guestname'])).
			{
				$username = $_REQUEST['guestname'];
				$email = isset($_REQUEST['email']) ? $_REQUEST['email'] : '';
			}
		}
		else // member.
		{
			$username = $_REQUEST['cffp'][$id_group]['guest_name'];
			$email = isset($_REQUEST['cffp'][$id_group]['guest_email']) ? $_REQUEST['cffp'][$id_group]['guest_email'] : '';
		}
		$_SESSION['guest_name'] = $username;
		$_SESSION['guest_email'] = $email;
	}
	// User no guest creates a group of fields.
	else
	{
		$username = $user_info['username'];
		$email = $user_info['email'];
	}

	$columns = array(
		'ID_MSG' => 'int', 'ID_GROUP' => 'int', 'ID_MEMBER' => 'int',
		'posterName' => 'string-255', 'posterEmail' => 'string-255', 'posterIP' => 'string-255', 'posterTime' => 'int',
		'modifiedName' => 'string', 'modifiedTime' => 'int',
	);
	$data = array(
		$id_msg, $id_group, $ID_MEMBER,
		$username, $email, $user_info['ip'], time(),
		'', 0,
	);
	foreach ($settings_fields as $row)
	{
		$name_field = 'column_' . $row['id_column'];
		$columns[$name_field] = 'string';
		$data[] = cffpGetRequestValueOfField($id_group, $name_field, $row['type'], $row['length'], $row['options']);
	}

	cffp_db_insert('',
		'cffp_fields',
		$columns, $data
	);
	$id_cffp = db_insert_id();

	// Update count.
	if (!empty($ID_MEMBER))
	{
		$request = db_query("
			SELECT ID_MSG
			FROM {$db_prefix}messages
			WHERE ID_MSG = $id_msg
				AND icon != 'recycled'", __FILE__, __LINE__);
		$num_rows = mysql_num_rows($request);
		mysql_free_result($request);
		if (0 < $num_rows)
			cffpUpdateCountGroup($ID_MEMBER, $id_group, 1);
	}

	return $id_cffp;
}

// Updates fields.
function cffpUpdateFields($id_cffp, $id_group, $settings_fields)
{
	global $modSettings, $user_info, $context, $txt, $db_prefix, $ID_MEMBER;

	if (empty($id_cffp) || empty($id_group))
		return false;

	$request = db_query("
		SELECT ID_MEMBER, posterTime
		FROM {$db_prefix}cffp_fields
		WHERE ID_CFFP = $id_cffp", __FILE__, __LINE__);
	$fields_value = mysql_fetch_assoc($request);
	mysql_free_result($request);

	$set = '';

	// Have admins allowed people to hide their screwups?
	if (time() - $fields_value['posterTime'] > $modSettings['edit_wait_time'] || $ID_MEMBER != $fields_value['ID_MEMBER'])
	{
		if ($context['user']['is_guest'])
			$modifiedName = isset($_SESSION['guest_name']) ? $_SESSION['guest_name'] : $txt[28];
		else
			$modifiedName = $user_info['name'];
		$set = "modifiedName = '$modifiedName', modifiedTime = " . time();
	}

	foreach ($settings_fields as $row)
	{
		$name_field = 'column_' . $row['id_column'];
		if (!empty($set))
			$set .= ', ';
		$set .= "$name_field = '" . cffpGetRequestValueOfField($id_group, $name_field, $row['type'], $row['length'], $row['options']) . "'";
	}

	db_query("
		UPDATE {$db_prefix}cffp_fields
		SET $set
		WHERE ID_CFFP = $id_cffp", __FILE__, __LINE__);
}

// Deletes fields.
function cffpDeleteFields($id_cffp)
{
	global $db_prefix;

	if (empty($id_cffp))
		return false;

	$request = db_query("
		SELECT ID_GROUP, f.ID_MEMBER, icon
		FROM {$db_prefix}cffp_fields AS f
			INNER JOIN {$db_prefix}messages AS m ON m.ID_MSG = f.ID_MSG
		WHERE ID_CFFP = $id_cffp", __FILE__, __LINE__);
	$fields_value = mysql_fetch_assoc($request);
	mysql_free_result($request);

	if ($fields_value)
	{
		db_query("
			DELETE FROM {$db_prefix}cffp_fields
			WHERE ID_CFFP = $id_cffp", __FILE__, __LINE__);

		if ('recycled' != $fields_value['icon'] && !empty($fields_value['ID_MEMBER']))
			cffpUpdateCountGroup($fields_value['ID_MEMBER'], $fields_value['ID_GROUP'], -1);
	}
}

// Moves fields.
function cffpMoveFields($id_group, $id_cffp, $msg_from, $msg_to)
{
	global $db_prefix, $context;

	if (empty($id_group) || empty($msg_from) || empty($msg_to))
		return false;

	// Get messages data.
	$request = db_query("
		SELECT ID_MSG, ID_MEMBER, posterName, posterEmail, posterIP, icon
		FROM {$db_prefix}messages
		WHERE ID_MSG IN ($msg_from, $msg_to)", __FILE__, __LINE__);
	$msg_array = array();
	while ($row = mysql_fetch_assoc($request))
		$msg_array[$row['ID_MSG']] = $row;
	mysql_free_result($request);

	// Prepare count.
	$group_record = 'record' == $context['cffp']['settings_groups'][$id_group]['type'];
	$group_no_member = 'member' != $context['cffp']['settings_groups'][$id_group]['type'];
	$change_member = $msg_array[$msg_from]['ID_MEMBER'] != $msg_array[$msg_to]['ID_MEMBER'];
	$count_from = 'recycled' != $msg_array[$msg_from]['icon'];
	$count_to = 'recycled' != $msg_array[$msg_to]['icon'];

	$inc = 0;
	if ($group_record && (($change_member && ($count_from || $count_to)) || ($count_from xor $count_to)))
	{
		// Only have one record for each group in a message.
		$request = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}cffp_fields
			WHERE ID_MSG = $msg_from
				AND ID_GROUP = $id_group" . (!empty($id_cffp) ? "
				AND ID_CFFP = $id_cffp" : ''), __FILE__, __LINE__);

		list ($inc) = mysql_fetch_row($request);
		mysql_free_result($request);
	}

	// Move.
	db_query("
		UPDATE {$db_prefix}cffp_fields
		SET
			ID_MSG = $msg_to" . ($group_no_member ? ",
			ID_MEMBER = " . $msg_array[$msg_to]['ID_MEMBER'] . ",
			posterName = '" . addslashes($msg_array[$msg_to]['posterName']) . "',
			posterEmail = '" . $msg_array[$msg_to]['posterEmail'] . "',
			posterIP = '" . $msg_array[$msg_to]['posterIP'] . "'" : '') . "
		WHERE ID_MSG = $msg_from
			AND ID_GROUP = $id_group" . (!empty($id_cffp) ? "
			AND ID_CFFP = $id_cffp": ''), __FILE__, __LINE__);

	// Count.
	if (!empty($inc)) // $group_record.
	{
		if ($change_member) // $count_from || $count_to.
		{
			if ($count_from)
				cffpUpdateCountGroup($msg_array[$msg_from]['ID_MEMBER'], $id_group, -$inc);
			if ($count_to)
				cffpUpdateCountGroup($msg_array[$msg_to]['ID_MEMBER'], $id_group, $inc);
		}
		else // $count_from xor $count_to.
		{
			$sign = $count_from && !$count_to ? -1 : 1;
			cffpUpdateCountGroup($msg_array[$msg_from]['ID_MEMBER'], $id_group, $sign * $inc);
		}
	}
}

// Updates statistics.
function cffpUpdateStats($id_group, $id_msg_array, $reload_settings = false)
{
	global $db_prefix, $context, $sourcedir;

	if (empty($id_group))
		return;

	require_once ($sourcedir . '/Subs-Db-CustomFieldFilterPost-mysql.php');

	if (empty($id_msg_array))
	{
		$request = db_query("
			SELECT DISTINCT ID_MSG
			FROM {$db_prefix}cffp_fields
			WHERE ID_GROUP = $id_group", __FILE__, __LINE__);
		$id_msg_array = array();
		while ($row = mysql_fetch_assoc($request))
			$id_msg_array[] = $row['ID_MSG'];
		mysql_free_result($request);
	}
	elseif (is_numeric($id_msg_array))
		$id_msg_array = array($id_msg_array);

	if (empty($id_msg_array))
		return;

	if ($reload_settings)
	{
		$request = db_query("
			SELECT " . implode(', ', $context['cffp']['list_columns']['settings_groups']) . "
			FROM {$db_prefix}cffp_settings_groups
			WHERE ID_GROUP = $id_group
				AND active = 1", __FILE__, __LINE__);
		$row = mysql_fetch_assoc($request);
		mysql_free_result($request);

		if (!$row)
			return;

		$id_group_array = array($id_group);
		$context['cffp']['settings_groups'][$id_group] = $row;
		$context['cffp']['settings_groups'][$id_group]['settings_fields'] = array();

		$request = db_query("
			SELECT " . implode(', ', $context['cffp']['list_columns']['settings_fields']) . "
			FROM {$db_prefix}cffp_settings_fields
			WHERE ID_GROUP IN (" . implode(', ', $id_group_array) . ")
				AND active = 1
			ORDER BY field_order ASC", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			$context['cffp']['settings_vars']['{FIELD_' . $row['ID_FIELD'] . '_DATABASE}'] = 'column_' . $row['id_column'];
			$context['cffp']['settings_groups'][$row['ID_GROUP']]['settings_fields'][$row['ID_FIELD']] = $row;
		}
		mysql_free_result($request);
	}
	elseif (!isset($context['cffp']['settings_groups'][$id_group]))
		return;

	$group = $context['cffp']['settings_groups'][$id_group];
	$show_stats = $group['show_stats'] && 1 == count($group['settings_fields']);
	if ($show_stats)
	{
		$settings_field = current($group['settings_fields']);
		switch ($settings_field['type'])
		{
			case 'select':
			{
				$options = explode(',', $settings_field['options']);
				$select_multiple = array_shift($options);
				array_shift($options);
				break;
			}
			case 'radio':
			case 'check':
			{
				$options = explode(',', $settings_field['options']);
				$select_multiple = 'check' == $settings_field['type'];
				break;
			}
			default:
			{
				$show_stats = 0;
				break;
			}
		}
	}

	if ($show_stats)
	{
		$fields = array(
			'data' => array(),
			'options_text' => array(),
			'is_numeric' => 1,
			'average' => '',
			'sum' => '',
			'max' => '',
			'min' => '',
			'highest' => '',
			'lowest' => '',
			'most_frequent' => '',
			'least_frequent' => '',
			'total' => '',
		);

		$trans = array();
		if (cffpIsNotEmptyString($settings_field['options_text']))
			$trans = array_combine($options, explode(',', $settings_field['options_text']));

		if (!empty($trans))
		{
			foreach ($trans as $value => $text)
			{
				$fields['data'][$value] = array(
					'value' => $value,
					'text' => $text,
					'num' => 0,
				);
				if ((string) $value != $text)
					$fields['options_text'][] = false === strpos($text, (string) $value) ? ($value . ' - ' . $text) : $text;
			}
		}
		else
		{
			foreach ($options as $value)
			{
				$fields['data'][$value] = array(
					'value' => $value,
					'text' => $value,
					'num' => 0,
				);
			}
		}
		$fields['data'][$value]['is_last'] = 1;
		$fields['options_text'] = !empty($fields['options_text']) ? implode(',', $fields['options_text']) : '';

		foreach ($fields['data'] as $value => $value_data)
		{
			if (!is_numeric($value))
			{
				$fields['is_numeric'] = 0;
				break; // Exit foreach.
			}
		}

		$data = $fields['data'];
		cffpLoadValueOfFieldsByMsg($id_msg_array, true);
		foreach ($id_msg_array as $id_msg)
		{
			// Set data.
			$fields['data'] = $data;
			$fields_value = cffpGetValueOfFieldsByMsg($id_msg, true);
			$fvm = isset($fields_value[$id_group]) ? $fields_value[$id_group] : array();
			foreach ($fvm as $fv)
			{
				$name_field = 'column_' . $settings_field['id_column'];
				$value = $fv[$name_field];

				if ($select_multiple)
				{
					$value_array = explode(',', $value);
					foreach ($value_array as $v)
					{
						if (!isset($fields['data'][$v]))
							continue;

						$fields['data'][$v]['num']++;
					}
				}
				else
				{
					if (!isset($fields['data'][$value]['num']))
						continue;

					$fields['data'][$value]['num']++;
				}
			}

			// Set summary data.
			if ($fields['is_numeric'])
			{
				$fields['sum'] = 0;
				$fields['max'] = max(array_keys($fields['data']));
				$fields['min'] = min(array_keys($fields['data']));
			}

			$fields['total'] = 0;
			$values_used = array();
			$values_frequent = array();
			foreach ($fields['data'] as $value => $value_data)
			{
				if (empty($value_data['num']))
					continue;

				$fields['total'] += $value_data['num'];
				if ($fields['is_numeric'])
					$fields['sum'] += $value * $value_data['num'];

				$values_used[$value] = $value_data['num'];

				if (!isset($values_frequent[$value_data['num']]))
					$values_frequent[$value_data['num']] = array();
				$values_frequent[$value_data['num']][] = $value;
			}
			if ($fields['is_numeric'])
				$fields['average'] = 0 != $fields['total'] ? $fields['sum'] / $fields['total'] : 0;

			foreach ($fields['data'] as $value => $value_data)
				$fields['data'][$value]['percent'] = round(0 != $fields['total'] ? ($value_data['num'] * 100) / $fields['total'] : 0, 1);

			if ($fields['is_numeric'] && !empty($values_used))
			{
				krsort($values_used);
				$fields['highest'] = key($values_used);
				end($values_used);
				$fields['lowest'] = key($values_used);
			}

			if (1 < count($values_frequent))
			{
				krsort($values_frequent);
				$fields['most_frequent'] = implode(',', current($values_frequent));
				end($values_frequent);
				$fields['least_frequent'] = implode(',', current($values_frequent));
			}

			$fields['data'] = serialize($fields['data']);

			if ($fields['is_numeric'])
			{
				$db_type_average = 'float';
				$db_type_sum = 'float';
				$db_type_max = 'float';
				$db_type_min = 'float';
			}
			else
			{
				$db_type_average = 'raw';
				$fields['average'] = 'NULL';
				$db_type_sum = 'raw';
				$fields['sum'] = 'NULL';
				$db_type_max = 'raw';
				$fields['max'] = 'NULL';
				$db_type_min = 'raw';
				$fields['min'] = 'NULL';
			}

			if ($fields['is_numeric'] && !empty($values_used))
			{
				$db_type_highest = 'float';
				$db_type_lowest = 'float';
			}
			else
			{
				$db_type_highest = 'raw';
				$fields['highest'] = 'NULL';
				$db_type_lowest = 'raw';
				$fields['lowest'] = 'NULL';
			}

			// Update or create stats.
			$request = db_query("
				SELECT ID_STATS
				FROM {$db_prefix}cffp_stats
				WHERE ID_MSG = $id_msg
					AND ID_GROUP = $id_group", __FILE__, __LINE__);
			$stats = mysql_fetch_assoc($request);
			mysql_free_result($request);
			if ($stats) // Update.
			{
				db_query("
					UPDATE {$db_prefix}cffp_stats
					SET
						data = '" . $fields['data'] . "', options_text = '" . $fields['options_text'] . "',
						is_numeric = " . $fields['is_numeric'] . ",
						average = " . $fields['average'] . ", sum = " . $fields['sum'] . ",
						max = " . $fields['max'] . ", min = " . $fields['min'] . ",
						highest = " . $fields['highest'] . ", lowest = " . $fields['lowest'] . ",
						most_frequent = '" . $fields['most_frequent'] . "', least_frequent = '" . $fields['least_frequent'] . "',
						total = " . $fields['total'] . "
					WHERE ID_STATS = " . $stats['ID_STATS'], __FILE__, __LINE__);
			}
			else // Create.
			{
				cffp_db_insert('',
					'cffp_stats',
					array(
						'ID_MSG' => 'int', 'ID_GROUP' => 'int',
						'data' => 'string', 'options_text' => 'string',
						'is_numeric' => 'int',
						'average' => $db_type_average, 'sum' => $db_type_sum,
						'max' => $db_type_max, 'min' => $db_type_min,
						'highest' => $db_type_highest, 'lowest' => $db_type_lowest,
						'most_frequent' => 'string', 'least_frequent' => 'string',
						'total' => 'int',
					),
					array(
						$id_msg, $id_group,
						$fields['data'], $fields['options_text'],
						$fields['is_numeric'],
						$fields['average'], $fields['sum'],
						$fields['max'], $fields['min'],
						$fields['highest'], $fields['lowest'],
						$fields['most_frequent'], $fields['least_frequent'],
						$fields['total'],
					)
				);
			}
		}
	}
	elseif ($group['show_stats'])
	{
		db_query("
			DELETE FROM {$db_prefix}cffp_stats
			WHERE ID_GROUP = $id_group", __FILE__, __LINE__);
	}
}

// Updates count groups of all members.
function cffpUpdateCountGroupAllMembers($id_group = 0)
{
	global $db_prefix;

	if (empty($id_group))
	{
		$request = db_query("
			SELECT DISTINCT f.ID_MEMBER, f.ID_GROUP
			FROM {$db_prefix}cffp_fields AS f
				INNER JOIN {$db_prefix}messages AS m ON (m.ID_MSG = f.ID_MSG)
				INNER JOIN {$db_prefix}cffp_settings_groups AS g ON (g.ID_GROUP = f.ID_GROUP)
			WHERE type = 'record'
				AND f.ID_MEMBER != 0
				AND icon != 'recycled'", __FILE__, __LINE__);
	}
	else
	{
		$request = db_query("
			SELECT DISTINCT f.ID_MEMBER, ID_GROUP
			FROM {$db_prefix}cffp_fields AS f
				INNER JOIN {$db_prefix}messages AS m ON (m.ID_MSG = f.ID_MSG)
			WHERE ID_GROUP = $id_group
				AND f.ID_MEMBER != 0
				AND icon != 'recycled'", __FILE__, __LINE__);
	}
	while ($row = mysql_fetch_assoc($request))
	{
		if (function_exists('apache_reset_timeout'))
			@apache_reset_timeout();

		cffpUpdateCountGroup($row['ID_MEMBER'], $row['ID_GROUP']);
	}
	mysql_free_result($request);
}

// Updates all count groups of a member.
function cffpUpdateCountGroupOfMember($id_member)
{
	global $db_prefix;

	if (empty($id_member))
		return false;

	$request = db_query("
		SELECT DISTINCT f.ID_GROUP
		FROM {$db_prefix}cffp_fields AS f
			INNER JOIN {$db_prefix}messages AS m ON (m.ID_MSG = f.ID_MSG)
			INNER JOIN {$db_prefix}cffp_settings_groups AS g ON (g.ID_GROUP = f.ID_GROUP)
		WHERE type = 'record'
			AND f.ID_MEMBER = $id_member
			AND icon != 'recycled'", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		if (function_exists('apache_reset_timeout'))
			@apache_reset_timeout();

		cffpUpdateCountGroup($id_member, $row['ID_GROUP']);
	}
	mysql_free_result($request);
}

// Updates count group of member and group.
function cffpUpdateCountGroup($id_member, $id_group, $inc = 0)
{
	global $db_prefix, $context, $sourcedir;

	if (empty($id_member) || empty($id_group) || (isset($context['cffp']['settings_groups'][$id_group]) && 'record' != $context['cffp']['settings_groups'][$id_group]['type']))
		return false;

	require_once ($sourcedir . '/Subs-Db-CustomFieldFilterPost-mysql.php');

	// Get count ID.
	$request = db_query("
		SELECT ID_COUNT
		FROM {$db_prefix}cffp_count_groups
		WHERE ID_MEMBER = $id_member
			AND ID_GROUP = $id_group", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Recount.
	if (!$row || empty($inc))
	{
		$request = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}cffp_fields AS f
				INNER JOIN {$db_prefix}messages AS m ON (m.ID_MSG = f.ID_MSG)
			WHERE f.ID_MEMBER = $id_member
				AND ID_GROUP = $id_group
				AND icon != 'recycled'", __FILE__, __LINE__);
		list ($groups) = mysql_fetch_row($request);
		mysql_free_result($request);
	}

	if ($row) // Update.
	{
		$id_count = $row['ID_COUNT'];

		if (empty($inc))
		{
			db_query("
				UPDATE {$db_prefix}cffp_count_groups
				SET groups = $groups
				WHERE ID_COUNT = $id_count", __FILE__, __LINE__);
		}
		else
		{
			db_query("
				UPDATE {$db_prefix}cffp_count_groups
				SET groups = groups + $inc
				WHERE ID_COUNT = $id_count", __FILE__, __LINE__);
		}
	}
	else // Insert recount.
	{
		cffp_db_insert('',
			'cffp_count_groups',
			array(
				'ID_MEMBER' => 'int', 'ID_GROUP' => 'int',
				'groups' => 'int',
			),
			array(
				$id_member, $id_group,
				$groups,
			)
		);
	}
}

// Gets list of moderation.
function cffpGetListModeration($start, $items_per_page, $sort)
{
	global $db_prefix, $context, $ID_MEMBER;

	if (!is_numeric($start) || empty($items_per_page) || empty($sort))
		return false;

	$request = db_query("
		SELECT DISTINCT
			t.isSticky, t.locked, t.ID_FIRST_MSG,
			cffpf." . implode(', cffpf.', $context['cffp']['list_columns']['fields']) . ",
			m.ID_TOPIC, m.subject, m.icon,
			IFNULL(mem.realName, cffpf.posterName) AS display_name,
			(IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) < m.ID_MSG) AS new
		FROM {$db_prefix}messages AS m
			INNER JOIN {$db_prefix}topics AS t ON (t.ID_TOPIC = m.ID_TOPIC)
			INNER JOIN {$db_prefix}cffp_fields AS cffpf ON (cffpf.ID_MSG = m.ID_MSG)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = cffpf.ID_MEMBER)
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = t.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)
		WHERE cffpf.ID_GROUP = " . $context['ID_GROUP'] . "
		ORDER BY $sort
		LIMIT $start, $items_per_page", __FILE__, __LINE__);
	$list = array();
	while ($row = mysql_fetch_assoc($request))
		$list[] = $row;
	mysql_free_result($request);

	return $list;
}

// Gets size of list of moderation.
function cffpGetListModerationSize()
{
	global $db_prefix, $context;

	$request = db_query("
		SELECT COUNT(DISTINCT cffpf.ID_CFFP)
		FROM {$db_prefix}messages AS m
			INNER JOIN {$db_prefix}cffp_fields AS cffpf ON (cffpf.ID_MSG = m.ID_MSG)
		WHERE cffpf.ID_GROUP = " . $context['ID_GROUP'], __FILE__, __LINE__);

	list ($size) = mysql_fetch_row($request);
	mysql_free_result($request);

	return $size;
}

// List of moderation.
function cffpModerationList()
{
	global $txt, $scripturl, $modSettings, $settings, $context;

	loadTemplate('CustomFieldFilterPost');
	loadTemplate('GenericList-CustomFieldFilterPost');

	// This comes under the umbrella of moderating posts.
	isAllowedTo('moderate_forum');

	// Set up the comforting bits...
	$context['page_title'] = $txt['cffp_moderation_area'];
	$context['page_desc'] = $txt['cffp_moderation_area_desc'];
	$context['sub_template'] = 'cffp_moderation_list';
	$context['ID_GROUP'] = isset($_GET['sa']) ? (int) $_GET['sa'] : 0;
	$context['ID_CFFP'] = isset($_GET['ID_CFFP']) ? (int) $_GET['ID_CFFP'] : 0;

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=cffpmoderation',
		'name' => $context['page_title'],
	);

	if (!empty($context['ID_GROUP']) && isset($_GET['delete']) && !empty($context['ID_CFFP']))
		cffpDeleteFields($context['ID_CFFP']);

	if (empty($context['ID_GROUP']) && !empty($context['cffp']['moderation_list']))
		$context['ID_GROUP'] = key($context['cffp']['moderation_list']);

	$links = array();
	foreach ($context['cffp']['moderation_list'] as $id_group => $label)
	{
		$links[$id_group] = array(
			'href' => $scripturl . '?action=cffpmoderation;sa=' . $id_group,
			'label' => $label,
			'selected' => $context['ID_GROUP'] == $id_group,
		);
	}

	$group = isset($context['cffp']['settings_groups'][$context['ID_GROUP']]) && $context['cffp']['settings_groups'][$context['ID_GROUP']]['moderation_list_show'] ? $context['cffp']['settings_groups'][$context['ID_GROUP']] : array();
	$cffp_moderation_settings_fields = !empty($group) ? $group['settings_fields'] : '';

	if (!empty($group))
	{
		$show_moderation_list = array();
		$column_list = array();
		foreach ($group['settings_fields'] as $id_field => $settings_field)
		{
			if ('no' == $settings_field['show_moderation_list_type'])
				continue;

			$settings_field2 = array(
				'ID_FIELD' => $settings_field['ID_FIELD'],
				'id_column' => $settings_field['id_column'],
				'show_moderation_list_type' => $settings_field['show_moderation_list_type'],
				'show_moderation_list_width' => $settings_field['show_moderation_list_width'],
				'show_moderation_list_name' => $settings_field['show_moderation_list_name'],
			);
			if ('multi' == $settings_field['show_moderation_list_type'])
			{
				$column = (!empty($settings_field['show_moderation_list_width']) ? $settings_field['show_moderation_list_width'] : 'auto') . ',' . $settings_field['show_moderation_list_name'];
				if (!isset($column_list[$column]))
				{
					$column_list[$column] = 'column_' . $settings_field['id_column'];
					$show_moderation_list[$column_list[$column]] = array($settings_field2, array());
				}
				$show_moderation_list[$column_list[$column]][1][] = $settings_field['ID_FIELD'];
			}
			else // one.
				$show_moderation_list[$settings_field['ID_FIELD']] = $settings_field2;
		}
	}
	$text_align = array(
		'text' => 'left',
		'text_email' => 'center',
		'text_number' => 'right',
		'textarea' => 'left',
		'select' => 'center',
		'select_multiple' => 'left',
		'combobox' => 'center',
		'combobox_multiple' => 'left',
		'radio' => 'center',
		'check' => 'left',
		'boolean' => 'center',
	);

	$base_href = $scripturl . '?action=cffpmoderation;sa=' . $context['ID_GROUP'];

	$get_count = !empty($context['ID_GROUP']) ? cffpGetListModerationSize() : 0;
	$items_per_page = $modSettings['defaultMaxMessages'];

	$headers = array();
	$headers['sticky_locked'] = array(
		'style' => 'width: 4%;',
	);
	$headers['icon'] = array(
		'style' => 'width: 4%;',
	);
	$headers['m.subject'] = array(
		'label' => $txt[72],
		'sort' => array(
			'default' => 'm.subject',
			'reverse' => 'm.subject DESC',
		),
	);
	if (!empty($group))
	{
		foreach ($show_moderation_list as $column => $show_moderation_list2)
		{
			if (is_numeric($column))
			{
				$id_field = $column;
				$column_data = $show_moderation_list2;

				if (!isset($cffp_moderation_settings_fields[$id_field]))
					$cffp_moderation_settings_fields[$id_field] = $context['cffp']['settings_groups'][$context['ID_GROUP']]['settings_fields'][$id_field];
				$name_field = 'column_' . $cffp_moderation_settings_fields[$id_field]['id_column'];

				$headers['cffpf.' . $name_field] = array(
					'label' => $cffp_moderation_settings_fields[$id_field]['name'],
					'style' => !empty($column_data['show_moderation_list_width']) ? ('width: ' . $column_data['show_moderation_list_width'] . ';') : '',
					'sort' => array(
						'default' => 'cffpf.' . $name_field,
						'reverse' => 'cffpf.' . $name_field . ' DESC',
					),
				);
			}
			else
			{
				$name_field = $column;
				$column_data = $show_moderation_list2[0];
				foreach ($show_moderation_list2[1] as $id_field)
				{
					if (!isset($cffp_moderation_settings_fields[$id_field]))
						$cffp_moderation_settings_fields[$id_field] = $context['cffp']['settings_groups'][$context['ID_GROUP']]['settings_fields'][$id_field];
				}

				$headers['cffpf.' . $name_field] = array(
					'label' => $column_data['show_moderation_list_name'],
					'style' => !empty($column_data['show_moderation_list_width']) ? ('width: ' . $column_data['show_moderation_list_width'] . ';') : '',
					'sort' => array(
						'default' => 'cffpf.' . $name_field,
						'reverse' => 'cffpf.' . $name_field . ' DESC',
					),
				);
			}
		}
	}
	$headers['cffpf.posterTime'] = array(
		'label' => $txt['cffp_poster_time'],
		'style' => 'width: 10%;',
		'sort' => array(
			'default' => 'cffpf.posterTime',
			'reverse' => 'cffpf.posterTime DESC',
		),
	);
	$headers['display_name'] = array(
		'label' => $txt[279],
		'style' => 'width: 10%;',
		'sort' => array(
			'default' => 'display_name',
			'reverse' => 'display_name DESC',
		),
	);
	$headers['option_delete'] = array(
		'style' => 'width: 10%;',
	);

	$moderation_list_order_by = !empty($group['moderation_list_order_by']) ? $group['moderation_list_order_by'] : 'cffpf.posterTime desc';
	list ($default_sort_col, $default_sort_dir) = explode(' ', $moderation_list_order_by);
	if (!isset($header[$default_sort_col]))
		$default_sort_col = 'cffpf.posterTime';

	if (isset($_REQUEST['sort']))
	{
		$sort = isset($headers[$_REQUEST['sort']]) && isset($headers[$_REQUEST['sort']]['sort']) ? $_REQUEST['sort'] : $default_sort_col;
		$desc = isset($_REQUEST['desc']);
	}
	else
	{
		$sort = $default_sort_col;
		$desc = 'desc' == $default_sort_dir;
	}
	$sort_order = $headers[$sort]['sort'][$desc ? 'reverse' : 'default'];
	$page_index = constructPageIndex($base_href . ';sort=' . $sort . ($desc ? ';desc' : ''), $_REQUEST['start'], $get_count, $items_per_page);
	$start = $_REQUEST['start'];
	$params_url = ';start=' . $start . ';sort=' . $sort . ($desc ? ';desc' : '');

	foreach ($headers as $col => $col_header)
	{
		if (isset($headers[$col]['sort']))
		{
			$headers[$col]['href'] = $base_href . ';sort=' . $col;
			if (!isset($_REQUEST['desc']) && $col == $sort)
				$headers[$col]['href'] .= ';desc';
			if ($col == $sort)
				$headers[$col]['sort_image'] = !isset($_REQUEST['desc']) ? 'down' : 'up';
			$headers[$col]['selected'] = $col == $sort;
		}
	}
	$num_columns = count($headers);

	$list = cffpGetListModeration($start, $items_per_page, $sort_order);
	$rows = array();
	foreach ($list as $rowData)
	{
		$row = array();

		$text = '';
		if ($rowData['isSticky'])
			$text .= '<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" alt="' . $txt['cffp_show_filters_sticky'] . '" />';
		if ($rowData['locked'])
			$text .= '<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" alt="' . $txt['cffp_show_filters_locked'] . '" />';
		$row['sticky_locked'] = array(
			'value' => $text,
			'style' => 'text-align: center;',
		);

		// We need to check the topic icons exist...
		if (empty($modSettings['messageIconChecks_disable']))
		{
			if (!isset($context['icon_sources'][$rowData['icon']]))
				$context['icon_sources'][$rowData['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $rowData['icon'] . '.gif') ? 'images_url' : 'default_images_url';
		}
		else
		{
			if (!isset($context['icon_sources'][$rowData['icon']]))
				$context['icon_sources'][$rowData['icon']] = 'images_url';
		}
		$row['icon'] = array(
			'value' => '<img src="' . $settings[$context['icon_sources'][$rowData['icon']]] . '/post/' . $rowData['icon'] . '.gif" alt="" />',
			'style' => 'text-align: center;',
		);

		$href = $scripturl . '?topic=' . $rowData['ID_TOPIC'] . '.msg' . $rowData['ID_MSG'];
		$text = '';
		if ($rowData['new'] && $context['user']['is_logged'])
			$text .= '
				<a href="' . $href . '#new" id="newicon' . $rowData['ID_MSG'] . '"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt[302] . '" /></a>';
		$row['m.subject'] = array(
			'value' => '<a href="' . $href . '#msg' . $rowData['ID_MSG'] . '">' . $rowData['subject'] . '</a>' . $text,
		);

		if (!empty($group))
		{
			foreach ($show_moderation_list as $column => $show_moderation_list2)
			{
				if (is_numeric($column))
				{
					$id_field = $column;

					$name_field = 'column_' . $cffp_moderation_settings_fields[$id_field]['id_column'];

					$type_align = $cffp_moderation_settings_fields[$id_field]['type'];
					switch ($cffp_moderation_settings_fields[$id_field]['type'])
					{
						case 'text':
						{
							if (in_array($cffp_moderation_settings_fields[$id_field]['mask'], array('email', 'number')))
								$type_align .= '_' . $cffp_moderation_settings_fields[$id_field]['mask'];
							break;
						}
						case 'select':
						case 'combobox':
						{
							$options = explode(',', $cffp_moderation_settings_fields[$id_field]['options']);
							$select_multiple = array_shift($options);
							if ($select_multiple)
								$type_align .= '_multiple';
							break;
						}
					}

					$row['cffpf.' . $name_field] = array(
						'value' => cffpHtmlOfField($cffp_moderation_settings_fields[$id_field], $rowData[$name_field], true, $rowData['ID_MSG']),
						'style' => 'text-align: ' . (!empty($text_align[$type_align]) ? $text_align[$type_align] : 'center') . ';',
					);
				}
				else
				{
					$name_field = $column;
					$text = '';
					foreach ($show_moderation_list2[1] as $id_field)
					{
						$name_field2 = 'column_' . $cffp_moderation_settings_fields[$id_field]['id_column'];

						$text2 = cffpHtmlOfField($cffp_moderation_settings_fields[$id_field], $rowData[$name_field2], true, $rowData['ID_MSG']);
						if (cffpIsNotEmptyString($text2))
						{
							if (cffpIsNotEmptyString($text))
								$text .= '<br />';
							$text .= $text2;
						}
					}

					$row['cffpf.' . $name_field] = array(
						'value' => $text,
						'style' => 'text-align: left;',
					);
				}
			}
		}

		$row['cffpf.posterTime'] = array(
			'value' => timeformat($rowData['posterTime']),
			'style' => 'text-align: center;',
		);
		$row['display_name'] = array(
			'value' => !empty($rowData['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $rowData['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $rowData['display_name'] . '">' . $rowData['display_name'] . '</a>' : $rowData['display_name'],
		);
		$row['option_delete'] = array(
			'value' => '<a href="' . $scripturl . '?action=cffpmoderation;sa=' . $context['ID_GROUP'] . ';delete=1;ID_CFFP=' . $rowData['ID_CFFP'] . $params_url . ';sesc=' . $context['session_id'] . '" onclick="return confirm(\'' . addslashes($txt['cffp_moderation_area_delete_sure']) . '\');">' . $txt['smf138'] . '</a>',
			'style' => 'text-align: center;',
		);

		$rows[] = $row;
	}

	$context['cffp_moderation_list'] = array(
		'list_menu' => array(
			'columns' => count($links),
			'show_on' => 'top',
			'links' => $links,
		),
		'no_items_label' => $txt['cffp_moderation_area_none'],
		'items_per_page' => $items_per_page,
		'page_index' => $page_index,
		'num_columns' => $num_columns,
		'headers' => $headers,
		'rows' => $rows,
	);
}

?>